/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is an optimized version of Dojo, built for deployment and not for
	development. To get sources and documentation, please visit:

		http://dojotoolkit.org
*/

require({cache:{
'ibm_ilog*graphlayout/forcedirected/ULEAlgorithm':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/basic/BasicLinkStyleLayout","ibm_ilog/graphlayout/forcedirected/FMMAlgorithm","ibm_ilog/graphlayout/forcedirected/ForceDirectedLayout","ibm_ilog/graphlayout/hierarchical/HierarchicalLayout","ibm_ilog/graphlayout/internalutil/GraphModelUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/GraphLayoutData","ibm_ilog/graphlayout/internalutil/LayoutUtil","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/internalutil/Point","ibm_ilog/graphlayout/internalutil/RandomUtil","ibm_ilog/graphlayout/internalutil/ReshapeLinkUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/tree/TreeLayout","ibm_ilog/graphlayout/GraphLayoutReport"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected.ULEAlgorithm", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.forcedirected.ULEAlgorithm');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.basic.BasicLinkStyleLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphLayoutData');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.Point');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.RandomUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.ReshapeLinkUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.tree.TreeLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayoutReport');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.forcedirected.ULEAlgorithm', null, 
{
  // summary:
  //		This class is the main internal class for the Uniform Length Edges
  //		(ULE) layout algorithm. 
  // description:
  //		This class is the main internal class for the Uniform Length Edges
  //		(ULE) layout algorithm. 
  //		
  // tags:
  //		private
  
  _graphModel: null,
  _layoutReport: null,
  _layoutData: null,
  _topologicalData: null,
  _positionData: null,

  _vectNodesDx: null,
  _vectNodesDy: null,
  _vectFromId: null,
  _vectToId: null,
  _vectWishedLength: null,
  _vectHalfNodeDiag: null,
  _hasConverged : null,
  _nodesAlreadyPlaced : null,
  _maxMovement : null,
  _xyValues : null,
  _phaseStartTime: null,
  _duringLayoutExecution : null,
  _preprocessingMode : null,

  _ule: null,

  _treeLayout: null,

  _hierarchicalLayout: null,
  _fmmAlgo: null,

  constructor : function(layout)
  {
    // summary:
    //		The instance of Hierarchical layout optionally used as auxiliary
    //		layout.
    
    this._hasConverged = false;
    this._nodesAlreadyPlaced = false;
    this._maxMovement = 0;
    this._xyValues = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(2, 0);
    this._duringLayoutExecution = false;
    this._preprocessingMode = ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.RADIAL_TREE_PREPROCESSING;
    this._ule = layout;
  },
  
  getOriginalUle : function()
  {
    return this._ule; // ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout
  },

  detach : function()
  {
    if (this._duringLayoutExecution) {
      return;
    }
    this._vectNodesDx = null;
    this._vectNodesDy = null;
    this._vectFromId = null;
    this._vectToId = null;
    this._vectWishedLength = null;
    this._vectHalfNodeDiag = null;
    this._layoutData = null;
    this._topologicalData = null;
    this._positionData = null;
    if (this._treeLayout != null) {
      this._treeLayout.detach();
    }
    if (this._hierarchicalLayout != null) {
      this._hierarchicalLayout.detach();
    }
    if (this._fmmAlgo != null) {
      this._fmmAlgo.detach();
    }
  },

  layout : function(redraw)
  {
    this._duringLayoutExecution = true;
    this.init();

    try
    {
      if (this._ule.getLayoutMode() == ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.FAST_MULTILEVEL_MODE)
      {
        if (this._fmmAlgo == null) {
          this._fmmAlgo = new ibm_ilog.graphlayout.forcedirected.FMMAlgorithm(this._ule);
        }
        this._fmmAlgo.doLayout(this._graphModel, redraw);
      }
      else
      {
        this.doLayout(redraw);
      }
    }
    finally
    {
      this._layoutData = null;
      this._topologicalData = null;
      this._positionData = null;
      this._duringLayoutExecution = false;
      this.clean();
    }
  },

  init : function()
  {
    // summary:
    // tags:
    //		protected
    
    this._graphModel = this._ule.getGraphModel();
    this._layoutReport = this._ule.getLayoutReport();
    this._layoutData = new ibm_ilog.graphlayout.internalutil.GraphLayoutData(this._ule, null);

    this._layoutData.beforeLayout(false, false, false, false);
    this._topologicalData = this._layoutData.getTopologicalData();
    this._positionData = this._layoutData.getPositionData();

    this.initializeDataStructures();

    if (this._topologicalData == null || this._positionData == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6766E");
    }

    if (this._topologicalData.isNoMoveableNode())
    {
      this._layoutReport.setCode(ibm_ilog.graphlayout.GraphLayoutReport.LAYOUT_DONE);
      return;
    }

    if (this._topologicalData.getNumberOfLinks() < 1)
    {
      this._layoutReport.setCode(ibm_ilog.graphlayout.GraphLayoutReport.LAYOUT_DONE);
      return;
    }

    if (this._topologicalData == null || this._positionData == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6766E");
    }
  },

  clean : function()
  {
  },

  doLayout : function(redraw)
  {
    // summary:
    //		Executes the layout.
    // tags:
    //		protected
    
    if (this._topologicalData.getNumberOfNodes() < 2 || this._topologicalData.getNumberOfLinks() < 1)
    {
      this.doAfterLayout(1, true, redraw);
      return;
    }

    var rect = null;
    var fitToLayoutRegion = this._ule.isForceFitToLayoutRegion();

    if (fitToLayoutRegion)
    {
      rect = this._topologicalData.getModifiedLayoutRegion(this._ule.getCalcLayoutRegion());
    }

    if (this._ule.getLinkStyle() == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.STRAIGHT_LINE_STYLE) {
      ibm_ilog.graphlayout.internalutil.GraphModelUtil.deleteIntermediatePointsOnLinks(this._graphModel, this._ule);
    }
    this.computeFromToIds();

    var centerPoint = this.getCenterPoint(rect);
    var incrementalMode = this._ule.getLayoutMode() == ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.INCREMENTAL_MODE;

    var random = new ibm_ilog.graphlayout.internalutil.RandomUtil(0);

    var globalAdditionalNodeRepulsionWeight = this._ule.getAdditionalNodeRepulsionWeight();
    var globalAllowedNumberOfIterations = this._ule.getAllowedNumberOfIterations();
    var globalAllowedTime = this._ule.getAllowedTime();
    var globalMinNodeDist = this._ule.getNodeDistanceThreshold();
    var globalMaxMovePerIter = this._ule.getMaxAllowedMovePerIteration();
    var globalRespectNodeSize = this._ule.isRespectNodeSizes();
    var globalWishedLength = this._ule.getPreferredLinksLength();
    var maxMovePerIter;
    var minNodeDist;
    var allowedTime;
    var allowedNumberOfIterations;
    var respectNodeSizes = false;
    var additionalNodeRepulsionWeight;
    var wishedLinkLength;
    var totalNumberOfIterations = 0;
    this.initBeforeIterations();

    if (!incrementalMode)
    {
      var preprocessingMode = this.getPreprocessingMode();

      switch (preprocessingMode)
      {
        case ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.RADIAL_TREE_PREPROCESSING:
          this.doTreeLayout(this._graphModel, this._ule.getRemainingAllowedTime());
          break;
        case ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.HIERARCHICAL_PREPROCESSING:
          this.doHierarchicalLayout(this._graphModel, this._ule.getRemainingAllowedTime());
          break;
      }
      if (preprocessingMode != ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.NO_PREPROCESSING) {
        this._positionData.updateNodePositions();
      }
      allowedNumberOfIterations = Math.floor((globalAllowedNumberOfIterations * ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.PHASE_ONE_PERCENTAGE_NON_INCREM));
      allowedTime = (globalAllowedTime * ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.PHASE_ONE_PERCENTAGE_NON_INCREM);
      respectNodeSizes = false;
      minNodeDist = globalMinNodeDist;

      wishedLinkLength = globalWishedLength;
      maxMovePerIter = this.computeMaxMoveForFirstPhase(this._graphModel, globalMaxMovePerIter);
      additionalNodeRepulsionWeight = 0;
      this.computeWishedLength(wishedLinkLength, respectNodeSizes);
      totalNumberOfIterations +=
        this.doIterations(allowedNumberOfIterations, allowedTime, maxMovePerIter, rect, centerPoint, fitToLayoutRegion, minNodeDist, additionalNodeRepulsionWeight, wishedLinkLength, respectNodeSizes,
            random, redraw);
    }

    var phaseTwoPercentage = 0;

    if (incrementalMode)
    {
      phaseTwoPercentage = (globalAdditionalNodeRepulsionWeight > 0 ? ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.PHASE_TWO_PERCENTAGE_INCREM : 1);
    }
    else
    {
      phaseTwoPercentage =
        (globalAdditionalNodeRepulsionWeight > 0
          ? ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.PHASE_TWO_PERCENTAGE_NON_INCREM
          : (ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.PHASE_TWO_PERCENTAGE_NON_INCREM + ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.PHASE_THREE_PERCENTAGE_NON_INCREM));
    }

    allowedNumberOfIterations = Math.floor((globalAllowedNumberOfIterations * phaseTwoPercentage));
    allowedTime = (globalAllowedTime * phaseTwoPercentage);
    wishedLinkLength = globalWishedLength;

    maxMovePerIter = globalMaxMovePerIter;
    additionalNodeRepulsionWeight = 0;
    respectNodeSizes = globalRespectNodeSize;
    minNodeDist = globalMinNodeDist;
    this.computeWishedLength(wishedLinkLength, respectNodeSizes);
    totalNumberOfIterations +=
      this.doIterations(allowedNumberOfIterations, allowedTime, maxMovePerIter, rect, centerPoint, fitToLayoutRegion, minNodeDist, additionalNodeRepulsionWeight, globalWishedLength, respectNodeSizes,
          random, redraw);

    if (globalAdditionalNodeRepulsionWeight > 0)
    {
      var phaseThreePercentage = (incrementalMode
        ? ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.PHASE_THREE_PERCENTAGE_INCREM
        : ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.PHASE_THREE_PERCENTAGE_NON_INCREM);
      allowedNumberOfIterations = Math.floor((globalAllowedNumberOfIterations * phaseThreePercentage));
      allowedTime = (globalAllowedTime * phaseThreePercentage);
      wishedLinkLength = globalWishedLength;
      maxMovePerIter = globalMaxMovePerIter;
      additionalNodeRepulsionWeight = globalAdditionalNodeRepulsionWeight;
      respectNodeSizes = globalRespectNodeSize;
      minNodeDist = globalMinNodeDist;
      this.computeWishedLength(wishedLinkLength, respectNodeSizes);
      totalNumberOfIterations +=
        this.doIterations(allowedNumberOfIterations, allowedTime, maxMovePerIter, rect, centerPoint, fitToLayoutRegion, minNodeDist, additionalNodeRepulsionWeight, globalWishedLength, 
                respectNodeSizes, random, redraw);
    }

    if (!this._nodesAlreadyPlaced) {
      if (!this._positionData.placeNodesAtPosition(redraw, centerPoint))
      {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6767E");
      }
    }
    this.doAfterLayout(totalNumberOfIterations, this._hasConverged, redraw);
  },

  setPreprocessingMode : function(mode)
  {
    this._preprocessingMode = mode;
  },

  getPreprocessingMode : function()
  {
    return this._preprocessingMode; // int
  },

  getCenterPoint : function(rect)
  {
    var centerPoint = null;

    if (this._positionData.getNumberOfFixedNodes() == 0)
    {
      centerPoint = (rect != null ? new ibm_ilog.graphlayout.internalutil.Point(rect.x + rect.width * 0.5, rect.y + rect.height * 0.5) : this._positionData.getNodesBarycenter());
    }

    return centerPoint; // Point
  },

  doAfterLayout : function(totalNumberOfIterations, hasConverged, redraw)
  {
    if (hasConverged) {
      this._layoutReport.setCode(ibm_ilog.graphlayout.GraphLayoutReport.LAYOUT_DONE);
    }
    else {
      this._layoutReport.setCode(ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_VALID);
    }
    this._layoutReport.setNumberOfIterations(totalNumberOfIterations);
  },

  computeMaxMoveForFirstPhase : function(graphModel, globalMaxMovePerIter)
  {
    var bbox = this._positionData.getNodesBoundingBox();
    var diag1 = Math.sqrt(bbox.width * bbox.width + bbox.height + bbox.height);
    bbox = ibm_ilog.graphlayout.internalutil.LayoutUtil.getEstimatedLayoutRegion(null, graphModel);
    var diag2 = Math.sqrt(bbox.width * bbox.width + bbox.height + bbox.height);

    var maxMove = 0.5 * Math.max(diag1, diag2);

    if (maxMove < globalMaxMovePerIter) {
      maxMove = globalMaxMovePerIter;
    }
    if (maxMove > 6 * globalMaxMovePerIter) {
      maxMove = 6 * globalMaxMovePerIter;
    }
    return maxMove; // Number
  },

  initBeforeIterations : function()
  {
    this._maxMovement = 0;
    this._nodesAlreadyPlaced = false;
    this._hasConverged = false;
  },

  doIterations : function(allowedNumberOfIter, allowedTime, maxAllowedMovePerIter, rect, centerPoint, fitToLayoutRegion, minNodeDist, additionalNodeRepulsionWeight, globalWishedLength,
    respectNodeSizes, random, redraw)
  {
    this._phaseStartTime = new Date().getTime();

    var animate = false;
    var convergenceThreshold = this._ule.getConvergenceThreshold();
    var bigConvergenceThreshold = 2 * convergenceThreshold;
    var linkLengthWeight = this._ule.getLinkLengthWeight();
    var convergedCount = 0;
    var convergedBigCount = 0;
    var numberOfIterations = 0;

    while (this.mayContinuePhase(numberOfIterations, allowedNumberOfIter, allowedTime))
    {
      this._positionData.resetMaxMovementCounter();

      this.performOneIteration(rect, minNodeDist, fitToLayoutRegion, maxAllowedMovePerIter, linkLengthWeight, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random);
      this._nodesAlreadyPlaced = false;
      this._maxMovement = this._positionData.getMaxMovement();

      if (animate && this._maxMovement > convergenceThreshold && numberOfIterations % ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.ANIMATION_REDRAW_RATE == 0)
      {
        if (!this._positionData.placeNodesAtPositionInAnimation(redraw, centerPoint))
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6767E");
        }

        this._nodesAlreadyPlaced = true;
      }

      this._layoutReport.setNumberOfIterations(numberOfIterations + 1);
      this._layoutReport.setMaxMovePerIteration(this._maxMovement);
      this._ule.callLayoutStepPerformedIfNeeded();
      numberOfIterations++;

      if (this._maxMovement <= convergenceThreshold)
      {
        if (convergedCount > ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.ITER_SMALL_EPSILON)
        {
          this._hasConverged = true;

          break;
        }
        else {
          convergedCount++;
        }
      }
      else {
        convergedCount = 0;
      }
      if (this._maxMovement <= bigConvergenceThreshold)
      {
        if (convergedBigCount > ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.ITER_BIG_EPSILON)
        {
          this._hasConverged = true;

          break;
        }
        else {
          convergedBigCount++;
        }
      }
      else {
        convergedBigCount = 0;
      }
    }

    return numberOfIterations; // int
  },

  performOneIteration : function(rect, minNodeDist, fitToLayoutRegion, maxAllowedMove, linkLengthWeight, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random)
  {
    this.computeLinkForces(linkLengthWeight, convergenceThreshold, random);
    this.computeNodeForces(minNodeDist, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random);
    this.applyNodeDeplacement(rect, fitToLayoutRegion, maxAllowedMove, convergenceThreshold, random);
  },

  initializeDataStructures : function()
  {
    // summary:
    //		Applies a random perturbation which should help to escape from local
    //		minimum.
    // tags:
    //		protected
    
    if (this._positionData == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6768E");
    }

    if (!this._positionData.identifyFixedAndMoveableNodes(false, true))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6768E");
    }

    var nNodes = this._topologicalData.getNumberOfNodes();
    var nLinks = this._topologicalData.getNumberOfLinks();

    if (this._vectNodesDx == null || nNodes != this._vectNodesDx.length)
    {
      this._vectNodesDx = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, 0);
      this._vectNodesDy = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, 0);
    }
    else
    {
      for (var i = 0; i < nNodes; i++)
      {
        this._vectNodesDx[i] = 0;
        this._vectNodesDy[i] = 0;
      }
    }

    if (this._vectFromId == null || nLinks != this._vectFromId.length)
    {
      this._vectFromId = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nLinks, 0);
      this._vectToId = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nLinks, 0);
    }

    if (this._vectWishedLength == null || nLinks != this._vectWishedLength.length) {
      this._vectWishedLength = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nLinks, 0);
    }
    if (this._ule.isRespectNodeSizes())
    {
      if (this._vectHalfNodeDiag == null || nNodes != this._vectHalfNodeDiag.length) {
        this._vectHalfNodeDiag = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, 0);
      }
    }
  },

  computeLinkForces : function(linkLengthWeight, convergenceThreshold, random)
  {
    // summary:
    //		Computes the displacement that depends on the relative position of
    //		the end-nodes of the links.
    // tags:
    //		private
    
    if (linkLengthWeight == 0) {
      return;
    }
    linkLengthWeight /= 3;
    var nLinks = this._topologicalData.getNumberOfLinks();
    var vx = 0;
    var vy = 0;
    var len = 0;
    var linkId;
    var fromId;
    var toId;
    var f;
    var dx;
    var dy;
    var avx;
    var avy;
    var randomValueRange = convergenceThreshold * 2;
    var vectNodesPositionX = this._positionData.getVectNodesPositionX();
    var vectNodesPositionY = this._positionData.getVectNodesPositionY();

    for (linkId = 0; linkId < nLinks; linkId++)
    {
      fromId = this._vectFromId[linkId];
      toId = this._vectToId[linkId];

      if (toId == fromId) {
        continue;
      }
      vx = vectNodesPositionX[toId] - vectNodesPositionX[fromId];
      vy = vectNodesPositionY[toId] - vectNodesPositionY[fromId];
      avx = vx;
      avy = vy;
      if (avx < 0) {
        avx = -avx;
      }
      if (avy < 0) {
        avy = -avy;
      }
      if (avx < ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT && avy < ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
      {
        vx = this.getRandomValue(randomValueRange, random);
        vy = this.getRandomValue(randomValueRange, random);
      }

      len = Math.sqrt(vx * vx + vy * vy);
      len = ((len == 0) ? 0.0001 : len);
      f = (linkLengthWeight * (this._vectWishedLength[linkId] - len) / len);
      dx = f * vx;
      dy = f * vy;
      this._vectNodesDx[toId] += dx;
      this._vectNodesDy[toId] += dy;
      this._vectNodesDx[fromId] -= dx;
      this._vectNodesDy[fromId] -= dy;
    }
  },

  computeWishedLength : function(globalPrefLength, respectNodeSizes)
  {
    if (respectNodeSizes)
    {
      var nNodes = this._topologicalData.getNumberOfNodes();

      if (this._vectHalfNodeDiag == null || this._vectHalfNodeDiag.length != nNodes)
      {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6769E");
      }

      this.computeNodeHalfDiagonals(this._vectHalfNodeDiag, nNodes);
    }

    var nLinks = this._topologicalData.getNumberOfLinks();
    var linkId;
    var link;
    var fromId;
    var toId;
    var maxLength = 0;
    var length;

    for (linkId = 0; linkId < nLinks; linkId++)
    {
      link = this._topologicalData.getLink(linkId);
      fromId = this._vectFromId[linkId];

      toId = this._vectToId[linkId];

      if (fromId != toId)
      {
        length = this._ule.getPreferredLength(link);
        this._vectWishedLength[linkId] = (length >= 0 ? length : globalPrefLength);
        if (respectNodeSizes) {
          this._vectWishedLength[linkId] += (this._vectHalfNodeDiag[fromId] + this._vectHalfNodeDiag[toId]);
        }
        if (this._vectWishedLength[linkId] > maxLength) {
          maxLength = this._vectWishedLength[linkId];
        }
      }
    }

    this._ule.callLayoutStepPerformedIfNeeded();
    return maxLength; // Number
  },

  computeFromToIds : function()
  {
    // summary:
    //		Computes and stores the id of the from and to node of each link.
    // tags:
    //		private
    
    var link;
    var nLinks = this._topologicalData.getNumberOfLinks();

    for (var linkId = 0; linkId < nLinks; linkId++)
    {
      link = this._topologicalData.getLink(linkId);
      this._vectFromId[linkId] = this._layoutData.getIntIdentifier(this._graphModel.getFrom(link));
      this._vectToId[linkId] = this._layoutData.getIntIdentifier(this._graphModel.getTo(link));
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  },

  computeNodeHalfDiagonals : function(vectHalfNodeDiag, nNodes)
  {
    // summary:
    //		Computes and stores the half diagonals for each node.
    // tags:
    //		private
    
    var max = -1;
    var halfDiag;

    for (var nodeId = 0; nodeId < nNodes; nodeId++)
    {
      halfDiag = 0.5 * ibm_ilog.graphlayout.internalutil.LayoutUtil.getDiagonal(this._topologicalData.getNode(nodeId), this._graphModel);
      if (halfDiag > max) {
        max = halfDiag;
      }
      vectHalfNodeDiag[nodeId] = halfDiag;
    }
  },

  computeNodeForces : function(minNodeDist, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random)
  {
    var vx = 0;
    var vy = 0;
    var dx = 0;
    var dy = 0;
    var dx1 = 0;
    var dy1 = 0;
    var f;
    var len;
    var sqrtLen;
    var minDistWeight = additionalNodeRepulsionWeight / 3;
    var desiredMinDist = minNodeDist;
    var randomValueRange = convergenceThreshold * 2;
    var nNodes = this._topologicalData.getNumberOfNodes();
    var vectNodesPositionX = this._positionData.getVectNodesPositionX();
    var vectNodesPositionY = this._positionData.getVectNodesPositionY();

    for (var nodeId1 = 0; nodeId1 < nNodes; nodeId1++)
    {
      dx = 0;
      dy = 0;

      for (var nodeId2 = 0; nodeId2 < nNodes; nodeId2++)
      {
        if (nodeId1 == nodeId2) {
          continue;
        }
        vx = vectNodesPositionX[nodeId1] - vectNodesPositionX[nodeId2];
        vy = vectNodesPositionY[nodeId1] - vectNodesPositionY[nodeId2];
        len = vx * vx + vy * vy;

        if (minDistWeight > 0)
        {
          sqrtLen = Math.sqrt(len);
          sqrtLen = ((sqrtLen == 0) ? 0.0001 : sqrtLen);
          if (respectNodeSizes) {
            desiredMinDist = minNodeDist + this._vectHalfNodeDiag[nodeId1] + this._vectHalfNodeDiag[nodeId2];
          }
          if (sqrtLen < desiredMinDist)
          {
            f = (minDistWeight * ((desiredMinDist - sqrtLen) / sqrtLen));
            dx1 = f * vx;
            dy1 = f * vy;
            this._vectNodesDx[nodeId1] += dx1;
            this._vectNodesDy[nodeId1] += dy1;
            this._vectNodesDx[nodeId2] -= dx1;
            this._vectNodesDy[nodeId2] -= dy1;
          }
        }

        if (len <= ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
        {
          dx += this.getRandomValue(randomValueRange, random);
          dy += this.getRandomValue(randomValueRange, random);
          dx += vx / 3;
          dy += vy / 3;
        }
        else
        {
          dx += vx / len;
          dy += vy / len;
        }
      }

      var dlen = dx * dx + dy * dy;

      if (dlen <= ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
      {
        if (this._vectNodesDx == null)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6770E");
        }

        this._vectNodesDx[nodeId1] += this.getRandomValue(randomValueRange, random);
        this._vectNodesDy[nodeId1] += this.getRandomValue(randomValueRange, random);
      }
      else
      {
        dlen = Math.sqrt(dlen) / 2;

        if (dlen > ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
        {
          this._vectNodesDx[nodeId1] += dx / dlen;
          this._vectNodesDy[nodeId1] += dy / dlen;
        }
      }
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  },

  applyNodeDeplacement : function(rect, fitToLayoutRegion, maxAllowedMove, convergenceThreshold, random)
  {
    var dx;
    var dy;
    var newx;
    var newy;
    var nNodes = this._topologicalData.getNumberOfNodes();
    var preserveFixedNodes = this._ule.isPreserveFixedNodes();
    var allForcesColinear = this.allForcesColinear();
    var randomValueRange = convergenceThreshold * 2;

    for (var nodeId = 0; nodeId < nNodes; nodeId++)
    {
      if (!(preserveFixedNodes && this._positionData.hasBeenIdentifiedAsFixed(nodeId)))
      {
        this._xyValues[0] = this._vectNodesDx[nodeId];
        this._xyValues[1] = this._vectNodesDy[nodeId];

        if (allForcesColinear)
        {
          this._xyValues[0] += this.getRandomValue(randomValueRange, random);
          this._xyValues[1] += this.getRandomValue(randomValueRange, random);
        }

        ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.boundedValues(this._xyValues, maxAllowedMove);
        dx = this._xyValues[0];
        dy = this._xyValues[1];
        newx = this._positionData.getXofNode(nodeId) + dx;
        newy = this._positionData.getYofNode(nodeId) + dy;

        if (fitToLayoutRegion)
        {
          if (newx < rect.x) {
            newx = rect.x;
          }
          else if (newx > (rect.x + rect.width)) {
            newx = rect.x + rect.width;
          }
          if (newy < rect.y) {
            newy = rect.y;
          }
          else if (newy > (rect.y + rect.height)) {
            newy = rect.y + rect.height;
          }
          this._positionData.recordMove(newx - this._positionData.getXofNode(nodeId), newy - this._positionData.getYofNode(nodeId));
        }
        else {
          this._positionData.recordMove(dx, dy);
        }
        this._positionData.setNodePosition(nodeId, newx, newy);
      }

      this._vectNodesDx[nodeId] /= 2;
      this._vectNodesDy[nodeId] /= 2;
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  },

  allForcesColinear : function()
  {
    // summary:
    //		Returns true if all forces are colinear or near colinear. 
    // description:
    //		Returns true if all forces are colinear or near colinear. 
    //		Returns false otherwise.
    // tags:
    //		private
    
    var nNodes = this._topologicalData.getNumberOfNodes();
    if (nNodes <= 2) {
      return false; // Boolean
    }
    var firstForceDirection = 0;
    var firstForceIsVertical = false;
    var firstForceIsHorizontal = false;
    var dx;
    var dy;

    for (var nodeId = 0; nodeId < nNodes; nodeId++)
    {
      dx = this._vectNodesDx[nodeId];
      dy = this._vectNodesDy[nodeId];

      if (nodeId == 0)
      {
        if (Math.abs(dx) < ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT) {
          firstForceIsVertical = true;
        }
        else if (Math.abs(dy) < ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT) {
          firstForceIsHorizontal = true;
        }
        else {
          firstForceDirection = Math.abs(dx / dy);
        }
      }
      else
      {
        if (firstForceIsVertical)
        {
          if (Math.abs(dx) >= ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT) {
            return false; // Boolean
          }
        }
        else if (firstForceIsHorizontal)
        {
          if (Math.abs(dy) >= ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT) {
            return false; // Boolean
          }
        }
        else
        {
          if (Math.abs(firstForceDirection - Math.abs(dx / dy)) >= ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT) {
            return false; // Boolean
          }
        }
      }
    }

    return true; // Boolean
  },

  getRandomValue : function(range, random)
  {
    // summary:
    //		Returns a random value in the interval [-range/2, +range/2]
    // tags:
    //		protected
    
    var value = random.nextDouble() * range - range * 0.5;
    return (Math.abs(value) < ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT ? this.getRandomValue(range, random) : value); // Number
  },

  mayContinuePhase : function(currentNumberOfIterations, allowedNumberOfIterations, allowedTime)
  {
    // summary:
    //		Returns 'true' if the current number of iterations is
    //		smaller than the allowed number of iterations and the current layout
    //		time is smaller than the allowed layout time for this phase. 
    // description:
    //		Returns <code>true</code> if the current number of iterations is
    //		smaller than the allowed number of iterations and the current layout
    //		time is smaller than the allowed layout time for this phase. 
    //		The method is automatically called after each iteration of the
    //		layout algorithm.
    // tags:
    //		private
    
    return (currentNumberOfIterations < allowedNumberOfIterations) && !this.isPhaseLayoutTimeElapsed(allowedTime) && !this._ule.isStoppedImmediately(); // Boolean
  },

  isPhaseLayoutTimeElapsed : function(allowedTime)
  {
    return (new Date().getTime() - this._phaseStartTime) > allowedTime; // Boolean
  },

  doTreeLayout : function(graphModel, allowedTime)
  {
    // summary:
    //		As a pre-processing step, executes the auxiliary tree layout.
    // tags:
    //		private
    
    if (this._treeLayout == null) {
      this.initTreeLayout();
    }
    if (this._treeLayout.getGraphModel() != graphModel)
    {
      var modelChecking = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
      this._treeLayout.attach(graphModel);

      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel,
        modelChecking);
    }

    this._treeLayout.setAllowedTime(allowedTime);
    var offset = this._ule.getPreferredLinksLength();

    this._treeLayout.setParentChildOffset(offset);
    var root = this.computeBestRootNode(graphModel);
    this._treeLayout.setRoot(root);

    try
    {
      this._treeLayout.performLayout(true);
    }
    finally
    {
      this._treeLayout.setRootPreference(root, -1);
    }

    this._treeLayout.setPreserveFixedNodes(this._ule.isPreserveFixedNodes());
  },

  initTreeLayout : function()
  {
    var ule = this._ule;
    this._treeLayout = new ULEAlgorithmAnonClass_1(ule);
    this._treeLayout.setGlobalLinkStyle(ibm_ilog.graphlayout.tree.TreeLayout.NO_RESHAPE_STYLE);

    this._treeLayout.setLayoutMode(ibm_ilog.graphlayout.tree.TreeLayout.ALTERNATING_RADIAL);

    this._treeLayout.setIncrementalMode(false);

    this._treeLayout.setFirstCircleEvenlySpacing(false);
  },

  computeBestRootNode : function(graphModel)
  {
    // summary:
    //		If no preferred root is specified, the tree layout uses a default
    //		heuristic for choosing the root node. 
    // description:
    //		If no preferred root is specified, the tree layout uses a default
    //		heuristic for choosing the root node. 
    //		This heuristic fits well non-radial layouts, but it is the somehow
    //		the opposite of what would fit nicely for radial layouts. Therefore,
    //		let's compute a root and specify it according to our needs. For now, the heuristic is very simple: the node with the highest degree. Hopefully, this is better, in general, than TreeLayout's
    //		current default heuristic. However, there are clearly cases  when
    //		this is not the optimum. It would probably be better  (but more
    //		expensive) to take the "topological center" (the node for which the
    //		sum of the topological distances to the other nodes is the highest).
    //		This might later be implemented in the tree layout itself.  Would it
    //		make sense to move the root node at some position, such as the
    //		barycenter of the existing node placement? I think it would bring
    //		nothing, since we anyway translate the graph as post-processing to
    //		preserve the initial barycenter.
    // tags:
    //		private
    
    var root = null;
    var maxDegree = -1;
    var nodes = new ibm_ilog.graphlayout.internalutil.ArrayIterator(graphModel.getNodes());

    while (nodes.hasNext())
    {
      var node = nodes.next();
      var degree = ibm_ilog.graphlayout.internalutil.GraphModelUtil.getNodeDegree(graphModel, node);

      if (degree > maxDegree)
      {
        maxDegree = degree;
        root = node;
      }
    }

    return root; // Object
  },

  doHierarchicalLayout : function(graphModel, allowedTime)
  {
    // summary:
    //		As a pre-processing step, executes the auxiliary hierarchical
    //		layout.
    // tags:
    //		private
    
    if (this._hierarchicalLayout == null) {
      this.initHierarchicalLayout();
    }
    if (this._hierarchicalLayout.getGraphModel() != graphModel)
    {
      var modelChecking = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, false);
      this._hierarchicalLayout.attach(graphModel);

      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel,
        modelChecking);
    }

    this._hierarchicalLayout.setAllowedTime(allowedTime);
    this._hierarchicalLayout.performLayout(true);
    this._hierarchicalLayout.setPreserveFixedNodes(this._ule.isPreserveFixedNodes());
  },

  initHierarchicalLayout : function()
  {
    var ule = this._ule;
    this._hierarchicalLayout = new ULEAlgorithmAnonClass_2(ule);
    this._hierarchicalLayout.setGlobalLinkStyle(ibm_ilog.graphlayout.tree.TreeLayout.NO_RESHAPE_STYLE);
    this._hierarchicalLayout.setHorizontalLinkOffset(30);
    this._hierarchicalLayout.setHorizontalNodeLinkOffset(40);
    this._hierarchicalLayout.setHorizontalNodeOffset(80);
    this._hierarchicalLayout.setVerticalLinkOffset(30);
    this._hierarchicalLayout.setVerticalNodeLinkOffset(40);
    this._hierarchicalLayout.setVerticalNodeOffset(80);
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.ULEAlgorithm,
{
  ITER_SMALL_EPSILON : null,

  ITER_BIG_EPSILON : null,

  ANIMATION_REDRAW_RATE : null,

  PHASE_TWO_PERCENTAGE_INCREM : null,
  PHASE_THREE_PERCENTAGE_INCREM : null,

  PHASE_ONE_PERCENTAGE_NON_INCREM : null,
  PHASE_TWO_PERCENTAGE_NON_INCREM : null,
  PHASE_THREE_PERCENTAGE_NON_INCREM : null,

  NO_PREPROCESSING : null,
  RADIAL_TREE_PREPROCESSING : null,

  HIERARCHICAL_PREPROCESSING : null,

  boundedValues : function(values, maxAllowedMove)
  {
    var dx = values[0];
    var dy = values[1];
    var ax = (dx < 0 ? -dx : dx);

    var ay = (dy < 0 ? -dy : dy);
    var max = (ax > ay ? ax : ay);

    if (max < ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT) {
      return;
    }
    if (max > maxAllowedMove)
    {
      if (ax >= ay)
      {
        dy = dy * maxAllowedMove / ax;
        dx = (dx >= 0 ? maxAllowedMove : -maxAllowedMove);
      }
      else
      {
        dx = dx * maxAllowedMove / ay;
        dy = (dy >= 0 ? maxAllowedMove : -maxAllowedMove);
      }
    }

    values[0] = dx;
    values[1] = dy;
  },

  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.forcedirected.ULEAlgorithm;
    
    c.ITER_SMALL_EPSILON = 20;
    c.ITER_BIG_EPSILON = 60;
    c.ANIMATION_REDRAW_RATE = 8;
    c.PHASE_TWO_PERCENTAGE_INCREM = 0.9;
    c.PHASE_THREE_PERCENTAGE_INCREM = 0.1;
    c.PHASE_ONE_PERCENTAGE_NON_INCREM = 0.2;
    c.PHASE_TWO_PERCENTAGE_NON_INCREM = 0.7;
    c.PHASE_THREE_PERCENTAGE_NON_INCREM = 0.1;
    c.NO_PREPROCESSING = 10;
    c.RADIAL_TREE_PREPROCESSING = 11;
    c.HIERARCHICAL_PREPROCESSING = 12;
  }
  
}
);

/**
 * @private
 */
dojo.declare('ULEAlgorithmAnonClass_1', ibm_ilog.graphlayout.tree.TreeLayout,
{
  // tags:
  //		private
  
  __ule : null,

  constructor : function(input__ule)
  {
    
    this.__ule = input__ule;
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    // tags:
    //		private
    
    return this.__ule.isFixed(nodeOrLink); // Boolean
  }

});

/**
 * @private
 */
dojo.declare('ULEAlgorithmAnonClass_2', ibm_ilog.graphlayout.hierarchical.HierarchicalLayout,
{
  // tags:
  //		private
  
  __ule : null,

  constructor : function(input__ule)
  {
    
    this.__ule = input__ule;
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    // tags:
    //		private
    
    return this.__ule.isFixed(nodeOrLink); // Boolean
  }

});

(function(){ ibm_ilog.graphlayout.forcedirected.ULEAlgorithm._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.forcedirected.ULEAlgorithm");});
require(["ibm_ilog/graphlayout/forcedirected/ULEAlgorithm"]);

},
'ibm_ilog*graphlayout/forcedirected/FMMAlgorithm':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/basic/BasicLinkStyleLayout","ibm_ilog/graphlayout/forcedirected/ForceDirectedLayout","ibm_ilog/graphlayout/forcedirected/GraphCoarseningAlgo","ibm_ilog/graphlayout/forcedirected/MultilevelGraphPartitioningAlgo","ibm_ilog/graphlayout/forcedirected/RegularizationAlgo","ibm_ilog/graphlayout/forcedirected/SolarSystemNode","ibm_ilog/graphlayout/forcedirected/ULEAlgorithm","ibm_ilog/graphlayout/internalutil/GraphModelUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraphAdapter","ibm_ilog/graphlayout/internalutil/IFixedNode","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/internalutil/ReshapeLinkUtil","ibm_ilog/graphlayout/GraphLayoutReport"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected.FMMAlgorithm", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.basic.BasicLinkStyleLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.RegularizationAlgo');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.SolarSystemNode');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ULEAlgorithm');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.IFixedNode');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.ReshapeLinkUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayoutReport');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm', null, 
{
  // summary:
  //		This class is the main internal class for the FMMM (Fast Multilevel
  //		Method) algorithm. 
  // description:
  //		This class is the main internal class for the FMMM (Fast Multilevel
  //		Method) algorithm. 
  //		
  // tags:
  //		private
  
  _factorOfElapsedTimeForRefinement: null,
  _factorOfTotalAllowedTimeForRefinement: null,
  _maxRepeatForConvergence: null,

  _globalStartTime: null,

  _ule: null,

  _auxUle: null,

  constructor : function(layout)
  {
    // summary:
    //		The auxiliary instance of ULE that is used by FMMM.
    
    this._ule = layout;
  },
  
  detach : function()
  {
    if (this._auxUle != null) {
      this._auxUle.detach();
    }
  },

  doLayout : function(graphModel, redraw)
  {
    // summary:
    //		Executes the layout.
    
    if (this._ule.getLinkStyle() == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.STRAIGHT_LINE_STYLE) {
      ibm_ilog.graphlayout.internalutil.GraphModelUtil.deleteIntermediatePointsOnLinks(graphModel, this._ule);
    }
    this._globalStartTime = new Date().getTime();
    this._factorOfElapsedTimeForRefinement = this._ule.getMaxPercentageOfElapsedTimeForRefinement() / 100;
    this._factorOfTotalAllowedTimeForRefinement = this._ule.getMaxPercentageOfTotalAllowedTimeForRefinement() / 100;
    this._maxRepeatForConvergence = this._ule.getMaxRepeatForConvergence();
    var globalAllowedTime = this._ule.getAllowedTime();
    this._auxUle = null;

    var graphs = new Array();
    var models = new Array();
    var multilevelPartioner = new ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo();
    multilevelPartioner.run(graphModel, graphs, models);
    var nGraphs = graphs.length;

    if (nGraphs >= 1)
    {
      var model;
      var parentGraph;
      var parentModel;
      var childGraph = null;
      var nGraphsMinusOne = nGraphs - 1;

      var graph;
      var regularization = new ibm_ilog.graphlayout.forcedirected.RegularizationAlgo();

      for (var i = nGraphsMinusOne; i >= 0; i--)
      {
        graph = graphs[i];
        model = models[i];

        if (i < nGraphsMinusOne)
        {
          childGraph = graphs[i + 1];
        }

        this.doLayoutImpl(model, childGraph, nGraphs, i, globalAllowedTime, false, i == nGraphsMinusOne, redraw);

        if (i >= 1)
        {
          parentGraph = graphs[i - 1];
          parentModel = models[i - 1];
          var nodes = parentGraph.getNodes();

          while (nodes.hasNext())
          {
            var node = nodes.next();
            var solarSystemNode = ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.getSolarSystemNode(node);

            var bbox = graph.boundingBox(solarSystemNode);

            parentGraph.move(node, bbox.x, bbox.y);
          }

          var regModel = parentModel;

          if (regModel instanceof ibm_ilog.graphlayout.forcedirected.FMMAlgorithm.TopLevelAbstractGraphAdapter)
          {
            (regModel).setMoveInOriginalModel(false);
          }

          regularization.regularize(regModel, new FMMAlgorithmAnonClass_1(regModel));
        }
      }
    }

    this.doLayoutImpl(models[0], null, nGraphs, -1, globalAllowedTime, true, false, redraw);

    var layoutReport = this._ule.getLayoutReport();

    layoutReport.setCode(ibm_ilog.graphlayout.GraphLayoutReport.LAYOUT_DONE);
    layoutReport.setNumberOfIterations(this._ule.getAllowedNumberOfIterations());
  },

  doLayoutImpl : function(graphModel, childGraph, nLevels, level, globalAllowedTime, isRefinementStep, isSmallestGraph, redraw)
  {
    // summary:
    //		Executes the force-directed layout of the provided model using the
    //		provided number of iterations.
    // tags:
    //		private
    
    if (this._auxUle == null)
    {
      this._auxUle = new ibm_ilog.graphlayout.forcedirected.MultipoleULELayout(this._ule);
      this._auxUle.setRespectNodeSizes(true);

      this._auxUle.setPreserveFixedNodes(this._ule.isPreserveFixedNodes());
      this._auxUle.setAdditionalNodeRepulsionWeight(0.2);
      this._auxUle.setPreferredLinksLength(2 * this._ule.getPreferredLinksLength());

      this._auxUle.setMaxAllowedMovePerIteration(this._ule.getMaxAllowedMovePerIteration());

      this._auxUle.setLinkStyle(ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NO_RESHAPE_STYLE);
      this._auxUle.setLinkLengthWeight(0.1);

      this._auxUle.setForceFitToLayoutRegion(this._ule.isForceFitToLayoutRegion());
      this._auxUle.setLayoutOfConnectedComponentsEnabled(this._ule.isLayoutOfConnectedComponentsEnabled());

      var layoutOfConnComp = this._ule.getLayoutOfConnectedComponents();
      if (layoutOfConnComp != null) {
        this._auxUle.setLayoutOfConnectedComponents(layoutOfConnComp.copy());
      }
    }

    if (this._auxUle.getGraphModel() != graphModel)
    {
      var modelChecking = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, false);

      this._auxUle.setGraphModel(graphModel);

      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel,
        modelChecking);
    }

    if (level <= 0)
    {
      this._auxUle.setPreferredLinksLength(this._ule.getPreferredLinksLength());
      this._auxUle.setRespectNodeSizes(this._ule.isRespectNodeSizes());
      this._auxUle.setAdditionalNodeRepulsionWeight(this._ule.getAdditionalNodeRepulsionWeight());
    }

    this._auxUle.setULEMode(isRefinementStep);

    this._auxUle.setLayoutMode(
        ((!isSmallestGraph || isRefinementStep)
          ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.INCREMENTAL_MODE
          : ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.NON_INCREMENTAL_MODE));

    if (isRefinementStep && graphModel instanceof ibm_ilog.graphlayout.forcedirected.FMMAlgorithm.TopLevelAbstractGraphAdapter)
    {
      (graphModel).setMoveInOriginalModel(true);
      var threshold = this._ule.getConvergenceThreshold();

      if (nLevels <= 2) {
        threshold *= 0.5;
      }
      this._auxUle.setConvergenceThreshold(threshold);
      this._auxUle.setLinkLengthWeight(this._ule.getLinkLengthWeight());
      this._auxUle.setLinkStyle(this._ule.getLinkStyle());
    }

    this._auxUle.getULEAlgorithm().setPreprocessingMode(
        (isSmallestGraph ? ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.HIERARCHICAL_PREPROCESSING : ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.NO_PREPROCESSING));
    var isIncremental = this._auxUle.getLayoutMode() == ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.INCREMENTAL_MODE;

    if (isIncremental)
    {
      var counter = 0;

      var maxRepeat = (isRefinementStep ? 1 : this._maxRepeatForConvergence);

      while ((counter < maxRepeat) && (counter == 0 || !this._ule.isLayoutTimeElapsedPackage()))
      {
        if (isRefinementStep)
        {
          var durationSpentSoFar = new Date().getTime() - this._globalStartTime;

          var allowedTime = (nLevels > 1 ? Math.min(this._factorOfElapsedTimeForRefinement * durationSpentSoFar, this._factorOfTotalAllowedTimeForRefinement * globalAllowedTime) : globalAllowedTime);

          this._auxUle.setAllowedTime(allowedTime);
        }
        else
        {
          this._auxUle.setAllowedTime(this._ule.getRemainingAllowedTime());
        }

        this._auxUle.performLayout(childGraph, isSmallestGraph, redraw);
        counter++;

        if (isRefinementStep && !isSmallestGraph && nLevels > 2) {
          break;
        }
      }
    }
    else
    {
      this._auxUle.setAllowedTime(this._ule.getRemainingAllowedTime());

      this._auxUle.performLayout(childGraph, isSmallestGraph, redraw);
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.FMMAlgorithm,
{
}
);

/**
 * @private
 */
dojo.declare('FMMAlgorithmAnonClass_1', ibm_ilog.graphlayout.internalutil.IFixedNode,
{
  // tags:
  //		private
  
  __regModel : null,

  constructor : function(input__regModel)
  {
    
    this.__regModel = input__regModel;
  },

  isFixed : function(node)
  {
    if (node instanceof ibm_ilog.graphlayout.forcedirected.SolarSystemNode)
    {
      var sn = node;
      if (sn.getType() == ibm_ilog.graphlayout.forcedirected.SolarSystemNode.SUN_NODE) {
        return true; // Boolean
      }
    }

    return ibm_ilog.graphlayout.internalutil.GraphModelUtil.getNodeDegree(this.__regModel, node) < 2; // Boolean
  }

});

dojo.declare('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm.TopLevelAbstractGraphAdapter', ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter, 
{
  _graphModel: null,
  _moveInOriginalModel : null,

  constructor : function(graph, graphModel)
  {
    this._moveInOriginalModel = false;
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6012E");
    }

    this._graphModel = graphModel;
  },
  
  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node.  
    // node: Object
    //		the node.
    // x: Number
    //		the new x position.
    // y: Number
    //		the new y position.
    // redraw: Boolean
    //		is true the object is redrawn.
    // tags:
    //		private
    
    if (this._moveInOriginalModel)
    {
      var origObj = (node).getOriginalObject();
      this._graphModel.moveNode(origObj, x, y);
    }
    else
    {
      this.inherited("moveNode", arguments, [node, x, y]);
    }
  },

  setMoveInOriginalModel : function(flag)
  {
    // summary:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    // description:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    //		The default is false.
    // tags:
    //		private
    
    this._moveInOriginalModel = flag;
  },

  isMoveInOriginalModel : function()
  {
    // summary:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    // description:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    //		The default is false.
    // tags:
    //		private
    
    return this._moveInOriginalModel; // Boolean
  }

}
);

return dojo.getObject("ibm_ilog.graphlayout.forcedirected.FMMAlgorithm");});
require(["ibm_ilog/graphlayout/forcedirected/FMMAlgorithm"]);

},
'ibm_ilog*graphlayout/forcedirected/RegularizationAlgo':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/forcedirected/ForceDirectedLayout","ibm_ilog/graphlayout/internalutil/GraphModelUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/GraphLayoutData","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/GraphLayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected.RegularizationAlgo", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.forcedirected.RegularizationAlgo');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////
// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphLayoutData');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayout');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.forcedirected.RegularizationAlgo', null, 
{
  // summary:
  //		This class produces a quite uniform distribution of nodes inside a
  //		regular polygon of fixed nodes. 
  // description:
  //		This class produces a quite uniform distribution of nodes inside a
  //		regular polygon of fixed nodes. 
  //		It is a kind of minimization of the square of the distances between
  //		nodes. In other words, it puts each non-fixed node at the "center" of
  //		its neighbors.   
  // tags:
  //		private
  /*=====
  // SLOW_GOOD: int
  //		Slow node placement algorithm. 
  //		It provides more uniformity of the node distribution inside the
  //		exterior cycle, but is slightly slower.
  SLOW_GOOD : null,
  // QUICK_BAD: int
  //		Fast node placement algorithm. 
  //		It provides less uniformity of the node distribution inside the
  //		exterior cycle, but is slightly faster.
  QUICK_BAD : null,
  =====*/
  
  _topologyData: null,
  _positionData: null,

  _xSum : null,
  _ySum : null,
  _xSumUp : null,
  _ySumUp : null,
  _sumDown: null,

  _mode : null,

  constructor : function()
  {
    this._xSum = 0;
    this._ySum = 0;
    this._xSumUp = 0;
    this._ySumUp = 0;
    this._mode = ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.QUICK_BAD;
  },
  
  getMode : function()
  {
    return this._mode; // int
  },

  computeXYbarycenter : function(nodeId)
  {
    // summary:
    //		Computes _x, _y = the position of nodeId as a barycenter of his 
    //		neighbors.
    // tags:
    //		private
    
    var newX;
    var newY;
    this.computeSumXYNeighbours(nodeId);

    newX =
      ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.BARYCENTER_COEF * (this._xSum / this._topologyData.getNumberOfNeighbours(nodeId)) +
        this._positionData.getXofNode(nodeId) * ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.BARYCENTER_COEF;
    newY =
      ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.BARYCENTER_COEF * (this._ySum / this._topologyData.getNumberOfNeighbours(nodeId)) +
        this._positionData.getYofNode(nodeId) * ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.BARYCENTER_COEF;
    this._positionData.recordMove(Math.abs(this._positionData.getXofNode(nodeId) - newX), Math.abs(this._positionData.getYofNode(nodeId) - newY));
    this._positionData.setNodePosition(nodeId, newX, newY);
  },

  computeXYcenter : function(nodeId)
  {
    // summary:
    //		Computes _x, _y = the position of nodeId at the center of its
    //		neighbors using another formula which gives a slower convergence
    //		speed, but a better quality of the results. 
    // description:
    //		Computes &#95;x, &#95;y = the position of nodeId at the center of its
    //		neighbors using another formula which gives a slower convergence
    //		speed, but a better quality of the results. 
    //		We compute the center of the smallest disc including all the
    //		neighbors.
    // tags:
    //		private
    
    var newX;
    var newY;

    this.computeSumUpDownNeighbours(nodeId, this._positionData.getXofNode(nodeId), this._positionData.getYofNode(nodeId));

    if (this._sumDown > 0.00001)
    {
      newX = this._positionData.getXofNode(nodeId) + this._xSumUp / (4 * this._sumDown);
      newY = this._positionData.getYofNode(nodeId) + this._ySumUp / (4 * this._sumDown);
      this._positionData.recordMove(Math.abs(this._positionData.getXofNode(nodeId) - newX), Math.abs(this._positionData.getYofNode(nodeId) - newY));
      this._positionData.setNodePosition(nodeId, newX, newY);
    }
  },

  computeSumXYNeighbours : function(nodeId)
  {
    // summary:
    //		Computes _xSum = the sum of the x coordinate of all neighbors of
    //		nodeId idem for _ySum.
    // tags:
    //		private
    
    this._xSum = 0;
    this._ySum = 0;

    var n = this._topologyData.getNumberOfNeighbours(nodeId);

    for (var i = 0; i < n; i++)
    {
      var neighborId = this._topologyData.getNeighbour(nodeId, i);
      this._xSum += this._positionData.getXofNode(neighborId);
      this._ySum += this._positionData.getYofNode(neighborId);
    }
  },

  computeSumUpDownNeighbours : function(nodeId, x, y)
  {
    // summary:
    //		Computes _xSum = the sum of the x coordinate of all neighbours of
    //		nodeId. 
    // description:
    //		Computes &#95;xSum = the sum of the x coordinate of all neighbours of
    //		nodeId. 
    //		Idem for &#95;ySum  
    // nodeId: int
    //		The Id of the current node
    // x: Number
    //		the x-coordinate of the node
    // y: Number
    //		the y-coordinate of the node
    // tags:
    //		private
    
    this._xSumUp = 0;
    this._ySumUp = 0;
    this._sumDown = 0;
    var dist = 0;
    var distX = 0;
    var distY = 0;

    var n = this._topologyData.getNumberOfNeighbours(nodeId);

    for (var neighb = 0; neighb < n; neighb++)
    {
      var neighborId = this._topologyData.getNeighbour(nodeId, neighb);
      distX = this._positionData.getXofNode(neighborId) - this._positionData.getXofNode(nodeId);
      distY = this._positionData.getYofNode(neighborId) - this._positionData.getYofNode(nodeId);
      dist = distX * distX + distY * distY;
      dist = dist * dist;
      this._xSumUp += distX * dist;
      this._ySumUp += distY * dist;
      this._sumDown += dist;
    }
  },

  regularize : function(graphModel, fixedNodeInterface)
  {
    // summary:
    //		Performs the regularization.  
    // returns:
    //		The number of iterations done.
    
    var msg;

    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6012E");
    }

    if (fixedNodeInterface == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6763E");
    }

    var nodeId;
    var numberOfIterationsDone = 0;
    var regLayout = new ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.RegularizationLayout();
    regLayout.attach(graphModel);
    var layoutData = new ibm_ilog.graphlayout.internalutil.GraphLayoutData(regLayout, fixedNodeInterface);
    layoutData.beforeLayout(true, true, false, false);
    this._topologyData = layoutData.getTopologicalData();
    this._positionData = layoutData.getPositionData();

    if (!this._positionData.identifyFixedAndMoveableNodes(true, false))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6764E");
    }

    var maxIter = ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.MAX_NUMBER_OF_ITER;
    var firstIndexOfMoveableNodes = this._positionData.getFirstIndexOfMoveableNodes();
    var numberOfMoveableNodes = this._positionData.getNumberOfMoveableNodes();
    if (numberOfMoveableNodes == 0) {
      return 0; // int
    }

    var nodePlacementAlgo = this.getMode();

    for (var iter = 1; iter <= maxIter; iter++)
    {
      numberOfIterationsDone = iter;
      this._positionData.resetMaxMovementCounter();

      for (var k = firstIndexOfMoveableNodes; k < firstIndexOfMoveableNodes + numberOfMoveableNodes; k++)
      {
        nodeId = this._positionData.getNodeId(k);

        switch (nodePlacementAlgo)
        {
          case ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.SLOW_GOOD:
            
            this.computeXYbarycenter(nodeId);
            break;
          case ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.QUICK_BAD:
            this.computeXYcenter(nodeId);
            break;
          default:
            var params = [this.getMode() ];
            ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6765E", params);
        }
      }

      if (this._positionData.getMaxMovement() <= ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.CONVERGENCE_THRESHOLD) {
        break;
      }
      if (this.isNodesPlacementTimeElapsed()) {
        break;
      }
    }

    this._positionData.placeNodesAtPosition(false);

    return numberOfIterationsDone; // int
  },

  isNodesPlacementTimeElapsed : function()
  {
    return false; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.RegularizationAlgo,
{
  CONVERGENCE_THRESHOLD : null,

  BARYCENTER_COEF : null,
  MAX_NUMBER_OF_ITER : null,

  SLOW_GOOD : null,

  QUICK_BAD : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.forcedirected.RegularizationAlgo;
    
    c.CONVERGENCE_THRESHOLD = 1;
    c.BARYCENTER_COEF = -0.24;
    c.MAX_NUMBER_OF_ITER = 50;
    c.SLOW_GOOD = 0;
    c.QUICK_BAD = 1;
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.RegularizationLayout', ibm_ilog.graphlayout.GraphLayout, 
{

  constructor : function()
  {
    
  },
  copy : function()
  {
    return null; // ibm_ilog.graphlayout.GraphLayout
  },

  layout : function(redraw)
  {
    // summary:
    // tags:
    //		private
    
  }

}
);

ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.RegularizationLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getGlobalProperties();
};

ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.RegularizationLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getNodeProperties();
};

ibm_ilog.graphlayout.forcedirected.RegularizationAlgo.RegularizationLayout._getLinkProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.GraphLayout._getLinkProperties();
};

(function(){ ibm_ilog.graphlayout.forcedirected.RegularizationAlgo._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.forcedirected.RegularizationAlgo");});
require(["ibm_ilog/graphlayout/forcedirected/RegularizationAlgo"]);

},
'ibm_ilog*graphlayout/forcedirected/GraphCoarseningAlgo':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/forcedirected/ForceDirectedLayout","ibm_ilog/graphlayout/forcedirected/SolarSystemNode","ibm_ilog/graphlayout/internalutil/GraphModelUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraph","ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractLink","ibm_ilog/graphlayout/internalutil/LogResUtil"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.SolarSystemNode');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo', null, 
{
  // summary:
  //		Coarsens the graph for the FMMM algo. 
  // description:
  //		Coarsens the graph for the FMMM algo. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  createCoarserGraph : function (a0, a1, a2)
  {
    if(arguments.length == 2)
      return this.createCoarserGraph_overload_2(a0, a1);
    else if(arguments.length == 3)
      return this.createCoarserGraph_overload_3(a0, a1, a2);
  },
  
  createCoarserGraph_overload_2 : function(graph, graphModel)
  {
    var suns = ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.createSolarSystemPartition(graph, graphModel);
    var coarserGraph = this.createCoarserGraph(graph, suns, graphModel);
    return coarserGraph; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph
  },

  createCoarserGraph_overload_3 : function(graph, suns, graphModel)
  {
    // summary:
    //		Creates a coarser graph from the input graph according to its
    //		partitioning into solar systems. 
    // description:
    //		Creates a coarser graph from the input graph according to its
    //		partitioning into solar systems. 
    //		
    // graph: ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph
    //		The input graph
    // suns: Array
    //		The set of suns identified in the input graph.
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		
    // returns:
    //		The coarser graph.
    // tags:
    //		private
    
    var initialNumberOfNodes = graph.getNodesCount();
    var coarserGraph = new ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph(graphModel);

    var nSuns = suns.length;
    var mNode;
    var pNode;
    var sNode;
    var sunData;
    var planets;

    for (var i = 0; i < nSuns; i++)
    {
      sNode = suns[i];
      var node = new ibm_ilog.graphlayout.forcedirected.SolarSystemNode(sNode, sNode.boundingBox());
      coarserGraph.addNode(node);
      sunData = sNode.getUserData();
      sunData.setSolarSystemNode(node);
      planets = sunData.getPlanets();

      var _for_each_array_1 = planets;
      for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
      {
        var opNode = _for_each_array_1[_for_each_index_1];
        pNode = opNode;
        var planetData = pNode.getUserData();
        planetData.setSolarSystemNode(node);
        var mNodes = planetData.getMoons();

        if (mNodes != null)
        {
          var _for_each_array_2 = mNodes;
          for (var _for_each_index_2 = 0; _for_each_index_2 < _for_each_array_2.length; _for_each_index_2++)
          {
            var omNode = _for_each_array_2[_for_each_index_2];
            mNode = omNode;
            var moonData = mNode.getUserData();
            moonData.setSolarSystemNode(node);
          }
        }
      }
    }

    for (var ji = 0; ji < nSuns; ji++)
    {
      sNode = suns[ji];
      sunData = sNode.getUserData();
      var solarSystemNode = sunData.getSolarSystemNode();

      var neighbors = graph.getNeighbors(sNode);

      while (neighbors.hasNext())
      {
        var neighbor = neighbors.next();
        if (neighbor != sNode) {
          this.addLinkIfNeeded(solarSystemNode, neighbor, coarserGraph);
        }
      }

      planets = sunData.getPlanets();

      var _for_each_array_3 = planets;
      for (var _for_each_index_3 = 0; _for_each_index_3 < _for_each_array_3.length; _for_each_index_3++)
      {
        var poNode = _for_each_array_3[_for_each_index_3];
        pNode = poNode;
        neighbors = graph.getNeighbors(pNode);

        while (neighbors.hasNext())
        {
          var pNodeNeighbor = neighbors.next();
          if (pNodeNeighbor != pNode && pNodeNeighbor != sNode) {
            this.addLinkIfNeeded(solarSystemNode, pNodeNeighbor, coarserGraph);
          }
        }

        var pData = pNode.getUserData();
        var moonNodes = pData.getMoons();

        if (moonNodes != null)
        {
          var _for_each_array_4 = moonNodes;
          for (var _for_each_index_4 = 0; _for_each_index_4 < _for_each_array_4.length; _for_each_index_4++)
          {
            var moNode = _for_each_array_4[_for_each_index_4];
            mNode = moNode;
            neighbors = graph.getNeighbors(mNode);

            while (neighbors.hasNext())
            {
              var nbor = neighbors.next();
              if (nbor != mNode && nbor != pNode && nbor != sNode) {
                this.addLinkIfNeeded(solarSystemNode, nbor, coarserGraph);
              }
            }
          }
        }
      }
    }

    if (coarserGraph.getNodesCount() < initialNumberOfNodes) {
      return coarserGraph; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph
    }
    ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6757E",  initialNumberOfNodes);
    return null; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph
  },

  addLinkIfNeeded : function(firstNodeSolarSystemNode, secondNode, coarserGraph)
  {
    var secondNodeData = secondNode.getUserData();
    if (secondNodeData == null) {
      return;
    }

    var secondNodeSolarSystemNode = secondNodeData.getSolarSystemNode();

    if (secondNodeSolarSystemNode != firstNodeSolarSystemNode && !coarserGraph.isLinkBetween(firstNodeSolarSystemNode, secondNodeSolarSystemNode))
    {
      var link = new ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink(firstNodeSolarSystemNode, secondNodeSolarSystemNode);
      coarserGraph.addLink(link);
    }
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo,
{

  createSolarSystemPartition : function(graph, graphModel)
  {
    var nodes = graph.getNodes();
    var nNodes = graph.getNodesCount();
    var candidatesArray = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, null);
    var counter = 0;

    while (nodes.hasNext())
    {
      var node = nodes.next();
      candidatesArray[counter++] = node;
    }

    var comp = new ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.GCANodeDegreeComparator(graph);

    candidatesArray.sort(dojo.hitch(comp, comp.compare));
    var candidates = new Array();

    for (var i = 0; i < nNodes; i++)
      candidates.push(candidatesArray[i]);
    var suns = new Array();
    var pNode;

    while (!(candidates.length==0))
    {
      var index = candidates.length - 1;
      var sNode = candidates[index];

      ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.registerSun(sNode);
      ibm_ilog.graphlayout.internalutil.TranslateUtil.removeArrayObject(candidates, sNode);
      suns.push(sNode);
      var neighbors = graph.getNeighbors(sNode);

      while (neighbors.hasNext())
      {
        pNode = neighbors.next();

        if (pNode == sNode)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6750E");
        }

        if (pNode.getType() == ibm_ilog.graphlayout.forcedirected.SolarSystemNode.MOON_NODE)
        {
          ibm_ilog.graphlayout.internalutil.TranslateUtil.removeArrayObject(candidates, pNode);

          ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.registerPlanet(pNode, sNode);
        }
      }

      neighbors = graph.getNeighbors(sNode);

      while (neighbors.hasNext())
      {
        pNode = neighbors.next();

        if (pNode == sNode)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6750E");
        }

        if (pNode.getType() != ibm_ilog.graphlayout.forcedirected.SolarSystemNode.PLANET_NODE)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6751E");
        }

        var neighborsOfPlanet = graph.getNeighbors(pNode);

        while (neighborsOfPlanet.hasNext())
        {
          var ssNode = neighborsOfPlanet.next();

          if (ssNode == pNode)
          {
            ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6752E");
          }

          if (ssNode.getType() == ibm_ilog.graphlayout.forcedirected.SolarSystemNode.MOON_NODE)
          {
            ibm_ilog.graphlayout.internalutil.TranslateUtil.removeArrayObject(candidates, ssNode);
          }
        }
      }
    }

    nodes = graph.getNodes();

    while (nodes.hasNext())
    {
      pNode = nodes.next();
      var type = pNode.getType();

      if (type == ibm_ilog.graphlayout.forcedirected.SolarSystemNode.MOON_NODE)
      {
        var mNode = pNode;
        var neighborsOfMoon = graph.getNeighbors(mNode);
        var foundPlanetForThisMoon = false;

        while (neighborsOfMoon.hasNext())
        {
          var neighbor = neighborsOfMoon.next();

          if (neighbor.getType() == ibm_ilog.graphlayout.forcedirected.SolarSystemNode.PLANET_NODE || neighbor.getType() == ibm_ilog.graphlayout.forcedirected.SolarSystemNode.PLANET_WITH_MOON_NODE)
          {
            ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.registerMoon(mNode, neighbor);

            foundPlanetForThisMoon = true;
            break;
          }
        }

        if (!foundPlanetForThisMoon)
        {
          var params = [mNode ];
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6753E", params);
        }
      }
    }

    return suns; // Array
  },

  registerSun : function(sNode)
  {
    sNode.setType(ibm_ilog.graphlayout.forcedirected.SolarSystemNode.SUN_NODE);

    sNode.setUserData(new ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.SunData());
  },

  registerPlanet : function(pNode, sNode)
  {
    pNode.setType(ibm_ilog.graphlayout.forcedirected.SolarSystemNode.PLANET_NODE);
    pNode.setUserData(new ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.PlanetData());
    var sunData = sNode.getUserData();

    if (sunData == null)
    {
      sunData = new ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.SunData(pNode);
      sNode.setUserData(sunData);
    }
    else
    {
      sunData.addPlanet(pNode);
    }
  },

  registerMoon : function(mNode, pNode)
  {
    if (pNode.getUserData() == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6754E");
    }

    if (pNode.getType() != ibm_ilog.graphlayout.forcedirected.SolarSystemNode.PLANET_NODE && pNode.getType() != ibm_ilog.graphlayout.forcedirected.SolarSystemNode.PLANET_WITH_MOON_NODE)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6755E");
    }

    pNode.setType(ibm_ilog.graphlayout.forcedirected.SolarSystemNode.PLANET_WITH_MOON_NODE);
    mNode.setType(ibm_ilog.graphlayout.forcedirected.SolarSystemNode.MOON_NODE);
    mNode.setUserData(new ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.MoonData());
    var planetData = pNode.getUserData();

    if (planetData != null)
    {
      planetData.addMoon(mNode);
    }
    else
    {
      var params = [pNode ];
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6756E", params);
    }
  },

  getSolarSystemNode : function(node)
  {
    var data = node.getUserData();
    return data.getSolarSystemNode(); // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  },

  getPlanets : function(sunNode)
  {
    var sunData = sunNode.getUserData();
    return sunData.getPlanets(); // Array
  },

  getMoons : function(pNode)
  {
    var planetData = pNode.getUserData();
    return planetData.getMoons(); // Array
  }

}
);

dojo.declare('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.SolarSystemData', null, 
{

  constructor : function()
  {
    
  },
  _node: null,

  setSolarSystemNode : function(node)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6758E");
    }

    this._node = node;
  },

  getSolarSystemNode : function()
  {
    if (this._node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6759E");
    }

    return this._node; // ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode
  }

}
);
dojo.declare('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.SunData', ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.SolarSystemData, 
{
  // summary:
  //		The solar system to which the current node is connected.
  // tags:
  //		private
  
  _pNodes : null,

  constructor : function(pNode )
  {
    this._pNodes = new Array();    if (pNode)
      this.addPlanet(pNode);
                              
  },
  
  addPlanet : function(pNode)
  {
    if (pNode == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6760E");
    }

    this._pNodes.push(pNode);
  },

  getPlanets : function()
  {
    // summary:
    //		Returns the planets of this sun. 
    // description:
    //		Returns the planets of this sun. 
    //		Can be empty (sun without planets).
    // tags:
    //		private
    
    return this._pNodes; // Array
  }

}
);
dojo.declare('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.PlanetData', ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.SolarSystemData, 
{
  _mNodes: null,

  constructor : function(

)
  {
  },
  
  addMoon : function(mNode)
  {
    if (this._mNodes == null) {
      this._mNodes = new Array();
    }
    this._mNodes.push(mNode);
  },

  getMoons : function()
  {
    return this._mNodes; // Array
  }

}
);
dojo.declare('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.MoonData', ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.SolarSystemData, 
{

  constructor : function()
  {
  }
  
}
);
dojo.declare('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.GCANodeDegreeComparator', null, 
{
  _graph: null,

  constructor : function(graph)
  {
    this._graph = graph;
  },
  
  compare : function(node1, node2)
  {
    var degree1 = this._graph.getNodeLinksCount(node1);
    var degree2 = this._graph.getNodeLinksCount(node2);
    if (degree1 < degree2) {
      return 1; // int
    }
    else if (degree1 == degree2) {
      return 0; // int
    }
    else {
      return -1; // int
    }
  }

}
);

return dojo.getObject("ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo");});
require(["ibm_ilog/graphlayout/forcedirected/GraphCoarseningAlgo"]);

},
'ibm_ilog*graphlayout/forcedirected/_ForceDirectedLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/basic/BasicLinkStyleLayout","ibm_ilog/graphlayout/forcedirected/ForceDirectedLayoutReport","ibm_ilog/graphlayout/forcedirected/ULEAlgorithm","ibm_ilog/graphlayout/internalutil/GraphModelUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/LayoutParametersUtil","ibm_ilog/graphlayout/internalutil/LinkStyles","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/GraphLayoutReport"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected._ForceDirectedLayout", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.forcedirected._ForceDirectedLayout');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.basic.BasicLinkStyleLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayoutReport');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ULEAlgorithm');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutParametersUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LinkStyles');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayoutReport');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout', ibm_ilog.graphlayout.basic.BasicLinkStyleLayout, 
{
  // summary:
  //		The main class for the Force-Directed Layout algorithm. 
  // description:
  //		The main class for the Force-Directed Layout algorithm. 
  //		<p>
  //		The Force-Directed Layout algorithm can be used to lay out any type
  //		of graph. It often provides a drawing with no, or only a few, edge
  //		crossings and with approximately equal-length edges for small- and
  //		medium-size graphs having a small number of cycles.  
  //		</p>
  //		<p>
  //		This layout algorithm iteratively searches for a configuration of the
  //		graph such that the lengths of the edges are close to a desired
  //		value.  
  //		</p>
  //		<p>
  //		Here are sample drawings produced with the Force-Directed Layout
  //		algorithm:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Uniform-3cyc-after.gif" alt="Sample drawing produced with the Force-Directed Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Uniform-cycles-tree.gif" alt="Sample drawing produced with the Force-Directed Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Uniform-huge.jpg" alt="Sample drawing produced with the Force-Directed Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-Uniform-sierpinski5.jpg" alt="Sample drawing produced with the Force-Directed Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		<b>Performance hints</b>  
  //		</p>
  //		<p>
  //		Several parameters have an impact on speed. In some extent, the
  //		performance can be improved by modifying these parameters.  
  //		<ul>
  //		<li>Parameter with the largest impact on speed:  
  //		<ul>
  //		<li><code> ForceDirectedLayout.setLayoutMode()</code>. The algorithm
  //		provides three modes with different tradeoffs between quality and
  //		speed. For details, please refer to documentation of this
  //		method.</li>  
  //		</ul>
  //		</li>  
  //		<li>Parameters that allow to reduce the number of iterations that are
  //		executed:  
  //		<ul>
  //		<li><code> ForceDirectedLayout.setPreferredLinksLength()</code>. The
  //		algorithm stops iterating when the length of all links is close to
  //		the specified "preferredLinksLength" parameter. If the preferred
  //		length is very high while the initial length of the links is small,
  //		reducing the preferred length is an indirect way to reduce the
  //		necessary number of iterations, hence to speed up.</li>  
  //		<li><code> ibm&#95;ilog.graphlayout.GraphLayout.setAllowedTime()</code>.
  //		Reducing the allowed time is a way to force the completion of the
  //		layout quicker. However, the quality gets of course worst.</li>  
  //		<li><code> ForceDirectedLayout.setAllowedNumberOfIterations()</code>.
  //		Similar as for <code>
  //		ibm&#95;ilog.graphlayout.GraphLayout.setAllowedTime()</code>.</li>  
  //		</ul>
  //		</li>  
  //		<li>Parameters that allow to reduce the time spent on each iteration:
  //		 
  //		<ul>
  //		<li><code> ForceDirectedLayout.setRespectNodeSizes()</code>. If
  //		disabled, the algorithm is a bit quicker because it does not try to
  //		avoid overlaps between nodes. This is in particular possible, without
  //		quality degradation, when all the nodes have approximately the same
  //		size and have more or less a square shape. In such cases, specifying
  //		a "preferredLinksLength" high enough usually avoids overlaps even if
  //		"respectNodeSizes" is not enabled.</li>   
  //		<li><code>
  //		ForceDirectedLayout.setMaxAllowedMovePerIteration()</code>. This
  //		indicates the maximum distance the algorithm is allowed to move a
  //		node at each iteration. The higher the value, quicker the optimum may
  //		be reached, but also the algorithm may fail to converge (no "crash",
  //		just that the quality may be worst).</li>  
  //		</ul>
  //		</li>  
  //		</ul>  
  //		</p>
  //		<p>
  //		See the corresponding chapter of the IBM ILOG Dojo Diagrammer
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, parameters, and so on.  
  //		</p>
  //		<p>
  //		You can specify a preferred length for the links globally (<code> ForceDirectedLayout.setPreferredLinksLength()</code> or for specific links (<code> ForceDirectedLayout.setPreferredLength()</code>).  
  //		</p>
  //		<p>
  //		You can request that the real size of the nodes is taken into account (<code> ForceDirectedLayout.setRespectNodeSizes()</code>). This is especially recommended when the nodes are not square (have a larger or smaller width than height), or have different sizes. In such a case, the layout quality can be often further improved by increasing the weight of the node repulsion force (see <code> ForceDirectedLayout.setAdditionalNodeRepulsionWeight()</code>; the default is zero).  
  //		</p>
  //		<p>
  //		While the layout algorithm optionally restricts the region where the nodes are placed (see <code> ForceDirectedLayout.setForceFitToLayoutRegion()</code>), the layout quality is usually much better if this option is not used (this is the default behavior).  
  //		</p>
  //		<p>
  //		If this option is not set, the nodes are considered to be points located in the center of the bounding box of the nodes. Using the layout algorithm without setting this option is recommended when the width of the nodes is close to their height and there are no significant size differences among the nodes.  
  //		</p>
  //		<p>
  //		Note that, in the incremental mode (which is the default), the initial position of the nodes (at the moment you start the layout) is taken into account by the layout algorithm, so you may get different results depending on the initial position.  
  //		</p>
  /*=====
  // INCREMENTAL_MODE: int
  //		Incremental layout mode. 
  //		When used as an argument of  '
  //		ForceDirectedLayout.setLayoutMode()', the layout is executed in
  //		incremental mode. For details, see '
  //		ForceDirectedLayout.setLayoutMode()'.
  INCREMENTAL_MODE : null,
  // NON_INCREMENTAL_MODE: int
  //		Non-incremental layout mode. 
  //		When used as an argument of  '
  //		ForceDirectedLayout.setLayoutMode()', the layout is executed in
  //		nonincremental mode. For details, see '
  //		ForceDirectedLayout.setLayoutMode()'.
  NON_INCREMENTAL_MODE : null,
  // FAST_MULTILEVEL_MODE: int
  //		Fast multilevel layout mode. 
  //		When used as an an argument of  '
  //		ForceDirectedLayout.setLayoutMode()', the layout is executed in
  //		fast multilevel mode. For details, see '
  //		ForceDirectedLayout.setLayoutMode()'.
  FAST_MULTILEVEL_MODE : null,
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line links shape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are given a straight-line shape.
  STRAIGHT_LINE_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No links reshape option. 
  //		When used as an argument of  '
  //		ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.setLinkStyle()',
  //		the links are not reshaped.
  NO_RESHAPE_STYLE : null,
  =====*/
  
  _numberOfIterations: null,
  _convergenceThreshold: null,
  _maxAllowedMovePerIteration: null,

  _preferredLinksLength: null,
  _nodeDistanceThreshold: null,
  _isForceFitToLayoutRegion: null,
  _respectNodeSizes: null,
  _linkLengthWeight: null,
  _additionalNodeRepulsionWeight: null,

  _layoutMode: null,
  _maxPercOfElapsedTimeForRefinement: null,
  _maxPercOfTotalAllowedTimeForRefinement: null,
  _maxRepeatForConvergence: null,

  _uleAlgorithm: null,

  constructor : function (a0)
  {
    if(arguments.length == 0)
      this._constructor_overload_ibm_ilog_graphlayout_forcedirected_ForceDirectedLayout_0();
    else if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_forcedirected_ForceDirectedLayout_1(a0);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_forcedirected_ForceDirectedLayout_0 : function()
  {
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.  
    //		</p>
    // tags:
    //		protected
    
    ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultRespectNodeSizes = true;
    //ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultLayoutMode = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.FAST_MULTILEVEL_MODE; 

    this.inherited("init", arguments, []);
    this._numberOfIterations = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultNumberOfIterations;
    this._convergenceThreshold = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultConvergenceThreshold;
    this._maxAllowedMovePerIteration = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultMaxAllowedMovePerIteration;

    this._preferredLinksLength = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultPreferredLinksLength;
    this._nodeDistanceThreshold = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultNodeDistanceThreshold;
    this._isForceFitToLayoutRegion = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultIsForceFitToLayoutRegion;
    this._respectNodeSizes = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultRespectNodeSizes;
    this._linkLengthWeight = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultLinkLengthWeight;
    this._additionalNodeRepulsionWeight = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultAdditionalNodeRepulsionWeight;
    this._layoutMode = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultLayoutMode;
    this._maxPercOfElapsedTimeForRefinement = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultMaxPercOfElapsedTimeForRefinement;
    this._maxPercOfTotalAllowedTimeForRefinement = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultMaxPercOfTotalAllowedTimeForRefinement;
    this._maxRepeatForConvergence = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultMaxRepeatForConvergence;

    this._uleAlgorithm = this.createULEAlgorithm();
  },

  createULEAlgorithm : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return new ibm_ilog.graphlayout.forcedirected.ULEAlgorithm(this); // ibm_ilog.graphlayout.forcedirected.ULEAlgorithm
  },

  getULEAlgorithm : function()
  {
    // summary:
    //		
    // tags:
    //		private
    
    return this._uleAlgorithm; // ibm_ilog.graphlayout.forcedirected.ULEAlgorithm
  },

  _constructor_overload_ibm_ilog_graphlayout_forcedirected_ForceDirectedLayout_1 : function(source )
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the customization interfaces, are also copied. A
    //		copy of the layout instance used for laying out the connected
    //		components is set on the new instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the layout region
    //		specification and the customization interfaces, are also copied. A
    //		copy of the layout instance used for laying out the connected
    //		components is set on this layout instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout)
    {
      var usource = source;
      this.setAllowedNumberOfIterations(usource.getAllowedNumberOfIterations());
      this.setConvergenceThreshold(usource.getConvergenceThreshold());
      this.setMaxAllowedMovePerIteration(usource.getMaxAllowedMovePerIteration());
      this.setPreferredLinksLength(usource.getPreferredLinksLength());
      this.setNodeDistanceThreshold(usource.getNodeDistanceThreshold());
      this.setForceFitToLayoutRegion(usource.isForceFitToLayoutRegion());
      this.setRespectNodeSizes(usource.isRespectNodeSizes());
      this.setLinkLengthWeight(usource.getLinkLengthWeight());
      this.setAdditionalNodeRepulsionWeight(usource.getAdditionalNodeRepulsionWeight());
      this.setLayoutMode(usource.getLayoutMode());
      this.setMaxPercentageOfElapsedTimeForRefinement(usource.getMaxPercentageOfElapsedTimeForRefinement());
      this.setMaxPercentageOfTotalAllowedTimeForRefinement(usource.getMaxPercentageOfTotalAllowedTimeForRefinement());
      this.setMaxRepeatForConvergence(usource.getMaxRepeatForConvergence());
    }
  },

  detach : function()
  {
    // summary:
    //		Detaches the graph model from the layout instance. 
    // description:
    //		Detaches the graph model from the layout instance. 
    //		When you attach a new graph model to the layout instance, you do not
    //		need to detach the old graph model because this is done
    //		automatically when you call <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code>.  
    //		<p>
    //		The method performs cleaning operations on the graph model.  
    //		</p>
    //		<p>
    //		Note that you must call this method when you no longer need the
    //		layout instance. Otherwise, some objects may not be garbage
    //		collected.  
    //		</p>
    
    if (this._uleAlgorithm != null) {
      this._uleAlgorithm.detach();
    }
    this.inherited("detach", arguments, []);
  },

  createLayoutReport : function()
  {
    // summary:
    //		Creates the graph layout report instance.  
    // returns:
    //		A new instance of graph layout report. The current
    //		implementation creates an instance of '
    //		ForceDirectedLayoutReport'.
    
    return new ibm_ilog.graphlayout.forcedirected.ForceDirectedLayoutReport(); // ibm_ilog.graphlayout.GraphLayoutReport
  },

  isLayoutOfConnectedComponentsEnabledByDefault : function()
  {
    // summary:
    //		Overridden version of the method from the superclass that always
    //		returns 'true'.  
    // returns:
    //		'true'
    // tags:
    //		protected
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation
    //		when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation
    //		when the user-defined allowed time is exceeded. 
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> in
    //		this case.
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;VALID</code> in
    //		this case.
    
    return true; // Boolean
  },

  supportsLayoutRegion : function()
  {
    // summary:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit (approximately) a user-defined region (a rectangle). 
    // description:
    //		Indicates that this layout class can control the size of the graph
    //		drawing to fit (approximately) a user-defined region (a rectangle). 
    //		By default, this feature is disabled. To enable it, use the method
    //		<code> ForceDirectedLayout.setForceFitToLayoutRegion()</code>.
    
    return true; // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can not estimate the percentage of
    //		completion during the layout run.
    
    return false; // Boolean
  },

  internalLayout : function()
  {
    // summary:
    //		Computes the layout using the Force-Directed Layout algorithm. 
    // description:
    //		Computes the layout using the Force-Directed Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. Note that
    //		this class overrides the <code>
    //		ForceDirectedLayout.createLayoutReport()</code> and creates an
    //		instance of <code> ForceDirectedLayoutReport</code>.   
    // tags:
    //		protected
    
    this._uleAlgorithm.layout(false);
    
  },

  isInterrupted : function()
  {
    // summary:
    //		Returns 'true' if the layout is interrupted.  
    // returns:
    //		'true' if the layout is interrupted.
    // tags:
    //		protected
    
    return false; // Boolean
  },

  getLayoutCodeOnInterrupt : function()
  {
    // summary:
    //		Returns the layout code when the allowed time elapsed before
    //		completion of the layout. 
    // description:
    //		Returns the layout code when the allowed time elapsed before
    //		completion of the layout. 
    //		
    // returns:
    //		'
    //		ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_VALID'
    // tags:
    //		protected
    
    return ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_VALID; // int
  },

  setConvergenceThreshold : function(threshold)
  {
    // summary:
    //		Sets the threshold value for the convergence detection mechanism. 
    // description:
    //		Sets the threshold value for the convergence detection mechanism. 
    //		The iterative algorithm is stopped if the greatest movement of a
    //		node at an iteration <code>
    //		ForceDirectedLayout.getMaxAllowedMovePerIteration()</code> is
    //		smaller than <code>threshold</code> during several successive
    //		iterations.  
    //		<p>
    //		The default value is <code>1</code>. The units are in the same
    //		coordinate space as the coordinates and size of the nodes.
    //		Increasing this value may speed up the layout because the iterations
    //		may be stopped earlier. However, this may produce a nonoptimal
    //		layout. Decreasing this value in some cases improves the quality of
    //		the layout but needs more time because more iterations are
    //		performed. Note that if the specified value is too small, the
    //		iterations cannot be stopped until the allowed time or the allowed
    //		number of iterations is reached.  
    //		</p>
    
    threshold = Math.max(threshold, ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT);

    if (threshold != this._convergenceThreshold)
    {
      this._convergenceThreshold = threshold;
      this.onParameterChanged("ConvergenceThreshold");
    }
  },

  getConvergenceThreshold : function()
  {
    // summary:
    //		Returns the threshold value for the convergence detection mechanism.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultConvergenceThreshold : this._convergenceThreshold); // Number
  },

  setMaxAllowedMovePerIteration : function(maxMove)
  {
    // summary:
    //		Sets the maximum authorized node move at each iteration of the
    //		layout algorithm. 
    // description:
    //		Sets the maximum authorized node move at each iteration of the
    //		layout algorithm. 
    //		The default value is <code>5</code>.  
    //		<p>
    //		Increasing this parameter may speed up the layout, but the algorithm
    //		may fail to converge. Decreasing this parameter slows down the
    //		layout but in some cases improves the convergence. You should not
    //		specify a zero value, because in this case the layout cannot move
    //		the nodes at all.  
    //		</p>
    
    if (maxMove < ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT) {
      maxMove = ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT;
    }
    if (maxMove != this._maxAllowedMovePerIteration)
    {
      this._maxAllowedMovePerIteration = maxMove;
      this.onParameterChanged("MaxAllowedMovePerIteration");
    }
  },

  getMaxAllowedMovePerIteration : function()
  {
    // summary:
    //		Returns the maximum authorized move at each iteration of the layout
    //		algorithm.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultMaxAllowedMovePerIteration : this._maxAllowedMovePerIteration); // Number
  },

  setForceFitToLayoutRegion : function(option)
  {
    // summary:
    //		Sets whether the layout algorithm must force the graph drawing to
    //		fit the layout region. 
    // description:
    //		Sets whether the layout algorithm must force the graph drawing to
    //		fit the layout region. 
    //		If the argument is <code>false</code> (which is the default), the
    //		layout algorithm is free to move nodes outside the layout region.
    //		Note that the layout may not be optimal if the size of the layout
    //		region is too small. It is recommended to avoid forcing the use of a
    //		layout region anytime this is possible.
    
    if (option != this._isForceFitToLayoutRegion)
    {
      this._isForceFitToLayoutRegion = option;
      this.onParameterChanged("ForceFitToLayoutRegion");
    }
  },

  isForceFitToLayoutRegion : function()
  {
    // summary:
    //		Returns the current choice for the force-fit-to-layout-region
    //		parameter.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultIsForceFitToLayoutRegion : this._isForceFitToLayoutRegion); // Boolean
  },

  setPreferredLinksLength : function(length)
  {
    // summary:
    //		Sets the global preferred length of the links. 
    // description:
    //		Sets the global preferred length of the links. 
    //		The layout algorithm tries to compute a layout where the links have
    //		the specified length. The preferred length can also be specified
    //		individually for each link (or for some links). If an individual
    //		length is not specified for a particular link, the global length
    //		specified using this method is used for this link.  
    //		<p>
    //		The default value is <code>60</code>.  
    //		</p>
    
    if (length < 0) {
      length = 0;
    }
    if (length != this._preferredLinksLength)
    {
      this._preferredLinksLength = length;
      this.onParameterChanged("PreferredLinksLength");
    }
  },

  getPreferredLinksLength : function()
  {
    // summary:
    //		Returns the global preferred length of the links.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultPreferredLinksLength : this._preferredLinksLength); // Number
  },

  setPreferredLength : function(link, length)
  {
    // summary:
    //		Sets the preferred length of a link. 
    // description:
    //		Sets the preferred length of a link. 
    //		The layout algorithm tries to compute a layout where the link has
    //		the specified length. If a preferred length is set for a link, this
    //		overrides the global preferred length for this link.  
    //		<p>
    //		After having specified a length for a link, you can call the method
    //		with a strictly negative value to indicate that the global preferred
    //		length must be used again for this link.  
    //		</p>
    //		<p>
    //		By default, no length is specified for the individual links.  
    //		</p>
    // link: Object
    //		The link instance.
    // length: Number
    //		The preferred length of the link.
    
    if (length < 0) {
      length = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultPreferredIndividualLinksLength;
    }
    ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setLinkParameter(this, link, ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.LINK_LENGTH_PROPERTY, Number(length ),
      Number(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultPreferredIndividualLinksLength ));
  },

  getPreferredLength : function(link)
  {
    // summary:
    //		Returns the preferred length of a link; returns '-1' if
    //		the length is unspecified (in this case, the layout uses the global
    //		length; see '
    //		ForceDirectedLayout.getPreferredLinksLength()').  
    // link: Object
    //		The link instance.
    // returns:
    //		The preferred length of a link, if one is specified; or
    //		'-1' if the layout uses the global length.
    
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getLinkFloatParameter(this, link, ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.LINK_LENGTH_PROPERTY,
        ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultPreferredIndividualLinksLength); // Number
  },

  setLayoutMode : function(mode)
  {
    // summary:
    //		Sets the layout mode. 
    // description:
    //		Sets the layout mode. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> ForceDirectedLayout.INCREMENTAL&#95;MODE</code> - The
    //		algorithm starts from the current position and iteratively tries to
    //		converge towards the optimal layout. Thus, in some cases, this mode
    //		avoids a major reorganization of the graph, which helps to preserve
    //		the "mental map" of the user as much as possible. However, this
    //		approach is not guaranteed, and depends on how far the initial
    //		position of the nodes is from the position that satisfies the
    //		criteria of the algorithm. </li>  
    //		<li> <code> ForceDirectedLayout.NON&#95;INCREMENTAL&#95;MODE</code> - The
    //		algorithm is free to reorganize the graph without trying to stay
    //		close to the initial positions. Often, the nonincremental mode is
    //		faster than the incremental mode, sometimes at the price of lower
    //		quality. </li>  
    //		<li> <code> ForceDirectedLayout.FAST&#95;MULTILEVEL&#95;MODE</code> - The
    //		algorithm uses a multilevel graph decomposition strategy that
    //		usually leads to significant speed gain. In this mode, the behavior
    //		is nonincremental. </li>  
    //		</ul>  
    //		<p>
    //		The default value is <code>
    //		ForceDirectedLayout.INCREMENTAL&#95;MODE</code> .  
    //		</p>
    
    if (!
      (mode == ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.INCREMENTAL_MODE || mode == ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.NON_INCREMENTAL_MODE ||
          mode == ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.FAST_MULTILEVEL_MODE))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6771E",  mode);
    }

    if (mode != this._layoutMode)
    {
      this._layoutMode = mode;
      this.onParameterChanged("LayoutMode");
    }
  },

  getLayoutMode : function()
  {
    // summary:
    //		Returns the current layout mode.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultLayoutMode : this._layoutMode); // int
  },

  setNodeDistanceThreshold : function(threshold)
  {
    // summary:
    //		Sets the node distance threshold. 
    // description:
    //		Sets the node distance threshold. 
    //		The additional repulsion force (see <code>
    //		ForceDirectedLayout.setAdditionalNodeRepulsionWeight()</code>) is
    //		applied only for nodes that are not connected by a link and are at a
    //		distance smaller than this threshold.  
    //		<p>
    //		The default value is <code>30</code>.  
    //		</p>
    //		<p>
    //		Note that the additional repulsion force is applied only if the
    //		corresponding weight (see <code>
    //		ForceDirectedLayout.setAdditionalNodeRepulsionWeight()</code>) is
    //		larger than 0. The default weight is 0; therefore, the node distance
    //		threshold has no effect if the weight is not modified.  
    //		</p>
    
    if (threshold != this._nodeDistanceThreshold)
    {
      this._nodeDistanceThreshold = threshold;
      this.onParameterChanged("NodeDistanceThreshold");
    }
  },

  getNodeDistanceThreshold : function()
  {
    // summary:
    //		Returns the node distance threshold.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultNodeDistanceThreshold : this._nodeDistanceThreshold); // Number
  },

  setRespectNodeSizes : function(respect)
  {
    // summary:
    //		Sets whether the algorithm must try to respect the size of the
    //		nodes. 
    // description:
    //		Sets whether the algorithm must try to respect the size of the
    //		nodes. 
    //		If the argument is <code>true</code>, the preferred length parameter
    //		is interpreted as a minimum distance between the bounding boxes of
    //		the end nodes. Otherwise, the preferred length parameter is
    //		considered as the center-to-center distance between the end nodes.
    
    if (respect != this._respectNodeSizes)
    {
      this._respectNodeSizes = respect;
      this.onParameterChanged("RespectNodeSizes");
    }
  },

  isRespectNodeSizes : function()
  {
    // summary:
    //		Returns 'true' if the algorithm tries to respect the size
    //		of the nodes.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultRespectNodeSizes : this._respectNodeSizes); // Boolean
  },

  setLinkLengthWeight : function(weight)
  {
    // summary:
    //		Sets the link length weight. 
    // description:
    //		Sets the link length weight. 
    //		This weight is a multiplier that is applied when two nodes connected
    //		by a link are moved in order to obtain a link length close to the
    //		preferred value (see <code>
    //		ForceDirectedLayout.setPreferredLinksLength()</code> and <code>
    //		ForceDirectedLayout.setPreferredLength()</code>). The default value
    //		is <code>1</code>. Increasing (or decreasing) this value increases
    //		(or decreases) the priority that is given to the link length
    //		criteria with respect to the minimum distance between nodes not
    //		connected by a link.
    
    if (weight != this._linkLengthWeight)
    {
      this._linkLengthWeight = weight;
      this.onParameterChanged("LinkLengthWeight");
    }
  },

  getLinkLengthWeight : function()
  {
    // summary:
    //		Returns the link length weight.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultLinkLengthWeight : this._linkLengthWeight); // Number
  },

  setAdditionalNodeRepulsionWeight : function(weight)
  {
    // summary:
    //		Sets the weight of the additional node repulsion force. 
    // description:
    //		Sets the weight of the additional node repulsion force. 
    //		This weight is a multiplier which is applied to the repulsion force
    //		between two nodes that are not connected by a link. The additional
    //		repulsion force is applied only if the distance between the nodes is
    //		smaller than the node distance threshold (see <code>
    //		ForceDirectedLayout.setNodeDistanceThreshold()</code>).  
    //		<p>
    //		The default value is <code>0.2</code>. Increasing the weight
    //		increases the priority that is given to maintaining the nodes at a
    //		distance larger than the node distance threshold. However,
    //		increasing the weight decreases the ability of the algorithm to
    //		reach convergence quickly.  
    //		</p>
    
    if (weight != this._additionalNodeRepulsionWeight)
    {
      this._additionalNodeRepulsionWeight = weight;
      this.onParameterChanged("AdditionalNodeRepulsionWeight");
    }
  },

  getAdditionalNodeRepulsionWeight : function()
  {
    // summary:
    //		Returns the weight of the additional node repulsion force.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultAdditionalNodeRepulsionWeight : this._additionalNodeRepulsionWeight); // Number
  },

  getAllowedNumberOfIterations : function()
  {
    // summary:
    //		Returns the maximum number of allowed iterations.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultNumberOfIterations : this._numberOfIterations); // int
  },

  setAllowedNumberOfIterations : function(iterations)
  {
    // summary:
    //		Sets the maximum number of iterations of the layout algorithm. 
    // description:
    //		Sets the maximum number of iterations of the layout algorithm. 
    //		The default value is <code>1000</code>.
    
    if (iterations < 0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6772E",  iterations);
    }

    if (this._numberOfIterations != iterations)
    {
      this._numberOfIterations = iterations;
      this.onParameterChanged("AllowedNumberOfIterations");
    }
  },

  setMaxPercentageOfElapsedTimeForRefinement : function(percentage)
  {
    // summary:
    //		Sets the maximum percentage of the time already elapsed  that should
    //		be spent on the final refinement step when the layout mode is '
    //		ForceDirectedLayout.FAST_MULTILEVEL_MODE' . 
    // description:
    //		Sets the maximum percentage of the time already elapsed  that should
    //		be spent on the final refinement step when the layout mode is <code>
    //		ForceDirectedLayout.FAST&#95;MULTILEVEL&#95;MODE</code> . 
    //		The parameter has no effect in other layototut modes.  
    //		<p>
    //		If the specified value is negative, the value <code>0</code> is
    //		used.  
    //		</p>
    //		<p>
    //		The default value is <code>1000</code> percent. That is, the
    //		refinement step should not take longer than 10 times the time
    //		already spent before this step.  
    //		</p>
    //		<p>
    //		Increasing the value of this parameter may increase the quality of
    //		the  layout, possibly at the price of a lower speed.   
    //		</p>
    
    if (percentage != this._maxPercOfElapsedTimeForRefinement)
    {
      if (percentage < 0) {
        percentage = 0;
      }
      this._maxPercOfElapsedTimeForRefinement = percentage;
      this.onParameterChanged("MaxPercentageOfElapsedTimeForRefinement");
    }
  },

  getMaxPercentageOfElapsedTimeForRefinement : function()
  {
    // summary:
    //		Returns the maximum percentage of the time already elapsed  that
    //		should be spent on the final refinement step when the layout mode is
    //		' ForceDirectedLayout.FAST_MULTILEVEL_MODE' . 
    // description:
    //		Returns the maximum percentage of the time already elapsed  that
    //		should be spent on the final refinement step when the layout mode is
    //		<code> ForceDirectedLayout.FAST&#95;MULTILEVEL&#95;MODE</code> .
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultMaxPercOfElapsedTimeForRefinement : this._maxPercOfElapsedTimeForRefinement); // Number
  },

  setMaxPercentageOfTotalAllowedTimeForRefinement : function(percentage)
  {
    // summary:
    //		Sets the maximum percentage of the total allowed time  that should
    //		be spent on the final refinement step when the layout mode is '
    //		ForceDirectedLayout.FAST_MULTILEVEL_MODE' . 
    // description:
    //		Sets the maximum percentage of the total allowed time  that should
    //		be spent on the final refinement step when the layout mode is <code>
    //		ForceDirectedLayout.FAST&#95;MULTILEVEL&#95;MODE</code> . 
    //		The parameter has no effect in other layout modes.  
    //		<p>
    //		If the specified value is negative, the value <code>0</code> is
    //		used.  
    //		</p>
    //		<p>
    //		The default value is <code>1O</code> percent. Increasing the value
    //		of this parameter may increase the quality of the  layout, possibly
    //		at the price of a lower speed.   
    //		</p>
    
    if (percentage != this._maxPercOfTotalAllowedTimeForRefinement)
    {
      if (percentage < 0) {
        percentage = 0;
      }
      this._maxPercOfTotalAllowedTimeForRefinement = percentage;
      this.onParameterChanged("MaxPercentageOfTotalAllowedTimeForRefinement");
    }
  },

  getMaxPercentageOfTotalAllowedTimeForRefinement : function()
  {
    // summary:
    //		Returns the upper limit for the duration of the finetuning step in 
    //		"fast multilevel" layout mode as percentage of the total allowed
    //		time.
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultMaxPercOfTotalAllowedTimeForRefinement : this._maxPercOfTotalAllowedTimeForRefinement); // Number
  },

  setMaxRepeatForConvergence : function(repeat)
  {
    // summary:
    //		Sets the maximum number of attempts to reach convergence at each
    //		step when the layout mode is '
    //		ForceDirectedLayout.FAST_MULTILEVEL_MODE' . 
    // description:
    //		Sets the maximum number of attempts to reach convergence at each
    //		step when the layout mode is <code>
    //		ForceDirectedLayout.FAST&#95;MULTILEVEL&#95;MODE</code> . 
    //		The parameter has no effect in other layout modes.  
    //		<p>
    //		If the specified value is less than <code>0</code>, the value
    //		<code>1</code>  is used.  
    //		</p>
    //		<p>
    //		The default value is <code>3</code>. Increasing the value of this
    //		parameter may increase the quality of the  layout, possibly at the
    //		price of a lower speed.   
    //		</p>
    
    if (repeat != this._maxRepeatForConvergence)
    {
      if (repeat < 1) {
        repeat = 1;
      }
      this._maxRepeatForConvergence = repeat;
      this.onParameterChanged("MaxRepeatForConvergence");
    }
  },

  getMaxRepeatForConvergence : function()
  {
    // summary:
    //		Returns the maximum number of attempts to reach convergence at each
    //		step when the layout mode is '
    //		ForceDirectedLayout.FAST_MULTILEVEL_MODE' . 
    // description:
    //		Returns the maximum number of attempts to reach convergence at each
    //		step when the layout mode is <code>
    //		ForceDirectedLayout.FAST&#95;MULTILEVEL&#95;MODE</code> .
    
    return (false ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultMaxRepeatForConvergence : this._maxRepeatForConvergence); // int
  },

  isLayoutTimeElapsedPackage : function()
  {
    // summary:
    //		This method is protected on GraphLayout, we need to provide a 
    //		package access.
    // tags:
    //		private
    
    return this.isLayoutTimeElapsed(); // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout,
{
  INCREMENTAL_MODE : null,

  NON_INCREMENTAL_MODE : null,

  FAST_MULTILEVEL_MODE : null,

  STRAIGHT_LINE_STYLE : null,

  NO_RESHAPE_STYLE : null,

  _defaultNumberOfIterations : null,

  _defaultConvergenceThreshold : null,

  _defaultMaxAllowedMovePerIteration : null,

  _defaultPreferredLinksLength : null,

  _defaultPreferredIndividualLinksLength : null,

  _defaultNodeDistanceThreshold : null,

  _defaultIsForceFitToLayoutRegion : null,

  _defaultRespectNodeSizes : null,

  _defaultAdditionalNodeRepulsionWeight : null,

  _defaultLinkLengthWeight : null,

  _defaultLayoutMode : null,

  _defaultMaxPercOfElapsedTimeForRefinement : null,

  _defaultMaxPercOfTotalAllowedTimeForRefinement : null,

  _defaultMaxRepeatForConvergence : null,

  LINK_LENGTH_PROPERTY : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout;
    if(ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._fields_init)
      ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._fields_init(c);
    
    c.INCREMENTAL_MODE = 10;
    c.NON_INCREMENTAL_MODE = 11;
    c.FAST_MULTILEVEL_MODE = 12;
    c.STRAIGHT_LINE_STYLE = ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE;
    c.NO_RESHAPE_STYLE = ibm_ilog.graphlayout.internalutil.LinkStyles.NO_RESHAPE_STYLE;
    c._defaultNumberOfIterations = 1000;
    c._defaultConvergenceThreshold = 1;
    c._defaultMaxAllowedMovePerIteration = 5;
    c._defaultPreferredLinksLength = 60;
    c._defaultPreferredIndividualLinksLength = -1;
    c._defaultNodeDistanceThreshold = 30;
    c._defaultIsForceFitToLayoutRegion = false;
    c._defaultRespectNodeSizes = false;
    c._defaultAdditionalNodeRepulsionWeight = 0.2;
    c._defaultLinkLengthWeight = 1;
    c._defaultLayoutMode = ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.INCREMENTAL_MODE;
    c._defaultMaxPercOfElapsedTimeForRefinement = 1000.0;
    c._defaultMaxPercOfTotalAllowedTimeForRefinement = 10;
    c._defaultMaxRepeatForConvergence = 3;
    c.LINK_LENGTH_PROPERTY = "PreferredLength";
  }
  
}
);

ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'allowedTime', defaultValue: 32000 },
    { name: 'layoutRegion', defaultValue: null },
    { name: 'layoutOfConnectedComponentsEnabled', defaultValue: true },
    { name: 'convergenceThreshold', defaultValue: 1 },
    { name: 'maxAllowedMovePerIteration', defaultValue: 5 },
    { name: 'forceFitToLayoutRegion', defaultValue: false },
    { name: 'preferredLinksLength', defaultValue: 60 },
    { name: 'layoutMode', defaultValue: ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.INCREMENTAL_MODE },
    { name: 'nodeDistanceThreshold', defaultValue: 30 },
    { name: 'respectNodeSizes', defaultValue: true },
    { name: 'linkLengthWeight', defaultValue: 1 },
    { name: 'additionalNodeRepulsionWeight', defaultValue: 0.2 },
    { name: 'allowedNumberOfIterations', defaultValue: 1000 },
    { name: 'maxPercentageOfElapsedTimeForRefinement', defaultValue: 1000 },
    { name: 'maxPercentageOfTotalAllowedTimeForRefinement', defaultValue: 10 },
    { name: 'maxRepeatForConvergence', defaultValue: 3 }
  ];
  var baseProperties = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._getNodeProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._getNodeProperties();
};

ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'preferredLength', defaultValue: -1 }
  ];
  var baseProperties = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

(function(){ ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.forcedirected._ForceDirectedLayout");});
require(["ibm_ilog/graphlayout/forcedirected/_ForceDirectedLayout"]);

},
'ibm_ilog*graphlayout/forcedirected/MultilevelGraphPartitioningAlgo':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/forcedirected/FMMAlgorithm","ibm_ilog/graphlayout/forcedirected/ForceDirectedLayout","ibm_ilog/graphlayout/forcedirected/GraphCoarseningAlgo","ibm_ilog/graphlayout/forcedirected/SolarSystemNode","ibm_ilog/graphlayout/internalutil/GraphModelUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraph","ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractGraphAdapter","ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractLink","ibm_ilog/graphlayout/internalutil/LogResUtil"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.SolarSystemNode');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo', null, 
{
  // summary:
  //		Partitions the graph for the FMM algo.  
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  run : function(graphModel, graphs, models)
  {
    // summary:
    //		Creates the multilevel partitioning of the graph described by the
    //		given model. 
    // description:
    //		Creates the multilevel partitioning of the graph described by the
    //		given model. 
    //		The method fills the lists <code>graphs</code> and
    //		<code>models</code>.
    
    var graph = new ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph(graphModel);
    graphs.push(graph);

    models.push(new ibm_ilog.graphlayout.forcedirected.FMMAlgorithm.TopLevelAbstractGraphAdapter(graph, graphModel));
    var coarseningAlgo = new ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo();
    this.fill(graph, graphModel);

    while (graph.getNodesCount() > 10)
    {
      graph = coarseningAlgo.createCoarserGraph(graph, graphModel);
      if (graph.getNodesCount() < 3 || graph.getLinksCount() < 3) {
        break;
      }
      graphs.push(graph);
      models.push(new ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter(graph));
    }
  },

  fill : function(graph, graphModel)
  {
    // summary:
    //		Creates an abstract graph from a given graph model. 
    // description:
    //		Creates an abstract graph from a given graph model. 
    //		The following links are filtered out: - Self-links. - Multilinks
    //		(only one link between the same pair of nodes).
    // tags:
    //		private
    
    var nodes = new ibm_ilog.graphlayout.internalutil.ArrayIterator(graphModel.getNodes());

    while (nodes.hasNext())
    {
      var node = nodes.next();
      var abstractNode = new ibm_ilog.graphlayout.forcedirected.SolarSystemNode(node, ibm_ilog.graphlayout.internalutil.GraphModelUtil.getObjectBounds(graphModel,
              node));
      graphModel.setParameter(node, ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo.ABSTRACT_NODE, abstractNode);
      graph.addNode(abstractNode);
    }

    var links = new ibm_ilog.graphlayout.internalutil.ArrayIterator(graphModel.getLinks());

    while (links.hasNext())
    {
      var link = links.next();
      var from = graphModel.getFrom(link);
      var toobj = graphModel.getTo(link);

      if (from != toobj)
      {
        var abstractFrom = graphModel.getParameter(from, ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo.ABSTRACT_NODE);
        var abstractTo = graphModel.getParameter(toobj, ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo.ABSTRACT_NODE);

        if (abstractFrom == abstractTo)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6761E");
        }

        if (!graph.isLinkBetween(abstractFrom, abstractTo))
        {
          var abstractLink = new ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink(abstractFrom, abstractTo);

          graph.addLink(abstractLink);
          abstractLink.setUserData(link);
          abstractLink.setOriginalObject(link);
        }
      }
    }

    nodes = new ibm_ilog.graphlayout.internalutil.ArrayIterator(graphModel.getNodes());

    while (nodes.hasNext())
    {
      var no = nodes.next();
      graphModel.setParameter(no, ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo.ABSTRACT_NODE, null);
    }
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo,
{
  ABSTRACT_NODE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo;
    
    c.ABSTRACT_NODE = "__abstractNode";
  }
  
}
);

(function(){ ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo");});
require(["ibm_ilog/graphlayout/forcedirected/MultilevelGraphPartitioningAlgo"]);

},
'ibm_ilog*graphlayout/forcedirected/ForceDirectedLayoutReport':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/GraphLayoutReport"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected.ForceDirectedLayoutReport", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayoutReport');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.GraphLayoutReport');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayoutReport', ibm_ilog.graphlayout.GraphLayoutReport, 
{
  // summary:
  //		The class used to store information about the behavior of the '
  //		ForceDirectedLayout'. 
  // description:
  //		The class used to store information about the behavior of the <code>
  //		ForceDirectedLayout</code>.
  
  _numberOfIterations : null,
  _maxMovePerIteration : null,

  constructor : function()
  {
    this._numberOfIterations = 0;
    this._maxMovePerIteration = 0;
  },
  
  setNumberOfIterations : function(number)
  {
    // summary:
    // tags:
    //		private
    
    this._numberOfIterations = number;
  },

  getNumberOfIterations : function()
  {
    // summary:
    //		Returns the number of performed iterations. 
    // description:
    //		Returns the number of performed iterations.
    
    return this._numberOfIterations; // int
  },

  setMaxMovePerIteration : function(maxMove)
  {
    // summary:
    // tags:
    //		private
    
    this._maxMovePerIteration = maxMove;
  },

  getMaxMovePerIteration : function()
  {
    // summary:
    //		Returns the maximum displacement of the nodes at the last  performed
    //		iteration of the layout algorithm. 
    // description:
    //		Returns the maximum displacement of the nodes at the last  performed
    //		iteration of the layout algorithm.
    
    return this._maxMovePerIteration; // Number
  }

}
);

return dojo.getObject("ibm_ilog.graphlayout.forcedirected.ForceDirectedLayoutReport");});
require(["ibm_ilog/graphlayout/forcedirected/ForceDirectedLayoutReport"]);

},
'ibm_ilog*graphlayout/forcedirected/MultipoleULELayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/forcedirected/ForceDirectedLayout","ibm_ilog/graphlayout/forcedirected/GraphCoarseningAlgo","ibm_ilog/graphlayout/forcedirected/ULEAlgorithm","ibm_ilog/graphlayout/internalutil/GraphModelUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractLink","ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractNode","ibm_ilog/graphlayout/internalutil/LogResUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected.MultipoleULELayout", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.forcedirected.MultipoleULELayout');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.ULEAlgorithm');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.forcedirected.MultipoleULELayout', ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, 
{
  // summary:
  //		Multiple ULE layout. 
  // description:
  //		Multiple ULE layout. 
  //		
  // tags:
  //		private
  
  _originalUle: null,

  _childGraph: null,

  _algo: null,

  constructor : function(originalUle)
  {
    if (originalUle == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6762E");
    }

    this._originalUle = originalUle;
  },
  
  createULEAlgorithm : function()
  {
    this._algo = new ibm_ilog.graphlayout.forcedirected.MultipoleULEAlgorithm(this);
    return this._algo; // ibm_ilog.graphlayout.forcedirected.ULEAlgorithm
  },

  setULEMode : function(s)
  {
    this._algo._uleMode = s;
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    
    if (nodeOrLink instanceof ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode) {
      nodeOrLink = (nodeOrLink).getOriginalObject();
    }
    return this._originalUle.isFixed(nodeOrLink); // Boolean
  },

  getPreferredLength : function(link)
  {
    // summary:
    
    if (link instanceof ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink)
    {
      link = (link).getOriginalObject();

      if (link == null)
      {
        return ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultPreferredIndividualLinksLength; // Number
      }
    }

    return this._originalUle.getPreferredLength(link); // Number
  },

  performLayout : function(childGraph, isSmallestGraph, redraw)
  {
    // summary:
    
    this._childGraph = childGraph;

    return this.inherited("performLayout", arguments, [true]); // ibm_ilog.graphlayout.GraphLayoutReport
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.MultipoleULELayout,
{
  DEPTH : null,

  RESCALE_FACTOR : null,

  ITERATE_OVER_NODES : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.forcedirected.MultipoleULELayout;
    if(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._fields_init)
      ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._fields_init(c);
    
    c.DEPTH = 1;
    c.RESCALE_FACTOR = 1.5;
    c.ITERATE_OVER_NODES = false;
  }
  
}
);

ibm_ilog.graphlayout.forcedirected.MultipoleULELayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._getGlobalProperties();
};

ibm_ilog.graphlayout.forcedirected.MultipoleULELayout._getNodeProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._getNodeProperties();
};

ibm_ilog.graphlayout.forcedirected.MultipoleULELayout._getLinkProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._getLinkProperties();
};

dojo.declare('ibm_ilog.graphlayout.forcedirected.MultipoleULEAlgorithm', ibm_ilog.graphlayout.forcedirected.ULEAlgorithm, 
{
  _nodeList: null,
  _vectDx: null,
  _vectDy: null,

  _uleMode : null,

  constructor : function(layout)
  {
    this._uleMode = false;
  },
  
  detach : function()
  {
    this._vectDx = null;
    this._vectDy = null;
    this.inherited("detach", arguments, []);
  },

  initializeDataStructures : function()
  {
    this.inherited("initializeDataStructures", arguments, []);

    if (!this._uleMode)
    {
      var nNodes = this._topologicalData.getNumberOfNodes();

      if (this._vectDx == null || nNodes != this._vectDx.length)
      {
        this._vectDx = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, 0);
        this._vectDy = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, 0);
      }
      else
      {
        for (var i = 0; i < nNodes; i++)
        {
          this._vectDx[i] = 0;
          this._vectDy[i] = 0;
        }
      }
    }
  },

  init : function()
  {
    this.inherited("init", arguments, []);

    if (!this._uleMode)
    {
      var multipoleUle = this.getOriginalUle();
      var childGraph = multipoleUle._childGraph;
      if (childGraph != null) {
        this.initGraph(childGraph);
      }
    }
  },

  clean : function()
  {
    this.inherited("clean", arguments, []);
    this._nodeList = null;
  },

  getPreprocessingMode : function()
  {
    return ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.HIERARCHICAL_PREPROCESSING; // int
  },

  doLayout : function(redraw)
  {
    if (!this._uleMode) {
      this._positionData.rescale(ibm_ilog.graphlayout.forcedirected.MultipoleULELayout.RESCALE_FACTOR);
    }
    try
    {
      this.inherited("doLayout", arguments, [redraw]);
    }
    finally
    {
      this._uleMode = false;
    }
  },

  initGraph : function(childGraph)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var nNodes = childGraph.getNodesCount();
    var nLinks = childGraph.getLinksCount();
    var nNodesInOrigGraph = this._ule.getGraphModel().getNodesCount();

    if (nLinks < 3 || nNodes < 3)
    {
      this._nodeList = null;
      return;
    }

    var list = null;

    if (ibm_ilog.graphlayout.forcedirected.MultipoleULELayout.ITERATE_OVER_NODES)
    {
      this._nodeList = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, null);
      var nodeCounter = 0;
      var nodes = childGraph.getNodes();
      var neigh;
      var neighBis;

      while (nodes.hasNext())
      {
        var node = nodes.next();
        list = new Array();
        this._nodeList[nodeCounter++] = list;

        var nodeneighbs = childGraph.getNeighbors(node);

        while (nodeneighbs.hasNext())
        {
          neigh = nodeneighbs.next();

          if (neigh != node)
          {
            this.fill(list, neigh);

            if (ibm_ilog.graphlayout.forcedirected.MultipoleULELayout.DEPTH == 2)
            {
              var neighbsBis = childGraph.getNeighbors(neigh);

              while (neighbsBis.hasNext())
              {
                neighBis = neighbsBis.next();
                if (neighBis != node && neighBis != neigh) {
                  this.fill(list, neighBis);
                }
              }
            }
          }
        }

        if (list.length > (nNodesInOrigGraph * 0.3))
        {
          this._nodeList = null;
          return;
        }
      }
    }
    else
    {
      this._nodeList = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nLinks, null);
      var linkCounter = 0;
      var links = childGraph.getLinks();

      while (links.hasNext())
      {
        var link = links.next();
        list = new Array();
        this._nodeList[linkCounter++] = list;

        if (ibm_ilog.graphlayout.forcedirected.MultipoleULELayout.DEPTH == 1)
        {
          this.fill(list, childGraph.getFrom(link));
          this.fill(list, childGraph.getTo(link));
        }
        else
        {
          var fromNode = childGraph.getFrom(link);
          var toNode = childGraph.getTo(link);
          this.fill(list, fromNode);
          this.fill(list, toNode);
          var neighbs = childGraph.getNeighbors(fromNode);
          var neighb = null;

          while (neighbs.hasNext())
          {
            neighb = neighbs.next();
            if (neighb != toNode) {
              this.fill(list, neighb);
            }
          }

          neighbs = childGraph.getNeighbors(toNode);

          while (neighbs.hasNext())
          {
            neighb = neighbs.next();
            if (neighb != fromNode) {
              this.fill(list, neighb);
            }
          }
        }

        if (list.length > (nNodesInOrigGraph * 0.3))
        {
          this._nodeList = null;
          return;
        }
      }
    }
  },

  fill : function(list, node)
  {
    var solarSystemNode = node.getTargetObject();

    var id = this._layoutData.getIntIdentifier(solarSystemNode);
    list.push((id));
    var planets = ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.getPlanets(solarSystemNode);

    var pNode;
    var mNode;

    if (planets != null)
    {
      var _for_each_array_1 = planets;
      for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
      {
        var opNode = _for_each_array_1[_for_each_index_1];
        pNode = opNode;
        id = this._layoutData.getIntIdentifier(pNode);
        list.push((id));
        var moons = ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.getMoons(pNode);

        if (moons != null)
        {
          var _for_each_array_2 = moons;
          for (var _for_each_index_2 = 0; _for_each_index_2 < _for_each_array_2.length; _for_each_index_2++)
          {
            var omNode = _for_each_array_2[_for_each_index_2];
            mNode = omNode;
            id = this._layoutData.getIntIdentifier(mNode);
            list.push((id));
          }
        }
      }
    }
  },

  computeNodeForces : function(minNodeDist, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random)
  {
    if (this._nodeList == null || this._uleMode)
    {
      this.inherited("computeNodeForces", arguments, [minNodeDist, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random]);
      return;
    }

    var vx = 0;
    var vy = 0;
    var dx = 0;
    var dy = 0;
    var dx1 = 0;
    var dy1 = 0;
    var f;
    var len;
    var sqrtLen;
    var minDistWeight = additionalNodeRepulsionWeight / 3;
    var desiredMinDist = minNodeDist;
    var randomValueRange = convergenceThreshold * 2;
    var nTotalNodes = this._topologicalData.getNumberOfNodes();
    var nodeId1;

    for (nodeId1 = 0; nodeId1 < nTotalNodes; nodeId1++)
    {
      this._vectDx[nodeId1] = 0;
      this._vectDy[nodeId1] = 0;
    }

    var vectNodesPositionX = this._positionData.getVectNodesPositionX();
    var vectNodesPositionY = this._positionData.getVectNodesPositionY();
    var n = this._nodeList.length;

    for (var i = 0; i < n; i++)
    {
      var list = this._nodeList[i];
      var nNodes = (list != null ? list.length : 0);

      for (var j = 0; j < nNodes; j++)
      {
        nodeId1 =  (list[j]);

        dx = this._vectDx[nodeId1];
        dy = this._vectDy[nodeId1];

        for (var k = 0; k < nNodes; k++)
        {
          var nodeId2 =  (list[k]);
          if (nodeId1 == nodeId2) {
            continue;
          }
          vx = vectNodesPositionX[nodeId1] - vectNodesPositionX[nodeId2];
          vy = vectNodesPositionY[nodeId1] - vectNodesPositionY[nodeId2];
          len = vx * vx + vy * vy;

          if (minDistWeight > 0)
          {
            sqrtLen = Math.sqrt(len);
            sqrtLen = ((sqrtLen == 0) ? 0.0001 : sqrtLen);
            if (respectNodeSizes) {
              desiredMinDist = minNodeDist + this._vectHalfNodeDiag[nodeId1] + this._vectHalfNodeDiag[nodeId2];
            }
            if (sqrtLen < desiredMinDist)
            {
              f = (minDistWeight * ((desiredMinDist - sqrtLen) / sqrtLen));
              dx1 = f * vx;
              dy1 = f * vy;
              this._vectNodesDx[nodeId1] += dx1;
              this._vectNodesDy[nodeId1] += dy1;
              this._vectNodesDx[nodeId2] -= dx1;
              this._vectNodesDy[nodeId2] -= dy1;
            }
          }

          if (len <= ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
          {
            dx += this.getRandomValue(randomValueRange, random);
            dy += this.getRandomValue(randomValueRange, random);
            dx += vx / 3;
            dy += vy / 3;
          }
          else
          {
            dx += vx / len;
            dy += vy / len;
          }

          this._vectDx[nodeId1] = dx;
          this._vectDy[nodeId1] = dy;
        }
      }
    }

    for (nodeId1 = 0; nodeId1 < nTotalNodes; nodeId1++)
    {
      dx = this._vectDx[nodeId1];
      dy = this._vectDy[nodeId1];
      var dlen = dx * dx + dy * dy;

      if (dlen <= ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
      {
        this._vectNodesDx[nodeId1] += this.getRandomValue(randomValueRange, random);
        this._vectNodesDy[nodeId1] += this.getRandomValue(randomValueRange, random);
      }
      else
      {
        dlen = Math.sqrt(dlen) / 2;

        if (dlen > ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
        {
          this._vectNodesDx[nodeId1] += dx / dlen;
          this._vectNodesDy[nodeId1] += dy / dlen;
        }
      }
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  }

}
);

(function(){ ibm_ilog.graphlayout.forcedirected.MultipoleULELayout._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.forcedirected.MultipoleULELayout");});
require(["ibm_ilog/graphlayout/forcedirected/MultipoleULELayout"]);

},
'ibm_ilog*graphlayout/forcedirected/SolarSystemNode':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/internalutil/GraphModelUtil","ibm_ilog/graphlayout/internalutil/TranslateUtil","ibm_ilog/graphlayout/internalutil/genericgrapher/AbstractNode"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected.SolarSystemNode", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.forcedirected.SolarSystemNode');


 builder delete end */
///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

 builder delete end */
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode');


 builder delete end */
dojo.declare('ibm_ilog.graphlayout.forcedirected.SolarSystemNode', ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode, 
{
  // summary:
  //		The class that represents a solar system (in the sense of the FMMM
  //		algo) in the generic abstract graph. 
  // description:
  //		The class that represents a solar system (in the sense of the FMMM
  //		algo) in the generic abstract graph. 
  //		
  // tags:
  //		private
  
  _type : null,

  constructor : function(node, bbox)
  {
    this._type = ibm_ilog.graphlayout.forcedirected.SolarSystemNode.MOON_NODE;
  },
  
  setType : function(type)
  {
    this._type = type;
  },

  getType : function()
  {
    return this._type; // int
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.SolarSystemNode,
{
  SUN_NODE : null,
  PLANET_NODE : null,
  PLANET_WITH_MOON_NODE : null,
  MOON_NODE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.forcedirected.SolarSystemNode;
    if(ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode._fields_init)
      ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode._fields_init(c);
    
    c.SUN_NODE = 0;
    c.PLANET_NODE = 1;
    c.PLANET_WITH_MOON_NODE = 2;
    c.MOON_NODE = 3;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.forcedirected.SolarSystemNode._fields_init(); })();

return dojo.getObject("ibm_ilog.graphlayout.forcedirected.SolarSystemNode");});
require(["ibm_ilog/graphlayout/forcedirected/SolarSystemNode"]);

},
'ibm_ilog*graphlayout/forcedirected/ForceDirectedLayout':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/forcedirected/_ForceDirectedLayout","ibm_ilog/graphlayout/forcedirected/MultipoleULELayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout", 1);
/* builder delete begin
dojo.provide("ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout");

 builder delete end */
/* builder delete begin
dojo.require("ibm_ilog.graphlayout.forcedirected._ForceDirectedLayout");

 builder delete end */
/* builder delete begin
dojo.require("ibm_ilog.graphlayout.forcedirected.MultipoleULELayout");

 builder delete end */

return dojo.getObject("ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout");});
require(["ibm_ilog/graphlayout/forcedirected/ForceDirectedLayout"]);

},
'ibm_ilog*graphlayout/layer_forcedirected':function(){
define(["dojo","dijit","dojox","ibm_ilog/graphlayout/forcedirected/MultipoleULELayout","ibm_ilog/graphlayout/forcedirected/_ForceDirectedLayout"], function(dojo, dijit, dojox){
dojo.getObject("ibm_ilog.graphlayout.layer_forcedirected", 1);
/* builder delete begin
dojo.provide('ibm_ilog.graphlayout.layer_forcedirected');


 builder delete end */
// The MultipoleULELayout class will pull out the rest of classes
// required for the force-directed layer in the right order

/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected.MultipoleULELayout');



 builder delete end */
// The commented classes are included by the classes in the first
// group. I left them just for reference

// dojo.require('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm');
/* builder delete begin
dojo.require('ibm_ilog.graphlayout.forcedirected._ForceDirectedLayout');

 builder delete end */
// dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');
// dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayoutReport');
// dojo.require('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo');
// dojo.require('ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo');
// dojo.require('ibm_ilog.graphlayout.forcedirected.RegularizationAlgo');
// dojo.require('ibm_ilog.graphlayout.forcedirected.SolarSystemNode');
// dojo.require('ibm_ilog.graphlayout.forcedirected.ULEAlgorithm');

return dojo.getObject("ibm_ilog.graphlayout.layer_forcedirected");});
require(["ibm_ilog/graphlayout/layer_forcedirected"]);

}}});

define([], 1);
