/*
	Copyright (c) 2004-2010, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is an optimized version of Dojo, built for deployment and not for
	development. To get sources and documentation, please visit:

		http://dojotoolkit.org
*/

dojo.provide("ibm_ilog.graphlayout.ibm_graphlayout_basiclinkstyle");
if(!dojo._hasResource['ibm_ilog.graphlayout.internalutil.BundlingModes']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.graphlayout.internalutil.BundlingModes'] = true;
dojo.provide('ibm_ilog.graphlayout.internalutil.BundlingModes');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------





dojo.declare('ibm_ilog.graphlayout.internalutil.BundlingModes', null, 
{
  // summary:
  //		This class contains all enumeration constants used for multilink
  //		bundling. 
  // description:
  //		This class contains all enumeration constants used for multilink
  //		bundling. 
  //		This occurs mainly for the straight line link styles (TML, Uniform,
  //		Circular). It also contains some generic support for the modes.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.BundlingModes,
{
  NO_BUNDLE : null,
  STRAIGHT_LINE_BUNDLE : null,
  NARROW_STRAIGHT_LINE_BUNDLE : null,
  CONNECTED_ONE_BEND_BUNDLE : null,
  FREE_ONE_BEND_BUNDLE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.BundlingModes;
    
    c.NO_BUNDLE = ibm_ilog.graphlayout.internalutil.LinkStyles.NO_RESHAPE_STYLE;
    c.STRAIGHT_LINE_BUNDLE = ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE;
    c.NARROW_STRAIGHT_LINE_BUNDLE = 10;
    c.CONNECTED_ONE_BEND_BUNDLE = 11;
    c.FREE_ONE_BEND_BUNDLE = 12;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.BundlingModes._fields_init(); })();

}

if(!dojo._hasResource['ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions'] = true;
dojo.provide('ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------




dojo.declare('ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions', null, 
{
  // summary:
  //		This class contains all enumeration constants used for distributions
  //		of self-links multilink bundles. 
  // description:
  //		This class contains all enumeration constants used for distributions
  //		of self-links multilink bundles. 
  //		Those bundles are attached at reference points, and conceptually form
  //		3/4 circles, and the distribution specifies whether the multiple
  //		links are distributed towards the outer (that is, the smallest circle
  //		is at the reference points), towards the inner (that is, the largest
  //		circle is at the refernece points), or centered.  This occurs mainly
  //		for the straight line link styles (TML, Uniform, Circular). It also
  //		contains some generic support for the enums.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions,
{
  CENTERED : null,
  OUTER : null,
  INNER : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions;
    
    c.CENTERED = 0;
    c.OUTER = 1;
    c.INNER = 2;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions._fields_init(); })();

}

if(!dojo._hasResource['ibm_ilog.graphlayout.internalutil.SelfLinkOrientations']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.graphlayout.internalutil.SelfLinkOrientations'] = true;
dojo.provide('ibm_ilog.graphlayout.internalutil.SelfLinkOrientations');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------




dojo.declare('ibm_ilog.graphlayout.internalutil.SelfLinkOrientations', null, 
{
  // summary:
  //		This class contains all enumeration constants used for orientations
  //		of self-links. 
  // description:
  //		This class contains all enumeration constants used for orientations
  //		of self-links. 
  //		This occurs mainly for the straight line link styles (TML, Uniform,
  //		Circular). It also contains some generic support for the enums.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.SelfLinkOrientations,
{
  CLOCK_WISE : null,
  COUNTER_CLOCK_WISE : null,
  HORIZONTAL_TO_VERTICAL : null,
  VERTICAL_TO_HORIZONTAL : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.SelfLinkOrientations;
    
    c.CLOCK_WISE = 0;
    c.COUNTER_CLOCK_WISE = 1;
    c.HORIZONTAL_TO_VERTICAL = 2;
    c.VERTICAL_TO_HORIZONTAL = 3;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.SelfLinkOrientations._fields_init(); })();

}

if(!dojo._hasResource['ibm_ilog.graphlayout.internalutil.MultiAndSelfLinkUtil']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.graphlayout.internalutil.MultiAndSelfLinkUtil'] = true;
dojo.provide('ibm_ilog.graphlayout.internalutil.MultiAndSelfLinkUtil');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------











dojo.declare('ibm_ilog.graphlayout.internalutil.MultiAndSelfLinkUtil', null, 
{
  // summary:
  //		Utilities to route multilinks and self-links. 
  // description:
  //		Utilities to route multilinks and self-links. 
  //		
  // tags:
  //		private
  
  _layout: null,
  _model: null,
  _multiLinkOffset : null,
  _multiLinkMaxSpread : null,
  _selfLinkOffset : null,
  _selfLinkMaxSpread : null,
  _selfLinkAttachRelativeX : null,
  _selfLinkAttachRelativeY : null,
  _selfLinkAttachAbsoluteX : null,
  _selfLinkAttachAbsoluteY : null,
  _selfLinkSpacing : null,
  _connectToCenter : null,
  _allowedSelfLinkCorners : null,
  _boundingBoxes : null,

  constructor : function(graphLayout)
  {
    this._multiLinkOffset = 5;
    this._multiLinkMaxSpread = 50;
    this._selfLinkOffset = 5;
    this._selfLinkMaxSpread = 50;
    this._selfLinkAttachRelativeX = 0.5;
    this._selfLinkAttachRelativeY = 0.5;
    this._selfLinkAttachAbsoluteX = 0;
    this._selfLinkAttachAbsoluteY = 0;
    this._selfLinkSpacing = -1;
    this._connectToCenter = false;
    this._allowedSelfLinkCorners = 0x0;
    this._boundingBoxes = new ibm_ilog.graphlayout.internalutil.HashTable();
    this._layout = graphLayout;
    this._model = graphLayout.getGraphModel();
  },
  
  setMultiLinkOffset : function(offset)
  {
    // summary:
    //		Sets the multi link offset. 
    // description:
    //		Sets the multi link offset. 
    //		This offset can be additionally limited by the node bounds and the
    //		max spread.
    // tags:
    //		private
    
    this._multiLinkOffset = offset;
  },

  setMultiLinkMaxSpread : function(spread)
  {
    // summary:
    //		Sets the multi link maximal spread. 
    // description:
    //		Sets the multi link maximal spread. 
    //		If we have n multilinks, then n * offset should be less than
    //		maxSpread.
    // tags:
    //		private
    
    this._multiLinkMaxSpread = spread;
  },

  setSelfLinkOffset : function(offset)
  {
    // summary:
    //		Sets the self-link offset if the self-links are multi links. 
    // description:
    //		Sets the self-link offset if the self-links are multi links. 
    //		This offset can be additionally limited by the node bounds and the
    //		max spread.
    // tags:
    //		private
    
    this._selfLinkOffset = offset;
  },

  setSelfLinkMaxSpread : function(spread)
  {
    // summary:
    //		Sets the self-link maximal spread if the self-links are multi links.
    //		
    // description:
    //		Sets the self-link maximal spread if the self-links are multi links.
    //		
    //		If we have n multiple self-links, then n * offset should be less
    //		than maxSpread.
    // tags:
    //		private
    
    this._selfLinkMaxSpread = spread;
  },

  setSelfLinkSpacing : function(spacing)
  {
    // summary:
    //		Sets the self-link spacing, that is, the minimal distance the self
    //		link extends at the border of the node. 
    // description:
    //		Sets the self-link spacing, that is, the minimal distance the self
    //		link extends at the border of the node. 
    //		If negative, the spacing is ignored and an appropriate spacing is
    //		calculated from the node size and attachment points.
    // tags:
    //		private
    
    this._selfLinkSpacing = spacing;
  },

  setConnectToCenter : function(toCenter)
  {
    // summary:
    //		Sets whether the link should connect to center instead of the border
    //		of the bounding box. 
    // description:
    //		Sets whether the link should connect to center instead of the border
    //		of the bounding box. 
    //		This option has no effect if link clipping is enabled.
    // tags:
    //		private
    
    this._connectToCenter = toCenter;
  },

  setAllowedSelfLinkCorners : function(bitmask)
  {
    // summary:
    //		Sets which corners are allowed. 
    // description:
    //		Sets which corners are allowed. 
    //		This is a bitmask. 8 = top left, 4 = top right, 2 = bottom right, 1
    //		= bottom left.
    // tags:
    //		private
    
    this._allowedSelfLinkCorners = bitmask;
  },

  setSelfLinkAttachXPosition : function(rel, abs)
  {
    // summary:
    //		Sets the position of the base attachment point at the top or bottom
    //		side. 
    // description:
    //		Sets the position of the base attachment point at the top or bottom
    //		side. 
    //		The position is calculated from the sum of relative offset (a
    //		fraction of the width) and absolute offset.  
    // rel: Number
    //		The relative offset between 0 and 1 (0 and 100% of the node
    //		width).
    // abs: Number
    //		The absolute offset
    // tags:
    //		private
    
    this._selfLinkAttachRelativeX = rel;
    this._selfLinkAttachAbsoluteX = abs;
  },

  setSelfLinkAttachYPosition : function(rel, abs)
  {
    // summary:
    //		Sets the position of the base attachment point at the left or right
    //		side. 
    // description:
    //		Sets the position of the base attachment point at the left or right
    //		side. 
    //		The position is calculated from the sum of relative offset (a
    //		fraction of the height) and absolute offset.  
    // rel: Number
    //		The relative offset between 0 and 1 (0 and 100% of the node
    //		height).
    // abs: Number
    //		The absolute offset
    // tags:
    //		private
    
    this._selfLinkAttachRelativeY = rel;
    this._selfLinkAttachAbsoluteY = abs;
  },

  accept : function(link)
  {
    // summary:
    //		Whether the link should be treated as multilink.
    // tags:
    //		private
    
    if (this._layout.supportsPreserveFixedLinks() && this._layout.isPreserveFixedLinks() && this._layout.isFixed(link)) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  boundingBox : function(node)
  {
    // summary:
    //		Returns the bounding box of a node.
    // tags:
    //		private
    
    var r = this._boundingBoxes.item(node);

    if (r == null)
    {
      r = ibm_ilog.graphlayout.internalutil.GraphModelUtil.getObjectBounds(this._model, node);
      this._boundingBoxes.add(node, r);
    }

    return r; // Rectangle
  },

  getNodeCenter : function(node)
  {
    // summary:
    //		Returns the virtual center of a node.
    // tags:
    //		private
    
    var bbox = this.boundingBox(node);
    var xoffset = 0.0;
    var yoffset = 0.0;
    var cboxIfc = this._layout.getLinkConnectionBoxInterface();

    if (this._layout.supportsLinkConnectionBox() && cboxIfc != null)
    {
      bbox = cboxIfc.getBox(this._model, node);
      xoffset = 0.5 * (cboxIfc.getTangentialOffset(this._model, node, ibm_ilog.graphlayout.Direction.TOP) + cboxIfc.getTangentialOffset(this._model, node, ibm_ilog.graphlayout.Direction.BOTTOM));
      yoffset = 0.5 * (cboxIfc.getTangentialOffset(this._model, node, ibm_ilog.graphlayout.Direction.LEFT) + cboxIfc.getTangentialOffset(this._model, node, ibm_ilog.graphlayout.Direction.RIGHT));
    }

    return new ibm_ilog.graphlayout.internalutil.Point(bbox.x + 0.5 * bbox.width + xoffset, bbox.y + 0.5 * bbox.height + yoffset); // Point
  },

  usePreciseClipping : function()
  {
    // summary:
    //		Decides whether to use precise clipping or only clipping at the
    //		bounding box. 
    // description:
    //		Decides whether to use precise clipping or only clipping at the
    //		bounding box. 
    //		If precise clipping is used, it calls  <code>
    //		MultiAndSelfLinkUtil.clipLink()</code> after reshaping the link.
    //		Otherwise it calls <code>
    //		MultiAndSelfLinkUtil.getClippedConnectionPoint()</code> before
    //		reshaping the link.
    // tags:
    //		private
    
    return false;
    
  },

  getClippedConnectionPoint : function(link, origin, fromPoint, toPoint)
  {
    // summary:
    //		Returns the clipped connection point of a straight link at the given
    //		side, if the link starts at fromPoint and ends at toPoint.
    // tags:
    //		private
    
    if (origin) {
      return ibm_ilog.diagram.util.ClippingUtil.getClippedPoint(this.boundingBox(this._model.getFrom(link)), fromPoint, toPoint); // Point
    }
    else {
      return ibm_ilog.diagram.util.ClippingUtil.getClippedPoint(this.boundingBox(this._model.getTo(link)), toPoint, fromPoint); // Point
    }
  },

  collectMultilinks : function(listOfMultilinkLists, multiLinks, undirected, selfLinks)
  {
    // summary:
    //		Collects all accepted multilinks into the input list. 
    // description:
    //		Collects all accepted multilinks into the input list. 
    //		At the end, the input list is filled with array lists of multilinks.
    //		 
    // linkOfMultilinkLists:
    //		Container for the result.
    // multiLinks: Array
    //		Container that can act as marker for multilinks. Can
    //		be null.
    // undirected: Boolean
    //		Whether the direction of the link plays a role.
    // selfLinks: Boolean
    //		Whether self-links are included.
    // tags:
    //		private
    
    var markedNodes = new Array();
    var aux;
    var links;
    var e1 = new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getNodes());
    var node = null;
    var link = null;
    var otherNode = null;

    while (e1.hasNext())
    {
      node = e1.next();
      if (undirected) {
        ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(markedNodes, node);
      }
      var nodesToLinks = new ibm_ilog.graphlayout.internalutil.HashTable();
      var e2 = (new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getLinksFrom(node)));

      while (e2.hasNext())
      {
        link = e2.next();
        if (!this.accept(link)) {
          continue;
        }
        otherNode = this._model.getTo(link);

        if (otherNode == node)
        {
          if (selfLinks)
          {
            aux = nodesToLinks.item(node);

            if (aux == null)
            {
              nodesToLinks.add(node, link);
            }
            else if (aux instanceof Array)
            {
              (aux).push(link);
              if (multiLinks != null) {
                ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(multiLinks, link);
              }
            }
            else
            {
              links = new Array();
              links.push(aux);
              links.push(link);

              if (multiLinks != null)
              {
                ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(multiLinks, aux);
                ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(multiLinks, link);
              }

              nodesToLinks.add(node, links);
              listOfMultilinkLists.push(links);
            }
          }

          continue;
        }

        if (undirected && (dojo.indexOf(markedNodes, otherNode)>=0)) {
          continue;
        }
        aux = nodesToLinks.item(otherNode);

        if (aux == null)
        {
          nodesToLinks.add(otherNode, link);
        }
        else if (aux instanceof Array)
        {
          (aux).push(link);
          if (multiLinks != null) {
            ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(multiLinks, link);
          }
        }
        else
        {
          links = new Array();
          links.push(aux);
          links.push(link);

          if (multiLinks != null)
          {
            ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(multiLinks, aux);
            ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(multiLinks, link);
          }

          nodesToLinks.add(otherNode, links);
          listOfMultilinkLists.push(links);
        }
      }

      if (undirected)
      {
        e2 = (new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getLinksTo(node)));

        while (e2.hasNext())
        {
          link = e2.next();
          if (!this.accept(link)) {
            continue;
          }
          otherNode = this._model.getFrom(link);

          if (otherNode == node) {
            continue;
          }
          if ((dojo.indexOf(markedNodes, otherNode)>=0)) {
            continue;
          }
          aux = nodesToLinks.item(otherNode);

          if (aux == null)
          {
            nodesToLinks.add(otherNode, link);
          }
          else if (aux instanceof Array)
          {
            (aux).push(link);
            if (multiLinks != null) {
              ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(multiLinks, link);
            }
          }
          else
          {
            links = new Array();
            links.push(aux);
            links.push(link);

            if (multiLinks != null)
            {
              ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(multiLinks, aux);
              ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(multiLinks, link);
            }

            nodesToLinks.add(otherNode, links);
            listOfMultilinkLists.push(links);
          }
        }
      }
    }
  },

  collectSelflinks : function(listOfSimpleSelflinks, listOfMultiSelflinkLists, selfLinks)
  {
    // summary:
    //		Collects all accepted self-links into the input list. 
    // description:
    //		Collects all accepted self-links into the input list. 
    //		Note that self-links can occur as multilinks, therefore the
    //		mechanism is the same as for multilinks, however it also collects
    //		nonmultilink self-links. At the end, the input list is filled with
    //		array lists of multilinks.  
    // linkOfSimpleSelflinks:
    //		Container for the result. This contains
    //		the self-links that are no multilinks.
    // linkOfMultiSelflinkLists:
    //		Container for the result. This contains
    //		the self-links that are multilinks.
    // selfLinks: Array
    //		Container that can act as marker for self-links. Can be
    //		null.
    // tags:
    //		private
    
    var aux;
    var links;
    var e1 = new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getNodes());

    while (e1.hasNext())
    {
      var node = e1.next();
      links = new Array();
      var e2 = (new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getLinksFrom(node)));

      while (e2.hasNext())
      {
        var link = e2.next();
        if (!this.accept(link)) {
          continue;
        }
        var otherNode = this._model.getTo(link);

        if (otherNode == node)
        {
          links.push(link);
          if (selfLinks != null) {
            ibm_ilog.graphlayout.internalutil.TranslateUtil.addSetObject(selfLinks, link);
          }
        }
      }

      if (links.length >= 2)
      {
        listOfMultiSelflinkLists.push(links);
      }
      else if (links.length == 1)
      {
        listOfSimpleSelflinks.push(links[0]);
      }
    }
  },

  addBendToMultilinks : function(listOfMultilinkLists, straightenFirst, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert all multilink bundles into links with one bend. 
    // description:
    //		Convert all multilink bundles into links with one bend. 
    //		This assumes that the nodes have already their final positions.  
    // listOfMultilinkLists: Array
    //		A list containing lists of multilinks.
    // straightenFirst: Boolean
    //		Make the link straight before adding the bend.
    //		May be useful when using connection points, because then the
    //		connection point of the straight link are used.
    // useNodeCenter: Boolean
    //		Whether the bend is in the middle of the node
    //		centers or at the middle of the old connection points.
    // useConnectionPoints: Boolean
    //		Connect the link to the calculated connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new ibm_ilog.graphlayout.internalutil.ArrayIterator(listOfMultilinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.addBendToMultilinkBundle(links, usePreciseClipping, straightenFirst, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToMultilinkBundle : function(links, usePreciseClipping, straightenFirst, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert one link bundle of straight links into links with one bend.
    // tags:
    //		private
    
    var n = links.length;
    var p0;
    var p1;
    var pp0;
    var pp1;
    var pts;
    var mx = 0;
    var my = 0;
    var dx = 0;
    var dy = 0;
    var dist = this._multiLinkOffset;
    if (dist * n > this._multiLinkMaxSpread) {
      dist = this._multiLinkMaxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      var link = links[i];

      if (useNodeCenter)
      {
        p0 = this.getNodeCenter(this._model.getFrom(link));
        p1 = this.getNodeCenter(this._model.getTo(link));
      }
      else
      {
        if (straightenFirst) {
          ibm_ilog.graphlayout.internalutil.GraphModelUtil.reshapeLink(this._model, this._layout, link, ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE, null, null, 0, 0,
            null);
        }
        pts = this._model.getLinkPoints(link);
        p0 = pts[0];
        p1 = pts[pts.length - 1];
      }

      if (i == 0)
      {
        mx = 0.5 * (p0.x + p1.x);
        my = 0.5 * (p0.y + p1.y);
        dx = p1.y - p0.y;
        dy = p0.x - p1.x;
        var d = Math.sqrt(dx * dx + dy * dy);

        if (d > 0)
        {
          dx = dx / d;
          dy = dy / d;
        }
      }

      if (useConnectionPoints)
      {
        pp0 = p0;
        pp1 = p1;

        if (!usePreciseClipping && !this._connectToCenter)
        {
          pp0 = this.getClippedConnectionPoint(link, true, p0, p1);
          pp1 = this.getClippedConnectionPoint(link, false, p0, p1);
        }
      }
      else
      {
        pp0 = pp1 = null;
      }

      pts = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(1, null);
      pts[0] = new ibm_ilog.graphlayout.internalutil.Point((mx + (i - 0.5 * (n - 1)) * dx * dist), (my + (i - 0.5 * (n - 1)) * dy * dist));
      ibm_ilog.graphlayout.internalutil.GraphModelUtil.reshapeLink(this._model, this._layout, link, ibm_ilog.graphlayout.internalutil.LinkStyles.POLYLINE_STYLE, pp0, pts, 0, 1, pp1);
    }
  },

  shiftMultilinks : function(listOfMultilinkLists, limitSpacingToNodeBounds, redraw)
  {
    // summary:
    //		Convert all multilink bundles into shifted straight links. 
    // description:
    //		Convert all multilink bundles into shifted straight links. 
    //		This assumes that the nodes have already their final positions.  
    // listOfMultilinkLists: Array
    //		A list containing lists of multilinks.
    // limitSpacingToNodeBounds: Boolean
    //		Whether the multilink offset is reduced
    //		depending on the size of the end nodes.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new ibm_ilog.graphlayout.internalutil.ArrayIterator(listOfMultilinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.shiftMultilinkBundle(links, usePreciseClipping, limitSpacingToNodeBounds, redraw);
    }
  },

  shiftMultilinkBundle : function(links, usePreciseClipping, limitSpacingToNodeBounds, redraw)
  {
    // summary:
    //		Shifts one link bundle of straight links.
    // tags:
    //		private
    
    var n = links.length;
    var p0;
    var p1;
    var pp0;
    var pp1;
    var dx = 0;
    var dy = 0;
    var dist = this._multiLinkOffset;
    if (dist * n > this._multiLinkMaxSpread) {
      dist = this._multiLinkMaxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      var link = links[i];
      p0 = this.getNodeCenter(this._model.getFrom(link));
      p1 = this.getNodeCenter(this._model.getTo(link));

      if (i == 0)
      {
        if (limitSpacingToNodeBounds)
        {
          var r1 = this.boundingBox(this._model.getFrom(link));
          var r2 = this.boundingBox(this._model.getTo(link));
          var maxDist = Math.min(r1.width, r1.height);
          maxDist = Math.min(r2.width, maxDist);
          maxDist = Math.min(r2.height, maxDist);
          if (dist * n > maxDist) {
            dist = maxDist / n;
          }
        }

        dx = p1.y - p0.y;
        dy = p0.x - p1.x;
        var d = Math.sqrt(dx * dx + dy * dy);

        if (d > 0)
        {
          dx = dx / d;
          dy = dy / d;
        }
      }

      p0.x = (p0.x + (i - 0.5 * (n - 1)) * dx * dist);
      p0.y = (p0.y + (i - 0.5 * (n - 1)) * dy * dist);
      p1.x = (p1.x + (i - 0.5 * (n - 1)) * dx * dist);
      p1.y = (p1.y + (i - 0.5 * (n - 1)) * dy * dist);
      pp0 = p0;
      pp1 = p1;

      if (!usePreciseClipping && !this._connectToCenter)
      {
        pp0 = this.getClippedConnectionPoint(link, true, p0, p1);
        pp1 = this.getClippedConnectionPoint(link, false, p0, p1);
      }

      ibm_ilog.graphlayout.internalutil.GraphModelUtil.reshapeLink(this._model, this._layout, link, ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE, pp0, null, 0, 0, pp1);
    }
  },

  addBendToSelfLinkBundles : function(listOfMultiSelflinkLists, limitSpacingToNodeBounds, squared, orientation, attachPositionMode, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert all multilink bundles that are self-links into shapes with 3
    //		bends, forming a rectangle or square. 
    // description:
    //		Convert all multilink bundles that are self-links into shapes with 3
    //		bends, forming a rectangle or square. 
    //		This assumes that the nodes have already their final positions.  
    // listOfMultiSelflinkLists: Array
    //		A list containing lists of multilinks
    //		that are self-links.
    // limitSpacingToNodeBounds: Boolean
    //		Whether the multilink offset is reduced
    //		depending on the size of the end node.
    // squared: Boolean
    //		If true, the added bends try to simulate a square. This
    //		is useful for splines because then the spline shape looks
    //		approximately like a circle.
    // orientation: String
    //		The orientation of the self-links, see 
    //		SelfLinkOrientations.
    // useNodeCenter: Boolean
    //		Whether link should start and end at the node
    //		center.
    // useConnectionPoints: Boolean
    //		Whether link should set the connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new ibm_ilog.graphlayout.internalutil.ArrayIterator(listOfMultiSelflinkLists);

    while (iter.hasNext())
    {
      var links = iter.next();
      this.addBendToSelfLinkBundle(links, usePreciseClipping, limitSpacingToNodeBounds, squared, orientation, attachPositionMode, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToSelfLinkBundle : function(selfLinkBundle, usePreciseClipping, limitSpacingToNodeBounds, squared, orientation, attachPositionMode, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Add 3 bends to a bundle of self-links. 
    // description:
    //		Add 3 bends to a bundle of self-links. 
    //		
    // tags:
    //		private
    
    var n = selfLinkBundle.length;

    if (n == 0)
    {
      return;
    }

    if (n == 1)
    {
      this.addBendToSelfLinks(selfLinkBundle, squared, orientation, useNodeCenter, useConnectionPoints, redraw);
      return;
    }

    var link = selfLinkBundle[0];
    var node = this._model.getFrom(link);
    var r = this.boundingBox(node);
    var dx = this._selfLinkAttachRelativeX * r.width + this._selfLinkAttachAbsoluteX;
    var dy = this._selfLinkAttachRelativeY * r.height + this._selfLinkAttachAbsoluteY;
    var idx;
    var idy;

    if (squared)
    {
      dx = dy = Math.min(dx, dy);
    }

    var p0 = new ibm_ilog.graphlayout.internalutil.Point();
    var p1 = new ibm_ilog.graphlayout.internalutil.Point();
    var corner = this.getBestCorner(node);
    var reversed = this.isReversed(orientation, corner);
    var dist = this._selfLinkOffset;
    var maxSpread = this._selfLinkMaxSpread;

    if (limitSpacingToNodeBounds)
    {
      var ax;
      var ay;

      switch (attachPositionMode)
      {
        case ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions.CENTERED:
          ax = 2 * Math.min(dx, r.width - dx);
          ay = 2 * Math.min(dy, r.height - dy);
          break;
        case ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions.OUTER:
          ax = r.width - dx;
          ay = r.height - dy;
          break;
        case ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions.INNER:
        default:
          ax = dx;
          ay = dy;
          break;
      }
      maxSpread = Math.min(maxSpread, ax);
      maxSpread = Math.min(maxSpread, ay);
    }

    if (dist * n > maxSpread) {
      dist = maxSpread / n;
    }
    for (var i = 0; i < n; i++)
    {
      link = selfLinkBundle[i];

      switch (attachPositionMode)
      {
        case ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions.CENTERED:
          idx = dx + (i - 0.5 * (n - 1)) * dist;
          idy = dy + (i - 0.5 * (n - 1)) * dist;
          break;
        case ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions.OUTER:
          idx = dx + i * dist;
          idy = dy + i * dist;
          break;
        case ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions.INNER:
        default:
          idx = dx + (i - (n - 1)) * dist;
          idy = dy + (i - (n - 1)) * dist;
          break;
      }
      switch (corner)
      {
        case 1:
          
          p0.x = r.x;
          p0.y = r.y + r.height - idy;
          p1.x = r.x + idx;
          p1.y = r.y + r.height;
          break;
        case 2:
          p0.x = r.x + r.width;
          p0.y = r.y + r.height - idy;
          p1.x = r.x + r.width - idx;
          p1.y = r.y + r.height;
          break;
        case 4:
          p0.x = r.x + r.width;
          p0.y = r.y + idy;
          p1.x = r.x + r.width - idx;
          p1.y = r.y;
          break;
        case 8:
          p0.x = r.x;
          p0.y = r.y + idy;
          p1.x = r.x + idx;
          p1.y = r.y;
          break;
      }
      if (this._selfLinkSpacing >= 0)
      {
        if (squared)
        {
          var a = Math.max(idx + this._selfLinkSpacing + i * dist, idy + this._selfLinkSpacing + i * dist);
          idx = a - idx;
          idy = a - idy;
        }
        else
        {
          idx = idy = this._selfLinkSpacing + i * dist;
        }
      }

      this.addBendToSelfLink(link, corner, p0, p1, idx, idy, reversed, usePreciseClipping, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToSelfLinks : function(simpleSelfLinks, squared, orientation, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Convert all simple self-links that are no multilinks into shapes
    //		with 3 bends, forming a rectangle or square. 
    // description:
    //		Convert all simple self-links that are no multilinks into shapes
    //		with 3 bends, forming a rectangle or square. 
    //		This assumes that the nodes have already their final positions.  
    // simpleSelfLinks: Array
    //		A list containing the simple self-links.
    // squared: Boolean
    //		If true, the added bends try to simulate a square. This
    //		is useful for splines because then the spline shape looks
    //		approximately like a circle.
    // orientation: String
    //		The orientation of the self-links, see 
    //		SelfLinkOrientations.
    // useNodeCenter: Boolean
    //		Whether link should start and end at the node
    //		center.
    // useConnectionPoints: Boolean
    //		Whether link should set the connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the links.
    // tags:
    //		private
    
    var p0 = new ibm_ilog.graphlayout.internalutil.Point();
    var p1 = new ibm_ilog.graphlayout.internalutil.Point();
    var dx = 0;
    var dy = 0;
    var usePreciseClipping = this.usePreciseClipping();
    var iter =  new ibm_ilog.graphlayout.internalutil.ArrayIterator(simpleSelfLinks);

    while (iter.hasNext())
    {
      var link = iter.next();
      var node = this._model.getFrom(link);
      var rect = this.boundingBox(node);
      dx = this._selfLinkAttachRelativeX * rect.width + this._selfLinkAttachAbsoluteX;
      dy = this._selfLinkAttachRelativeY * rect.height + this._selfLinkAttachAbsoluteY;

      if (squared)
      {
        dx = dy = Math.min(dx, dy);
      }

      var corner = this.getBestCorner(node);

      switch (corner)
      {
        case 1:
          
          p0.x = rect.x;
          p0.y = rect.y + rect.height - dy;
          p1.x = rect.x + dx;
          p1.y = rect.y + rect.height;
          break;
        case 2:
          p0.x = rect.x + rect.width;
          p0.y = rect.y + rect.height - dy;
          p1.x = rect.x + rect.width - dx;
          p1.y = rect.y + rect.height;
          break;
        case 4:
          p0.x = rect.x + rect.width;
          p0.y = rect.y + dy;
          p1.x = rect.x + rect.width - dx;
          p1.y = rect.y;
          break;
        case 8:
          p0.x = rect.x;
          p0.y = rect.y + dy;
          p1.x = rect.x + dx;
          p1.y = rect.y;
          break;
      }
      if (this._selfLinkSpacing >= 0)
      {
        if (squared)
        {
          var a = Math.max(dx + this._selfLinkSpacing, dy + this._selfLinkSpacing);
          dx = a - dx;
          dy = a - dy;
        }
        else
        {
          dx = dy = this._selfLinkSpacing;
        }
      }

      this.addBendToSelfLink(link, corner, p0, p1, dx, dy, this.isReversed(orientation, corner), usePreciseClipping, useNodeCenter, useConnectionPoints, redraw);
    }
  },

  addBendToSelfLink : function(link, corner, start, end, dx, dy, reversed, usePreciseClipping, useNodeCenter, useConnectionPoints, redraw)
  {
    // summary:
    //		Add 3 bends to a self-links.  
    // link: Object
    //		The link
    // corner: int
    //		The corner of the node (1,2,4,8 = bottom right to top
    //		left)
    // start: Point
    //		The point at the left or right border.
    // end: Point
    //		The point at the top or bottom border.
    // dx: Number
    //		The extension of the self-link in horizontal direction.
    // dy: Number
    //		The extension of the self-link in vertical direction.
    // reversed: Boolean
    //		Whether the link runs from start to end or reversed.
    // usePreciseClipping: Boolean
    //		Whether to use link clipping with the
    //		interface.
    // useNodeCenter: Boolean
    //		Whether link should start and end at the node
    //		center.
    // useConnectionPoints: Boolean
    //		Whether link should set the connection
    //		points.
    // redraw: Boolean
    //		Whether to redraw the link.
    // tags:
    //		private
    
    var pts = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(3, null);
    var p0;
    var p1;
    var pp0;
    var pp1;

    if (reversed)
    {
      p0 = end;
      p1 = start;

      switch (corner)
      {
        case 1:
          
          pts[0] = new ibm_ilog.graphlayout.internalutil.Point(end.x, end.y + dy);
          pts[1] = new ibm_ilog.graphlayout.internalutil.Point(start.x - dx, end.y + dy);
          pts[2] = new ibm_ilog.graphlayout.internalutil.Point(start.x - dx, start.y);
          break;
        case 2:
          pts[0] = new ibm_ilog.graphlayout.internalutil.Point(end.x, end.y + dy);
          pts[1] = new ibm_ilog.graphlayout.internalutil.Point(start.x + dx, end.y + dy);
          pts[2] = new ibm_ilog.graphlayout.internalutil.Point(start.x + dx, start.y);
          break;
        case 4:
          pts[0] = new ibm_ilog.graphlayout.internalutil.Point(end.x, end.y - dy);
          pts[1] = new ibm_ilog.graphlayout.internalutil.Point(start.x + dx, end.y - dy);
          pts[2] = new ibm_ilog.graphlayout.internalutil.Point(start.x + dx, start.y);
          break;
        case 8:
          pts[0] = new ibm_ilog.graphlayout.internalutil.Point(end.x, end.y - dy);
          pts[1] = new ibm_ilog.graphlayout.internalutil.Point(start.x - dx, end.y - dy);
          pts[2] = new ibm_ilog.graphlayout.internalutil.Point(start.x - dx, start.y);
          break;
      }
    }
    else
    {
      p0 = start;
      p1 = end;

      switch (corner)
      {
        case 1:
          
          pts[0] = new ibm_ilog.graphlayout.internalutil.Point(start.x - dx, start.y);
          pts[1] = new ibm_ilog.graphlayout.internalutil.Point(start.x - dx, end.y + dy);
          pts[2] = new ibm_ilog.graphlayout.internalutil.Point(end.x, end.y + dy);
          break;
        case 2:
          pts[0] = new ibm_ilog.graphlayout.internalutil.Point(start.x + dx, start.y);
          pts[1] = new ibm_ilog.graphlayout.internalutil.Point(start.x + dx, end.y + dy);
          pts[2] = new ibm_ilog.graphlayout.internalutil.Point(end.x, end.y + dy);
          break;
        case 4:
          pts[0] = new ibm_ilog.graphlayout.internalutil.Point(start.x + dx, start.y);
          pts[1] = new ibm_ilog.graphlayout.internalutil.Point(start.x + dx, end.y - dy);
          pts[2] = new ibm_ilog.graphlayout.internalutil.Point(end.x, end.y - dy);
          break;
        case 8:
          pts[0] = new ibm_ilog.graphlayout.internalutil.Point(start.x - dx, start.y);
          pts[1] = new ibm_ilog.graphlayout.internalutil.Point(start.x - dx, end.y - dy);
          pts[2] = new ibm_ilog.graphlayout.internalutil.Point(end.x, end.y - dy);
          break;
      }
    }

    if (useNodeCenter)
    {
      var node = this._model.getFrom(link);
      p0 = this.getNodeCenter(node);
      p1 = this.getNodeCenter(node);
    }

    if (useConnectionPoints)
    {
      pp0 = p0;
      pp1 = p1;

      if (!usePreciseClipping && !this._connectToCenter)
      {
        pp0 = this.getClippedConnectionPoint(link, true, p0, pts[0]);
        pp1 = this.getClippedConnectionPoint(link, false, pts[2], p1);
      }
    }
    else
    {
      pp0 = pp1 = null;
    }

    ibm_ilog.graphlayout.internalutil.GraphModelUtil.reshapeLink(this._model, this._layout, link, ibm_ilog.graphlayout.internalutil.LinkStyles.POLYLINE_STYLE, pp0, pts, 0, 3, pp1);
  },

  getBestCorner : function(node)
  {
    // summary:
    //		Decides which corner to use for the self-links. 
    // description:
    //		Decides which corner to use for the self-links. 
    //		This heuristics looks at the other links and decides for the corner
    //		at the side that is least occupied. To decide how much a side is
    //		occupied, it assumes the other links are straight and start at the
    //		center of the nodes. This may not be precise, but it is good enough
    //		as heuristic. This routine must be called after all nodes have their
    //		final positions. The coding of the corners: 8 = top left, 4 = top
    //		right, 2 = bottom right, 1 = bottom left
    // tags:
    //		private
    
    if (this._allowedSelfLinkCorners == 0x01) {
      return 0x01; // int
    }
    if (this._allowedSelfLinkCorners == 0x02) {
      return 0x02; // int
    }
    if (this._allowedSelfLinkCorners == 0x04) {
      return 0x04; // int
    }
    if (this._allowedSelfLinkCorners == 0x08) {
      return 0x08; // int
    }

    var linksAtSide = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(4, 0);
    var linksAtCorner = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(4, 0);
    var p0 = this.getNodeCenter(node);
    var p1;
    var dx;
    var dy;
    var e = (new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getLinksFrom(node)));
    var link = null;
    var otherNode = null;

    while (e.hasNext())
    {
      link = e.next();
      otherNode = this._model.getTo(link);

      if (otherNode != node)
      {
        p1 = this.getNodeCenter(otherNode);
        dx = p1.x - p0.x;
        dy = p1.y - p0.y;

        if (Math.abs(dx) > Math.abs(dy))
        {
          if (dx > 0) {
            linksAtSide[2]++;
          }
          else {
            linksAtSide[0]++;
          }
        }
        else
        {
          if (dy > 0) {
            linksAtSide[3]++;
          }
          else {
            linksAtSide[1]++;
          }
        }

        if (dx < 0) {
          if (dy < 0) {
            linksAtCorner[0]++;
          }
          else if (dy > 0) {
            linksAtCorner[1]++;
          }
          else
          {
            linksAtCorner[0]++;
            linksAtCorner[1]++;
          }
        }
        else if (dx > 0) {
          if (dy < 0) {
            linksAtCorner[2]++;
          }
          else if (dy > 0) {
            linksAtCorner[3]++;
          }
          else
          {
            linksAtCorner[2]++;
            linksAtCorner[3]++;
          }
        }
        else if (dy < 0)
        {
          linksAtCorner[0]++;
          linksAtCorner[2]++;
        }
        else if (dy > 0)
        {
          linksAtCorner[1]++;
          linksAtCorner[3]++;
        }
      }
    }

    e = (new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getLinksTo(node)));

    while (e.hasNext())
    {
      link = e.next();
      otherNode = this._model.getFrom(link);

      if (otherNode != node)
      {
        p1 = this.getNodeCenter(otherNode);
        dx = p1.x - p0.x;
        dy = p1.y - p0.y;

        if (Math.abs(dx) > Math.abs(dy))
        {
          if (dx > 0) {
            linksAtSide[2]++;
          }
          else {
            linksAtSide[0]++;
          }
        }
        else
        {
          if (dy > 0) {
            linksAtSide[3]++;
          }
          else {
            linksAtSide[1]++;
          }
        }

        if (dx < 0) {
          if (dy < 0) {
            linksAtCorner[0]++;
          }
          else if (dy > 0) {
            linksAtCorner[1]++;
          }
          else
          {
            linksAtCorner[0]++;
            linksAtCorner[1]++;
          }
        }
        else if (dx > 0) {
          if (dy < 0) {
            linksAtCorner[2]++;
          }
          else if (dy > 0) {
            linksAtCorner[3]++;
          }
          else
          {
            linksAtCorner[2]++;
            linksAtCorner[3]++;
          }
        }
        else if (dy < 0)
        {
          linksAtCorner[0]++;
          linksAtCorner[2]++;
        }
        else if (dy > 0)
        {
          linksAtCorner[1]++;
          linksAtCorner[3]++;
        }
      }
    }

    var bestSide = 2;
    var linksAtBestSide = /*Number.MAX_VALUE*/2147483647;
    var linksCount;

    if ((this._allowedSelfLinkCorners & 0x01) != 0)
    {
      linksCount = linksAtSide[3] + linksAtSide[0] + 3 * linksAtCorner[1];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 1;
      }
    }

    if ((this._allowedSelfLinkCorners & 0x02) != 0)
    {
      linksCount = linksAtSide[3] + linksAtSide[2] + 3 * linksAtCorner[3];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 2;
      }
    }

    if ((this._allowedSelfLinkCorners & 0x04) != 0)
    {
      linksCount = linksAtSide[1] + linksAtSide[2] + 3 * linksAtCorner[2];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 4;
      }
    }

    if ((this._allowedSelfLinkCorners & 0x08) != 0)
    {
      linksCount = linksAtSide[1] + linksAtSide[0] + 3 * linksAtCorner[0];

      if (linksCount < linksAtBestSide)
      {
        linksAtBestSide = linksCount;
        bestSide = 8;
      }
    }

    return bestSide; // int
  },

  isReversed : function(orientation, corner)
  {
    // summary:
    //		Returns whether the self-link orientation is reversed or not. 
    // description:
    //		Returns whether the self-link orientation is reversed or not. 
    //		
    // tags:
    //		private
    
    switch (orientation)
    {
      case ibm_ilog.graphlayout.internalutil.SelfLinkOrientations.CLOCK_WISE:
        return corner == 0x01 || corner == 0x04; // Boolean
      case ibm_ilog.graphlayout.internalutil.SelfLinkOrientations.COUNTER_CLOCK_WISE:
        return corner == 0x02 || corner == 0x08; // Boolean
      case ibm_ilog.graphlayout.internalutil.SelfLinkOrientations.HORIZONTAL_TO_VERTICAL:
        return false; // Boolean
      case ibm_ilog.graphlayout.internalutil.SelfLinkOrientations.VERTICAL_TO_HORIZONTAL:
        return true; // Boolean
    }
    return false; // Boolean
  }

}
);

}

if(!dojo._hasResource['ibm_ilog.graphlayout.internalutil.SelfLinkModes']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.graphlayout.internalutil.SelfLinkModes'] = true;
dojo.provide('ibm_ilog.graphlayout.internalutil.SelfLinkModes');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------




dojo.declare('ibm_ilog.graphlayout.internalutil.SelfLinkModes', null, 
{
  // summary:
  //		This class contains all enumeration constants used for self-link
  //		layout. 
  // description:
  //		This class contains all enumeration constants used for self-link
  //		layout. 
  //		This occurs mainly for the straight line link styles (TML, Uniform,
  //		Circular). It also contains some generic support for the modes.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.SelfLinkModes,
{
  NO_BENDS : null,
  CONNECTED_RECTANGULAR : null,
  FREE_RECTANGULAR : null,
  NARROW_CONNECTED_RECTANGULAR : null,
  NARROW_FREE_RECTANGULAR : null,
  CONNECTED_SQUARE : null,
  FREE_SQUARE : null,
  NARROW_CONNECTED_SQUARE : null,
  NARROW_FREE_SQUARE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.SelfLinkModes;
    
    c.NO_BENDS = 0x00;
    c.CONNECTED_RECTANGULAR = 0x10;
    c.FREE_RECTANGULAR = 0x11;
    c.NARROW_CONNECTED_RECTANGULAR = 0x12;
    c.NARROW_FREE_RECTANGULAR = 0x13;
    c.CONNECTED_SQUARE = 0x20;
    c.FREE_SQUARE = 0x21;
    c.NARROW_CONNECTED_SQUARE = 0x22;
    c.NARROW_FREE_SQUARE = 0x23;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.SelfLinkModes._fields_init(); })();

}

if(!dojo._hasResource['ibm_ilog.graphlayout.basic.BasicLinkStyleLayout']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.graphlayout.basic.BasicLinkStyleLayout'] = true;
dojo.provide('ibm_ilog.graphlayout.basic.BasicLinkStyleLayout');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------















dojo.declare('ibm_ilog.graphlayout.basic.BasicLinkStyleLayout', ibm_ilog.graphlayout.GraphLayout, 
{
  // summary:
  //		The Basic Link Style Layout is a common base class of all layouts
  //		algorithms that offer no complex link shapes. 
  // description:
  //		The Basic Link Style Layout is a common base class of all layouts
  //		algorithms that offer no complex link shapes. 
  //		It offers only the link styles "straight links" and "no link reshape"
  //		for the regular links. It offers common options, for handling
  //		multiple links between the same pair of nodes, and for handling
  //		self-links that start and end at the same node.   
  //		<p>
  //		While the main purpose of <code>BasicLinkStyleLayout</code> is to
  //		serve as a base class for some other layout algorithms, the Basic
  //		Link Style Layout can also be used by itself. In this case, it does
  //		not place any nodes, but it can route certain links.  Links between
  //		different node pairs can be routed as straight lines. Multiple links
  //		between different node pairs can be routed as shifted bundle of
  //		straight links, or as bundle with one bend point. Self-links that
  //		start and end at the same node can be routed in a rectangular or
  //		square style (or, if spline links are used, as approximation of a
  //		circle).  
  //		</p>
  //		<p>
  //		</p>
  //		<p>
  //		Here are sample drawings produced with the Basic Link Style Layout
  //		algorithm:  
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-BasicLinkStyle-Multi1.gif" alt="Sample drawing produced with the Basic Link Style Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		<img src="../../../images/ibm&#95;graphlayout/layout-BasicLinkStyle-Multi2.gif" alt="Sample drawing produced with the Basic Link Style Layout" border="0" align="bottom" />
  //		 
  //		</p>
  //		<p>
  //		See the corresponding chapter of the IBM ILOG Dojo Diagrammer
  //		User's Manual for details on the algorithm, the types of graphs for which this algorithm can be used, the features and limitations, code samples, parameters, and so on.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  /*=====
  // STRAIGHT_LINE_STYLE: int
  //		Straight-line links shape option. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setLinkStyle()', the links are given a
  //		straight-line shape.
  STRAIGHT_LINE_STYLE : null,
  // NO_RESHAPE_STYLE: int
  //		No links reshape option. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setLinkStyle()', the links are not
  //		reshaped.
  NO_RESHAPE_STYLE : null,
  // NO_BUNDLE: int
  //		Multilink mode: no bundling. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are not spread out and will overlap.
  NO_BUNDLE : null,
  // STRAIGHT_LINE_BUNDLE: int
  //		Multilink mode: straight bundling. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed straight but shifted to
  //		avoid overlaps.
  STRAIGHT_LINE_BUNDLE : null,
  // NARROW_STRAIGHT_LINE_BUNDLE: int
  //		Multilink mode: narrow straight bundling. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed straight but shifted to
  //		avoid overlaps. The bundle may appear more narrow since the shift
  //		offset is limited by the size of the end nodes.
  NARROW_STRAIGHT_LINE_BUNDLE : null,
  // CONNECTED_ONE_BEND_BUNDLE: int
  //		Multilink mode: one bend polyline bundling with connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed with one bend to avoid
  //		overlaps. All links of the bundle are connected to the node and start
  //		at the same point and end at the same point.
  CONNECTED_ONE_BEND_BUNDLE : null,
  // FREE_ONE_BEND_BUNDLE: int
  //		Multilink mode: one bend polyline bundling without enforced
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiLinkMode()', multiple links
  //		between the same pair of nodes are routed with one bend to avoid
  //		overlaps. The link connection points are not enforced, that is, the
  //		nodes and links are free to decide themselves where to place the
  //		connection points. There is no guarantee that all links of the bundle
  //		start or end at a common point.
  FREE_ONE_BEND_BUNDLE : null,
  // NO_BENDS: int
  //		Self-link mode: no reshape. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', self-links (that is,
  //		links that start and end at the same node) are not reshaped with
  //		bends and may not be visible after layout.
  NO_BENDS : null,
  // CONNECTED_RECTANGULAR: int
  //		Self-link mode: rectangular self-links with 3 bends and connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a rectangle (the fourth
  //		quarter being the node where the self-link is attached).  The
  //		connection points are placed on the border of the node.
  CONNECTED_RECTANGULAR : null,
  // FREE_RECTANGULAR: int
  //		Self-link mode: rectangular self-links with 3 bends without enforced
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.CONNECTED_RECTANGULAR'. The link
  //		connection points are not enforced, that is, the nodes and links are
  //		free to decide themselves where to place the connection point.
  FREE_RECTANGULAR : null,
  // CONNECTED_SQUARE: int
  //		Self-link mode: square self-links with 3 bends and connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a square (the fourth quarter
  //		being the node where the self-link is attached). If the self-link is
  //		a spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  The connection points are placed on the
  //		border of the node.
  CONNECTED_SQUARE : null,
  // FREE_SQUARE: int
  //		Self-link mode: square self-links with 3 bends without enforced
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.CONNECTED_SQUARE'. If the self-link is a
  //		spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  The link connection points are not
  //		enforced, that is, the nodes and links are free to decide themselves
  //		where to place the connection point.
  FREE_SQUARE : null,
  // NARROW_CONNECTED_RECTANGULAR: int
  //		Self-link mode: narrow rectangular self-links with 3 bends and
  //		connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a rectangle (the fourth
  //		quarter being the node where the self-link is attached).  The
  //		connection points are placed on the border of the node. For single
  //		self-links, this mode has the same effect like '
  //		BasicLinkStyleLayout.CONNECTED_RECTANGULAR'. If you have
  //		multiple self-links at the same node, the self-links are shifted by
  //		an offset to avoid overlaps. In this case, this mode differs from
  //		' BasicLinkStyleLayout.CONNECTED_RECTANGULAR', as the
  //		self-link bundle may appear more narrow since the shift offset of the
  //		multiple self-links  is limited by the size of the end node.
  NARROW_CONNECTED_RECTANGULAR : null,
  // NARROW_FREE_RECTANGULAR: int
  //		Self-link mode: narrow rectangular self-links with 3 bends without
  //		enforced connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR'. For single
  //		self-links, this mode has the same effect like '
  //		BasicLinkStyleLayout.FREE_RECTANGULAR'. If you have multiple
  //		self-links at the same node, the self-links are shifted by an offset
  //		to avoid overlaps. In this case, this mode differs from '
  //		BasicLinkStyleLayout.FREE_RECTANGULAR', as the self-link bundle
  //		may appear more narrow since the shift offset of the multiple
  //		self-links      * is limited by the size of the end node. The link
  //		connection points are not enforced, that is, the nodes and links are
  //		free to decide themselves where to place the connection point.
  NARROW_FREE_RECTANGULAR : null,
  // NARROW_CONNECTED_SQUARE: int
  //		Self-link mode: narrow square self-links with 3 bends and connection.
  //		
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed in orthogonal style so that the link segments
  //		approximately resemble three quarters of a square (the fourth quarter
  //		being the node where the self-link is attached). If the self-link is
  //		a spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  The connection points are placed on the
  //		border of the node. For single self-links, this mode has the same
  //		effect like ' BasicLinkStyleLayout.CONNECTED_SQUARE'. If
  //		you have multiple self-links at the same node, the self-links are
  //		shifted by an offset to avoid overlaps. In this case, this mode
  //		differs from ' BasicLinkStyleLayout.CONNECTED_SQUARE', as
  //		the self-link bundle may appear more narrow since the shift offset of
  //		the multiple self-links  is limited by the size of the end node.
  NARROW_CONNECTED_SQUARE : null,
  // NARROW_FREE_SQUARE: int
  //		Self-link mode: narrow square self-links with 3 bends without
  //		enforced connection. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkMode()', 3 bends are added to 
  //		self-links (that is, links that start and end at the same node). The
  //		bends are placed at the same position like '
  //		BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE'. If the self-link
  //		is a spline link, the square shape might be more appropriate than a
  //		rectangular shape since the spline then may approximately resemble
  //		three quarters of a circle.  For single self-links, this mode has the
  //		same effect like ' BasicLinkStyleLayout.FREE_SQUARE'. If
  //		you have multiple self-links at the same node, the self-links are
  //		shifted by an offset to avoid overlaps. In this case, this mode
  //		differs from ' BasicLinkStyleLayout.FREE_SQUARE', as the
  //		self-link bundle may appear more narrow since the shift offset of the
  //		multiple self-links  is limited by the size of the end node. The link
  //		connection points are not enforced, that is, the nodes and links are
  //		free to decide themselves where to place the connection point.
  NARROW_FREE_SQUARE : null,
  // TOP_LEFT: int
  //		Defines the 'top left' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  TOP_LEFT : null,
  // BOTTOM_LEFT: int
  //		Defines the 'bottom left' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  BOTTOM_LEFT : null,
  // TOP_RIGHT: int
  //		Defines the 'top right' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  TOP_RIGHT : null,
  // BOTTOM_RIGHT: int
  //		Defines the 'bottom right' corner as allowed corner to place
  //		self-links (that is, links that start and end at the same node).
  BOTTOM_RIGHT : null,
  // ALL_CORNERS: int
  //		Defines that all the corners are allowed for placing self-links (that
  //		is, links that start and end at the same node). 
  //		This value is the combination of all the values described below:  
  //		BasicLinkStyleLayout.TOP_LEFT: top left corner;
  //		BasicLinkStyleLayout.TOP_RIGHT:  top right corner;
  //		BasicLinkStyleLayout.BOTTOM_RIGHT: bottom right corner; 
  //		BasicLinkStyleLayout.BOTTOM_LEFT: bottom left corner.
  ALL_CORNERS : null,
  // CLOCK_WISE: int
  //		Self-link orientation: clockwise. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) are routed in
  //		clockwise orientation.
  CLOCK_WISE : null,
  // COUNTER_CLOCK_WISE: int
  //		Self-link orientation: counterclockwise. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) are routed in
  //		counterclockwise orientation.
  COUNTER_CLOCK_WISE : null,
  // HORIZONTAL_TO_VERTICAL: int
  //		Self-link orientation: horizontal to vertical. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) start at the
  //		left or right side of the node with a horizontal segment and end at
  //		the top or bottom side of the node with a vertical segment.
  HORIZONTAL_TO_VERTICAL : null,
  // VERTICAL_TO_HORIZONTAL: int
  //		Self-link orientation: vertical to horizontal. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setSelfLinkOrientation()',  self-links
  //		(that is, links that start and end at the same node) start at the top
  //		or bottom side of the node with a vertical segment and end at the
  //		left or right side of the node with a horizontal segment.
  VERTICAL_TO_HORIZONTAL : null,
  // CENTERED: int
  //		Multiple self-link distribution: centered. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiSelfLinkDistribution()', the
  //		middle of the bundles of multiple self-links (that is, multiple links
  //		that start and end at the same node) is attached at the reference
  //		points for self-links.
  CENTERED : null,
  // OUTER: int
  //		Multiple self-link distribution: towards outer nestings. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiSelfLinkDistribution()', the
  //		innermost self-link loop of a bundle of multiple self-links (that is,
  //		multiple links that start and end at the same node) is attached at
  //		the reference points for self-links, and the remaining self-link
  //		loops are distributed towards the outer of the nestings.
  OUTER : null,
  // INNER: int
  //		Multiple self-link distribution: towards inner nestings. 
  //		When used as an argument of  '
  //		BasicLinkStyleLayout.setMultiSelfLinkDistribution()', the
  //		outermost self-link loop of a bundle of multiple self-links (that is,
  //		multiple links that start and end at the same node) is attached at
  //		the reference points for self-links, and the remaining self-links
  //		loops are distributed towards the inner of the nestings.
  INNER : null,
  =====*/
  
  _connectLinksToNodeCenters: null,

  _linkStyle: null,

  _multiLinkMode: null,
  _multiLinkOffset: null,
  _multiLinkMaxSpread: null,

  _selfLinkMode: null,

  _selfLinkOrientation: null,
  _selfLinkAllowedCorners: null,
  _selfLinkSpacing: null,
  _selfLinkRelativeAttachPosition: null,
  _selfLinkAbsoluteAttachPosition: null,
  _selfLinkConnectToNodeCenter: null,

  _multiSelfLinkDistribution: null,
  _multiSelfLinkOffset: null,
  _multiSelfLinkMaxSpread: null,

  _multiLinks : null,
  _selfLinks : null,

  constructor : function (a0)
  {
    if(arguments.length == 0)
      this._constructor_overload_ibm_ilog_graphlayout_basic_BasicLinkStyleLayout_0();
    else if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_basic_BasicLinkStyleLayout_1(a0);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_basic_BasicLinkStyleLayout_0 : function()
  {
    this._multiLinks = null;
    this._selfLinks = null;
  },
  
  init : function()
  {
    // summary:
    //		Initializes instance variables. 
    // description:
    //		Initializes instance variables. 
    //		<p>
    //		You should not call this method directly. The method is called
    //		internally by the constructor without arguments and by the copy
    //		constructor. The method must be overridden by subclasses that need
    //		to initialize additional instance variables.
    //		</p>
    // tags:
    //		protected
    
    ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultConnectLinksToNodeCenters = true;

    this.inherited("init", arguments, []);
    this._connectLinksToNodeCenters = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultConnectLinksToNodeCenters;
    this._linkStyle = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultLinkStyle;
    this._multiLinkMode = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiLinkMode;
    this._multiLinkOffset = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiLinkOffset;
    this._multiLinkMaxSpread = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiLinkMaxSpread;
    this._selfLinkMode = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkMode;
    this._selfLinkOrientation = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkOrientation;
    this._selfLinkAllowedCorners = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkAllowedCorners;
    this._selfLinkSpacing = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkSpacing;
    this._selfLinkRelativeAttachPosition =
      new ibm_ilog.graphlayout.internalutil.Point(ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkRelativeAttachPosition .x,
          ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkRelativeAttachPosition .y);
    this._selfLinkAbsoluteAttachPosition =
      new ibm_ilog.graphlayout.internalutil.Point(ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkAbsoluteAttachPosition .x,
          ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkAbsoluteAttachPosition .y);
    this._selfLinkConnectToNodeCenter = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkConnectToNodeCenter;
    this._multiSelfLinkDistribution = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiSelfLinkDistribution;
    this._multiSelfLinkOffset = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiSelfLinkOffset;
    this._multiSelfLinkMaxSpread = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiSelfLinkMaxSpread;
  },

  _constructor_overload_ibm_ilog_graphlayout_basic_BasicLinkStyleLayout_1 : function(source )
  {
    this._multiLinks = null;
    this._selfLinks = null;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the layout instance. 
    // description:
    //		Copies the layout instance. 
    //		<p>
    //		This method copies the layout instance by calling the copy
    //		constructor.  
    //		</p>
    //		<p>
    //		When performing a recursive layout of a nested graph, this method is
    //		used by <code> ibm&#95;ilog.graphlayout.ILayoutProvider</code> to
    //		"clone" the layout instance of a parent graph.  
    //		</p>
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the   customization
    //		interfaces, are also copied. A copy of the layout instance used for
    //		laying out the connected components is set on the new instance.  
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    // returns:
    //		A copy of the layout instance.
    
    return new ibm_ilog.graphlayout.basic.BasicLinkStyleLayout(this); // ibm_ilog.graphlayout.GraphLayout
  },

  copyParameters : function(source)
  {
    // summary:
    //		Copies the parameters from a given layout instance. 
    // description:
    //		Copies the parameters from a given layout instance. 
    //		<p>
    //		Note that the parameters which are specific to a node or a link are
    //		not copied. The other parameters, including the  customization
    //		interfaces, are also copied. A copy of the layout instance used for
    //		laying out the connected components is set on this layout instance. 
    //		
    //		</p>
    //		<p>
    //		If a method of the type <code>supportsXXX</code> is associated with
    //		a parameter, the parameter is copied only if the corresponding
    //		method returns <code>true</code>.  
    //		</p>
    
    this.inherited("copyParameters", arguments, [source]);

    if (source instanceof ibm_ilog.graphlayout.basic.BasicLinkStyleLayout)
    {
      var bsource = source;
      this.setConnectLinksToNodeCenters(bsource.isConnectLinksToNodeCenters());
      this.setLinkStyle(bsource.getLinkStyle());
      this.setMultiLinkMode(bsource.getMultiLinkMode());
      this.setMultiLinkOffset(bsource.getMultiLinkOffset());
      this.setMultiLinkMaxSpread(bsource.getMultiLinkMaxSpread());
      this.setSelfLinkMode(bsource.getSelfLinkMode());
      this.setSelfLinkOrientation(bsource.getSelfLinkOrientation());
      this.setSelfLinkAllowedCorners(bsource.getSelfLinkAllowedCorners());
      this.setSelfLinkSpacing(bsource.getSelfLinkSpacing());
      this.setSelfLinkRelativeAttachPosition(bsource.getSelfLinkRelativeAttachPosition());
      this.setSelfLinkAbsoluteAttachPosition(bsource.getSelfLinkAbsoluteAttachPosition());
      this.setSelfLinkConnectToNodeCenter(bsource.isSelfLinkConnectToNodeCenter());
      this.setMultiSelfLinkDistribution(bsource.getMultiSelfLinkDistribution());
      this.setMultiSelfLinkOffset(bsource.getMultiSelfLinkOffset());
      this.setMultiSelfLinkMaxSpread(bsource.getMultiSelfLinkMaxSpread());
    }
  },

  supportsPreserveFixedNodes : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		nodes. 
    //		Fixed nodes are not positioned during the layout if the method
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code>  is
    //		called with a <code>true</code> argument.   The base class <code>
    //		BasicLinkStyleLayout</code> does not move any nodes anyway, hence
    //		specifying nodes as fixed is not necessary. All subclasses of this
    //		class however move nodes, and specifying nodes as fixed for a
    //		subclass can be useful.
    
    return true; // Boolean
  },

  supportsPreserveFixedLinks : function()
  {
    // summary:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    // description:
    //		Indicates that this layout class allows the user to specify fixed
    //		links. 
    //		Fixed links are not reshaped during the layout if the method  <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.setPreserveFixedLinks()</code>  is
    //		called with a <code>true</code> argument.
    
    return true; // Boolean
  },

  supportsAllowedTime : function()
  {
    // summary:
    //		Indicates that this layout class can stop the layout computation
    //		when the user-defined allowed time is exceeded. 
    // description:
    //		Indicates that this layout class can stop the layout computation
    //		when the user-defined allowed time is exceeded. 
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case. Subclasses may return a different result code if the
    //		method <code> BasicLinkStyleLayout.getLayoutCodeOnInterrupt()</code>
    //		is overridden.
    
    return true; // Boolean
  },

  supportsStopImmediately : function()
  {
    // summary:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    // description:
    //		Indicates that this layout class can interrupt the current run of
    //		the layout immediately in a controlled way. 
    //		The result code in the layout report is <code>
    //		ibm&#95;ilog.graphlayout.GraphLayoutReport.STOPPED&#95;AND&#95;INVALID</code> in
    //		this case. Subclasses may return a different result code if the
    //		method <code> BasicLinkStyleLayout.getLayoutCodeOnInterrupt()</code>
    //		is overridden.
    
    return true; // Boolean
  },

  supportsLayoutOfConnectedComponents : function()
  {
    // summary:
    //		Indicates that this layout class can cut the attached graph into
    //		connected components, apply itself to each connected component
    //		separately, and then use the layout instance returned by the method 
    //		'
    //		ibm_ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()'
    //		to position the connected components. 
    // description:
    //		Indicates that this layout class can cut the attached graph into
    //		connected components, apply itself to each connected component
    //		separately, and then use the layout instance returned by the method 
    //		<code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.getLayoutOfConnectedComponents()</code>
    //		to position the connected components. 
    //		By default, this layout is an instance of <code>
    //		ibm&#95;ilog.graphlayout.grid.GridLayout</code> which can be customized
    //		as needed.
    
    return true; // Boolean
  },

  supportsLinkConnectionBox : function()
  {
    // summary:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    // description:
    //		Indicates that this layout class can use a link connection box
    //		interface to calculate the end points of a link. 
    //		The link connection box interface is an object that provides the
    //		rectangle to which the links are connected for each node and the
    //		tangential shift offset at each side for the connection points.  
    //		<p>
    //		The connection box interface is only used if the link style is
    //		straight line. It is used when the option
    //		"connect links to node centers" (see <code>
    //		BasicLinkStyleLayout.isConnectLinksToNodeCenters()</code>)  is
    //		enabled. It is used for multilink bundles unless the multilink mode
    //		is <code> BasicLinkStyleLayout.NO&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code>. It is used for
    //		self-links if the self-link mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>. In all other
    //		cases, the layout algorithms does not actively place the end points
    //		of links, hence it is not used.   
    //		</p>
    //		<p>
    //		When the connection box interface is used, the layout algorithm
    //		calculates the virtual center of the end nodes of each link by the
    //		link connection box interface and routes the links relative to those
    //		centers.  The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offsets in the horizontal direction, and by the average of
    //		the tangential "left" and "right" offsets in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence, the virtual center is at
    //		<code>connectionBox.center() + (15, 10)</code>.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    
    return true; // Boolean
  },

  supportsPercentageComplete : function()
  {
    // summary:
    //		Indicates that this layout class can estimate the percentage of
    //		completion during the layout run.
    
    return true; // Boolean
  },

  layout : function()
  {
    // summary:
    //		Computes the layout using the Basic Link Style Layout algorithm. 
    // description:
    //		Computes the layout using the Basic Link Style Layout algorithm. 
    //		To start the layout, call the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.performLayout()</code>. Subclasses
    //		should not override this method but should override <code>
    //		BasicLinkStyleLayout.internalLayout()</code> instead.   
    // tags:
    //		protected
    
    var percentages = this.getPercentagesOfCompletion();
    var layoutReport = this.getLayoutReport();

    this._multiLinks = new Array();
    this._selfLinks = new Array();
    var listOfMultiLinkBundles = new Array();
    var listOfSimpleSelfLinks = new Array();
    var listOfMultiSelfLinkBundles = new Array();
    var mutil = new ibm_ilog.graphlayout.internalutil.MultiAndSelfLinkUtil(this);
    mutil.setMultiLinkOffset(this.getMultiLinkOffset());
    mutil.setMultiLinkMaxSpread(this.getMultiLinkMaxSpread());
    mutil.setConnectToCenter(this.isConnectLinksToNodeCenters());
    mutil.setSelfLinkSpacing(this.getSelfLinkSpacing());
    mutil.setSelfLinkOffset(this.getMultiSelfLinkOffset());
    mutil.setSelfLinkMaxSpread(this.getMultiSelfLinkMaxSpread());
    mutil.setAllowedSelfLinkCorners(this.translateAllowedCorners(this.getSelfLinkAllowedCorners()));
    mutil.setSelfLinkAttachXPosition(this._selfLinkRelativeAttachPosition.x, this._selfLinkAbsoluteAttachPosition.x);
    mutil.setSelfLinkAttachYPosition(this._selfLinkRelativeAttachPosition.y, this._selfLinkAbsoluteAttachPosition.y);

    if (this.getLinkStyle() != ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NO_RESHAPE_STYLE)
    {
      if (this.getMultiLinkMode() != ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NO_BUNDLE) {
        mutil.collectMultilinks(listOfMultiLinkBundles, this._multiLinks, true, false);
      }
      if (this.getSelfLinkMode() != ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NO_BENDS) {
        mutil.collectSelflinks(listOfSimpleSelfLinks, listOfMultiSelfLinkBundles, this._selfLinks);
      }
    }

    this.increasePercentageComplete(percentages[0]);
    this.callLayoutStepPerformedIfNeeded();

    if (this.isInterrupted())
    {
      this.cleanupOnInterrupt();
      return;
    }

    this.internalLayout();
    this.increasePercentageComplete(percentages[1]);
    this.callLayoutStepPerformedIfNeeded();

    if (this.isInterrupted())
    {
      this.cleanupOnInterrupt();
      return;
    }

    if (this.getLinkStyle() != ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NO_RESHAPE_STYLE)
    {
      if (this.isConnectLinksToNodeCenters())
      {
        this.connectAllLinksToCenter();
      }
    }

    if (this.isInterrupted())
    {
      this.cleanupOnInterrupt();
      return;
    }

    var redraw = false;
    if (listOfMultiLinkBundles.length > 0)
    {
      switch (this.getMultiLinkMode())
      {
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.STRAIGHT_LINE_BUNDLE:
          mutil.shiftMultilinks(listOfMultiLinkBundles, false, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE:
          mutil.shiftMultilinks(listOfMultiLinkBundles, true, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CONNECTED_ONE_BEND_BUNDLE:
          mutil.addBendToMultilinks(listOfMultiLinkBundles, false, true, true, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.FREE_ONE_BEND_BUNDLE:
          mutil.addBendToMultilinks(listOfMultiLinkBundles, true, false, false, redraw);
          break;
      }
    }

    this.increasePercentageComplete(percentages[2]);
    this.callLayoutStepPerformedIfNeeded();

    if (this.isInterrupted())
    {
      this.cleanupOnInterrupt();
      return;
    }

    var selfLinkConnectToNodeCenter = this.isSelfLinkConnectToNodeCenter();

    if (listOfMultiSelfLinkBundles.length > 0)
    {
      switch (this.getSelfLinkMode())
      {
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CONNECTED_RECTANGULAR:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, false, false, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.FREE_RECTANGULAR:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, false, false, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), false, false, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, true, false, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_FREE_RECTANGULAR:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, true, false, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), false, false, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CONNECTED_SQUARE:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, false, true, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.FREE_SQUARE:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, false, true, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), false, false, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, true, true, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_FREE_SQUARE:
          mutil.addBendToSelfLinkBundles(listOfMultiSelfLinkBundles, true, true, this.getSelfLinkOrientation(), this.getMultiSelfLinkDistribution(), false, false, redraw);
          break;
      }
    }

    if (listOfSimpleSelfLinks.length > 0)
    {
      switch (this.getSelfLinkMode())
      {
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CONNECTED_RECTANGULAR:
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR:
          mutil.addBendToSelfLinks(listOfSimpleSelfLinks, false, this.getSelfLinkOrientation(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.FREE_RECTANGULAR:
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_FREE_RECTANGULAR:
          mutil.addBendToSelfLinks(listOfSimpleSelfLinks, false, this.getSelfLinkOrientation(), false, false, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CONNECTED_SQUARE:
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE:
          mutil.addBendToSelfLinks(listOfSimpleSelfLinks, true, this.getSelfLinkOrientation(), selfLinkConnectToNodeCenter, true, redraw);
          break;
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.FREE_SQUARE:
        case ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_FREE_SQUARE:
          mutil.addBendToSelfLinks(listOfSimpleSelfLinks, true, this.getSelfLinkOrientation(), false, false, redraw);
          break;
      }
    }

    this.increasePercentageComplete(percentages[3]);
    this.onLayoutStepPerformed(false, false);

    if (layoutReport.getCode() != ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_VALID && layoutReport.getCode() != ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_INVALID) {
      layoutReport.setCode(ibm_ilog.graphlayout.GraphLayoutReport.LAYOUT_DONE);
    }
    this._multiLinks = null;
    this._selfLinks = null;
  },

  internalLayout : function()
  {
    // summary:
    //		Called from ' BasicLinkStyleLayout.layout()' to place the
    //		nodes. 
    // description:
    //		Called from <code> BasicLinkStyleLayout.layout()</code> to place the
    //		nodes. 
    //		This layout does not place any nodes, but subclasses of this layout
    //		may place nodes in this method.  
    // tags:
    //		protected
    
    if (!this.isInterrupted() && this.getLinkStyle() == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.STRAIGHT_LINE_STYLE)
    {
      var graphModel = this.getGraphModel();
      ibm_ilog.graphlayout.internalutil.GraphModelUtil.deleteIntermediatePointsOnLinks(graphModel, this);
    }
  },

  getSelfLinksCount : function()
  {
    // summary:
    //		Returns the number of self-links. 
    // description:
    //		Returns the number of self-links. 
    //		Can be used by subclasses inside <code>
    //		BasicLinkStyleLayout.internalLayout()</code> to test how many
    //		self-links have to be treated.   
    // returns:
    //		The number of self-links.
    // tags:
    //		protected
    
    if (this._selfLinks != null) {
      return this._selfLinks.length; // int
    }
    return 0; // int
  },

  getMultiLinksCount : function()
  {
    // summary:
    //		Returns the number of multilinks. 
    // description:
    //		Returns the number of multilinks. 
    //		Can be used by subclasses inside <code>
    //		BasicLinkStyleLayout.internalLayout()</code> to test how many
    //		multilinks have to be treated.  
    // returns:
    //		The number of multilinks.
    // tags:
    //		protected
    
    if (this._multiLinks != null) {
      return this._multiLinks.length; // int
    }
    return 0; // int
  },

  isInterrupted : function()
  {
    // summary:
    //		Returns 'true' if the layout is interrupted.  
    // returns:
    //		'true' if the layout is interrupted.
    // tags:
    //		protected
    
    if (this.supportsAllowedTime() && this.isLayoutTimeElapsed()) {
      return true; // Boolean
    }
    if (this.supportsStopImmediately() && this.isStoppedImmediately()) {
      return true; // Boolean
    }
    return false; // Boolean
  },

  cleanupOnInterrupt : function()
  {
    // summary:
    //		Called when stopping the layout before completion. 
    // description:
    //		Called when stopping the layout before completion. 
    //		
    // tags:
    //		private
    
    var layoutReport = this.getLayoutReport();
    layoutReport.setCode(this.getLayoutCodeOnInterrupt());
    this.onLayoutStepPerformed(false, false);
    this._multiLinks = null;
    this._selfLinks = null;
  },

  getLayoutCodeOnInterrupt : function()
  {
    // summary:
    //		Returns the layout code when the allowed time elapsed before
    //		completion of the layout.  
    // returns:
    //		The layout code when the allowed time elapsed before completion
    //		of the layout.
    // tags:
    //		protected
    
    return ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_INVALID; // int
  },

  getPercentagesOfCompletion : function()
  {
    // summary:
    //		Returns an array of 4 integer numbers, denoting the percentage of
    //		completion for each of the 4 steps. 
    // description:
    //		Returns an array of 4 integer numbers, denoting the percentage of
    //		completion for each of the 4 steps. 
    //		The steps are the following: 
    //		<ol>
    //		 
    //		<li> After collecting multilinks and self-links. </li>  
    //		<li> After calling <code>
    //		BasicLinkStyleLayout.internalLayout()</code>. </li>  
    //		<li> After treating all multilinks. </li>  
    //		<li> After treating all self-links. </li> 
    //		</ol>
    //		This method can be overridden by subclasses.   
    // returns:
    //		An array of 4 integer numbers, denoting the percentage of
    //		completion.
    // tags:
    //		protected
    
    return [20, 60, 80, 100 ]; // Array
  },

  increasePercentageComplete : function(newPercentage)
  {
    // summary:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    // description:
    //		Increases the percentage of completion that is stored in the layout
    //		report to the input value. 
    //		Layout algorithms that support the percentage complete feature
    //		should call this method during the running of the layout. This
    //		method does not set the percentage to a lower value than the
    //		previous value. It also does not set the value to more than 100%. It
    //		silently ignores wrong input values.  
    // newPercentage: int
    //		New percentage of completion
    
    if (this.supportsPercentageComplete()) {
      this.inherited("increasePercentageComplete", arguments, [newPercentage]);
    }
  },

  setLinkStyle : function(style)
  {
    // summary:
    //		Sets the style of the shape of the links. 
    // description:
    //		Sets the style of the shape of the links. 
    //		Valid values are <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;STYLE</code> (the links are given
    //		a straight-line shape) and <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code> (no reshape is
    //		performed on the links).  
    //		<p>
    //		This feature can be useful if the graph contains links that have
    //		intermediate points and are not straight-line links, for instance,
    //		<code> ilog.diagrammer.model.DiagrammerLink</code> links with
    //		intermediate points.  
    //		</p>
    //		<p>
    //		The default value is <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;STYLE</code>.    
    //		</p>
    // style: int
    //		The link style value.
    
    if (!(style == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.STRAIGHT_LINE_STYLE || style == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NO_RESHAPE_STYLE))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6090E",  style);
    }

    if (style != this._linkStyle)
    {
      this._linkStyle = style;
      this.onParameterChanged("LinkStyle");
    }
  },

  getLinkStyle : function()
  {
    // summary:
    //		Returns the current option for the style of the shape of the links.
    
    return (false ? ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultLinkStyle : this._linkStyle); // int
  },

  setConnectLinksToNodeCenters : function(enable)
  {
    // summary:
    //		Sets whether the algorithm connects the links to the centers of the
    //		nodes. 
    // description:
    //		Sets whether the algorithm connects the links to the centers of the
    //		nodes. 
    //		This option has only an effect if the link style is not  <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code>.  If the argument is
    //		<code>true</code>, the links are connected to the center of the
    //		nodes.  If a link connection box is set, it uses the virtual center
    //		of the connection box instead of the center of the bounding boxes of
    //		the end nodes. The virtual center is defined as the center of the
    //		connection box shifted by the average of the tangential "top" and
    //		"bottom" offset in the horizontal direction and by the average of
    //		the tangential "left" and "right" offset in the vertical direction.
    //		For instance, if the tangential offset is 20 at the top side and 10
    //		at all other sides, the average shift offset is <code>(20 + 10)/2 =
    //		15</code> in the horizontal direction and <code>(10 + 10)/2 =
    //		10</code> in the vertical direction; hence the virtual center is at
    //		<code>connectionBox.center()&#160;+&#160;(15,&#160;10)</code>.  
    //		<p>
    //		 
    //		</p>
    //		<p>
    //		The default value is <code>true</code>.  
    //		</p>
    
    if (enable != this._connectLinksToNodeCenters)
    {
      this._connectLinksToNodeCenters = enable;
      this.onParameterChanged("ConnectLinksToNodeCenters");
    }
  },

  isConnectLinksToNodeCenters : function()
  {
    // summary:
    //		Returns 'true' if the algorithm connects the links to the
    //		centers of the nodes.
    
    return (false ? ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultConnectLinksToNodeCenters : this._connectLinksToNodeCenters); // Boolean
  },

  setMultiLinkMode : function(mode)
  {
    // summary:
    //		Sets the mode how multiple links between the same pair of nodes are
    //		laid out. 
    // description:
    //		Sets the mode how multiple links between the same pair of nodes are
    //		laid out. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.NO&#95;BUNDLE</code> - no bundling.
    //		Multiple links between the same pair of nodes are not spread out and
    //		will overlap. </li>  
    //		<li> <code> BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;BUNDLE</code> -
    //		straight line bundling. Multiple links between the same pair of
    //		nodes are routed as straight lines but shifted relative to each
    //		other to avoid overlaps. Different to the narrow mode, the shift
    //		offset is not limited by the node size. </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>
    //		- narrow straight line bundling (the default). Multiple links
    //		between the same pair of nodes are routed as straight lines but
    //		shifted relative to each other to avoid overlaps. The bundle may
    //		appear more narrow since the shift offset is limited by the size of
    //		the end nodes. </li>  
    //		<li> <code> BasicLinkStyleLayout.CONNECTED&#95;ONE&#95;BEND&#95;BUNDLE</code> -
    //		one bend polyline bundling with connection. Multiple links between
    //		the same pair of nodes are routed with one bend to avoid overlaps. 
    //		All links of the bundle are connected to the node and start at the
    //		same point and end at the same point. </li>  
    //		<li> <code> BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code> - one
    //		bend polyline bundling without enforced connection. Multiple links
    //		between the same pair of nodes are routed with one bend to avoid
    //		overlaps.  The link connection point is not enforced, that is, the
    //		node and link are free to decide themselves where to place the
    //		connection point. There is no guarantee that all links of the bundle
    //		start or end at a common point.  </li>  
    //		</ul>
    //		This feature is only useful if the graph contains pairs of nodes
    //		that have multiple links in between. If has only an effect when the
    //		link style is not <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code>.   
    // mode: int
    //		The multilink mode value.
    
    if (!((mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NO_BUNDLE) || (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.STRAIGHT_LINE_BUNDLE) ||
        (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE) || (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CONNECTED_ONE_BEND_BUNDLE) ||
        (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.FREE_ONE_BEND_BUNDLE)))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6090E",  mode);
    }

    if (mode != this._multiLinkMode)
    {
      this._multiLinkMode = mode;
      this.onParameterChanged("MultiLinkMode");
    }
  },

  getMultiLinkMode : function()
  {
    // summary:
    //		Returns the current option for the mode how multiple links between
    //		the same pair of nodes are laid out.
    
    return (false ? ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiLinkMode : this._multiLinkMode); // int
  },

  setMultiLinkOffset : function(offset)
  {
    // summary:
    //		Sets the offset between multiple links between the same pair of
    //		nodes. 
    // description:
    //		Sets the offset between multiple links between the same pair of
    //		nodes. 
    //		If the multilink mode is <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, it is the
    //		offset between the  the multiple straight line links. If the
    //		multilink mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;ONE&#95;BEND&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code>, it is the offset
    //		between the bends that are added to the multiple links to avoid that
    //		those links overlap. If the multilink mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BUNDLE</code>, the offset has no effect.  
    //		<p>
    //		The straight links, or the multilink bends, respectively, are
    //		shifted relative to each other by the multilink offset unless the
    //		number of links times the offset exceeds the max spread value. In
    //		that case, the offset is limited by the max spread value. If the
    //		multilink mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, the offset
    //		is further limited by the node size.  
    //		</p>
    //		<p>
    //		This offset affects only links that are no self-links. See <code>
    //		BasicLinkStyleLayout.setMultiSelfLinkOffset()</code> for the same
    //		parameter at self-links.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // offset: Number
    //		The offset value.
    
    if (offset < 0.0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6091E",  offset);
    }

    if (offset != this._multiLinkOffset)
    {
      this._multiLinkOffset = offset;
      this.onParameterChanged("MultiLinkOffset");
    }
  },

  getMultiLinkOffset : function()
  {
    // summary:
    //		Returns the offset between multiple links between the same pair of
    //		nodes.
    
    if (false) {
      return ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiLinkOffset; // Number
    }
    return this._multiLinkOffset; // Number
  },

  setMultiLinkMaxSpread : function(maxSpread)
  {
    // summary:
    //		Sets the maximum spread width between multiple links between the
    //		same pair of nodes. 
    // description:
    //		Sets the maximum spread width between multiple links between the
    //		same pair of nodes. 
    //		<p>
    //		If the multilink mode is <code>
    //		BasicLinkStyleLayout.STRAIGHT&#95;LINE&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, the
    //		multiple straight line links are shifted relative to each other to
    //		avoid overlaps. If the multilink mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;ONE&#95;BEND&#95;BUNDLE</code> or <code>
    //		BasicLinkStyleLayout.FREE&#95;ONE&#95;BEND&#95;BUNDLE</code>, bends are added to
    //		the multiple links to avoid that those links overlap. The straight
    //		links, or the multilink bends, respectively, are shifted relative to
    //		each other by the multilink offset unless the number of links times
    //		the offset exceeds the max spread value. In that case, the offset is
    //		limited by the max spread value. If the multilink mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;STRAIGHT&#95;LINE&#95;BUNDLE</code>, the offset
    //		is further limited by the node size. If the multilink mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BUNDLE</code>, the maximum spread width has
    //		no effect.  
    //		</p>
    //		<p>
    //		This maximum spread width affects only links that are no self-links.
    //		See <code> BasicLinkStyleLayout.setMultiSelfLinkMaxSpread()</code>
    //		for the same parameter at self-links.  
    //		</p>
    //		<p>
    //		The default maximum spread value is <code>50</code>.  
    //		</p>
    // maxSpread: Number
    //		The maximum spread value.
    
    if (maxSpread < 0.0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6091E",  maxSpread);
    }

    if (maxSpread != this._multiLinkMaxSpread)
    {
      this._multiLinkMaxSpread = maxSpread;
      this.onParameterChanged("MultiLinkMaxSpread");
    }
  },

  getMultiLinkMaxSpread : function()
  {
    // summary:
    //		Returns the maximum spread width between multiple links between the
    //		same pair of nodes.
    
    if (false) {
      return ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiLinkMaxSpread; // Number
    }
    return this._multiLinkMaxSpread; // Number
  },

  setSelfLinkMode : function(mode)
  {
    // summary:
    //		Sets the mode how self-links (that is, links that start and end at
    //		the same node) are laid out. 
    // description:
    //		Sets the mode how self-links (that is, links that start and end at
    //		the same node) are laid out. 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.NO&#95;BENDS</code> - no reshape.
    //		Self-links are not reshaped with bends and may not be visible after
    //		layout. </li>  
    //		<li> <code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code> - 
    //		rectangular self-links with 3 bends and connection. Self-links are
    //		reshaped with 3 bends placed in orthogonal style so that the link
    //		segments approximately resemble three quarters of a rectangle (the
    //		fourth quarter being the node where the self-link is attached).  The
    //		connection points are placed on the border of the node. </li>  
    //		<li> <code> BasicLinkStyleLayout.FREE&#95;RECTANGULAR</code> -
    //		rectangular self-links with 3 bends without enforced connection.
    //		Self-links are reshaped with 3 bends placed at the same position 
    //		like <code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>.
    //		However, the link connection points are not enforced, that is, the
    //		nodes and links are free to decide themselves where to place the
    //		connection point. Since the connection point is not enforced, the
    //		link segments in free rectangular mode may not be orthogonal.  </li>
    //		 
    //		<li> <code> BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code> - square
    //		self-links with 3 bends and connection. Self-links are reshaped with
    //		3 bends placed in orthogonal style so that the link segments
    //		approximately resemble three quarters of a square (the fourth
    //		quarter being the node where the self-link is attached).  If the
    //		self-link is a spline link, the square shape might be more
    //		appropriate than a rectangular shape since the spline then may
    //		approximately resemble three quarters of a circle.  The connection
    //		points are placed on the border of the node. </li>  
    //		<li> <code> BasicLinkStyleLayout.FREE&#95;SQUARE</code> - square
    //		self-links with 3 bends without enforced connection. Self-links are
    //		reshaped with 3 bends placed at the same position  like <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>. If the self-link is a
    //		spline link, the square shape might be more appropriate than a
    //		rectangular shape since the spline then may approximately resemble
    //		three quarters of a circle.  However, the link connection points are
    //		not enforced, that is, the nodes and links are free to decide
    //		themselves where to place the connection point. Since the connection
    //		point is not enforced, the link segments in free rectangular mode
    //		may not be orthogonal.  </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>
    //		- narrow rectangular self-links with 3 bends and connection
    //		(default). Self-links are reshaped with 3 bends placed in orthogonal
    //		style so that the link segments approximately resemble three
    //		quarters of a rectangle (the fourth quarter being the node where the
    //		self-link is attached).  The connection points are placed on the
    //		border of the node. For single self-links, this mode has the same
    //		effect like <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>. If you have
    //		multiple self-links at the same node, the self-links are shifted by
    //		an offset to avoid overlaps. In this case, this mode differs from
    //		<code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>, as the
    //		self-link bundle may appear more narrow since the shift offset of
    //		the multiple self-links is limited by the size of the end node.
    //		</li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;FREE&#95;RECTANGULAR</code> -
    //		narrow rectangular self-links with 3 bends without enforced
    //		connection. Self-links are reshaped with 3 bends placed at the same
    //		position  like <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>. For single
    //		self-links, this mode has the same effect like <code>
    //		BasicLinkStyleLayout.FREE&#95;RECTANGULAR</code>. If you have multiple
    //		self-links at the same node, the self-links are shifted by an offset
    //		to avoid overlaps. In this case, this mode differs from <code>
    //		BasicLinkStyleLayout.FREE&#95;RECTANGULAR</code>, as the self-link
    //		bundle may appear more narrow since the shift offset of the multiple
    //		self-links is limited by the size of the end node. The link
    //		connection points are not enforced, that is, the nodes and links are
    //		free to decide themselves where to place the connection point. Since
    //		the connection point is not enforced, the link segments in free
    //		rectangular mode may not be orthogonal.  </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code> -
    //		narrow square self-links with 3 bends and connection. Self-links are
    //		reshaped with 3 bends placed in orthogonal style so that the link
    //		segments approximately resemble three quarters of a square (the
    //		fourth quarter being the node where the self-link is attached).  If
    //		the self-link is a spline link, the square shape might be more
    //		appropriate than a rectangular shape since the spline then may
    //		approximately resemble three quarters of a circle.  The connection
    //		points are placed on the border of the node. For single self-links,
    //		this mode has the same effect like <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>. If you have multiple
    //		self-links at the same node, the self-links are shifted by an offset
    //		to avoid overlaps. In this case, this mode differs from <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, as the self-link
    //		bundle may appear more narrow since the shift offset of the multiple
    //		self-links is limited by the size of the end node. </li>  
    //		<li> <code> BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code> - narrow
    //		square self-links with 3 bends without enforced connection.
    //		Self-links are reshaped with 3 bends placed at the same position 
    //		like <code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>. If
    //		the self-link is a spline link, the square shape might be more
    //		appropriate than a rectangular shape since the spline then may
    //		approximately resemble three quarters of a circle.  For single
    //		self-links, this mode has the same effect like <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>. If you have multiple
    //		self-links at the same node, the self-links are shifted by an offset
    //		to avoid overlaps. In this case, this mode differs from <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>, as the self-link bundle may
    //		appear more narrow since the shift offset of the multiple self-links
    //		is limited by the size of the end node. The link connection points
    //		are not enforced, that is, the nodes and links are free to decide
    //		themselves where to place the connection point. Since the connection
    //		point is not enforced, the link segments in free square mode may not
    //		be orthogonal.  </li>  
    //		</ul>
    //		This feature is only useful if the graph contains any self-links. If
    //		has only an effect when the link style is not <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code>.    
    // mode: int
    //		The mode for self-links.
    
    if (!((mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NO_BENDS) || (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CONNECTED_RECTANGULAR) ||
        (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.FREE_RECTANGULAR) || (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR) ||
        (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_FREE_RECTANGULAR) || (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CONNECTED_SQUARE) ||
        (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.FREE_SQUARE) || (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_CONNECTED_SQUARE) ||
        (mode == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_FREE_SQUARE)))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6090E",  mode);
    }

    if (mode != this._selfLinkMode)
    {
      this._selfLinkMode = mode;
      this.onParameterChanged("SelfLinkMode");
    }
  },

  getSelfLinkMode : function()
  {
    // summary:
    //		Returns the current option for the mode how self-links (that is,
    //		links that start and end at the same node) are laid out.
    
    return (false ? ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkMode : this._selfLinkMode); // int
  },

  setSelfLinkOrientation : function(orientation)
  {
    // summary:
    //		Sets the orientation of self-links (that is, links that start and
    //		end at the same node). 
    // description:
    //		Sets the orientation of self-links (that is, links that start and
    //		end at the same node). 
    //		Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.CLOCK&#95;WISE</code> - clockwise
    //		(default). </li>  
    //		<li> <code> BasicLinkStyleLayout.COUNTER&#95;CLOCK&#95;WISE</code> -
    //		counterclockwise. </li>  
    //		<li> <code> BasicLinkStyleLayout.HORIZONTAL&#95;TO&#95;VERTICAL</code> -
    //		horizontal to vertical. Self-links start at the left or right side
    //		of the node with a horizontal segment and end at the top or bottom
    //		side of the node with a vertical segment. </li>  
    //		<li> <code> BasicLinkStyleLayout.VERTICAL&#95;TO&#95;HORIZONTAL</code> -
    //		vertical to horizontal. Self-links start at the top or bottom side
    //		of the node with a vertical segment and end at the left or right
    //		side of the node with a horizontal segment. </li>  
    //		</ul>
    //		This feature is only useful if the graph contains any self-links. If
    //		has only an effect when the link style is not <code>
    //		BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code> and the self-link mode
    //		is not <code> BasicLinkStyleLayout.NO&#95;BENDS</code>.   
    // orientation: int
    //		The orientation mode for self-links.
    
    if (!((orientation == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CLOCK_WISE) || (orientation == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.COUNTER_CLOCK_WISE) ||
        (orientation == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.HORIZONTAL_TO_VERTICAL) || (orientation == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.VERTICAL_TO_HORIZONTAL)))
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6090E",  orientation);
    }

    if (orientation != this._selfLinkOrientation)
    {
      this._selfLinkOrientation = orientation;
      this.onParameterChanged("SelfLinkOrientation");
    }
  },

  getSelfLinkOrientation : function()
  {
    // summary:
    //		Returns the current option for the orientation of self-links (that
    //		is, links that start and end at the same node).
    
    return (false ? ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkOrientation : this._selfLinkOrientation); // int
  },

  setSelfLinkAllowedCorners : function(corners)
  {
    // summary:
    //		Sets which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    // description:
    //		Sets which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    //		The default value is <code> BasicLinkStyleLayout.ALL&#95;CORNERS</code>,
    //		that is, a combination of all the possible values:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.TOP&#95;LEFT</code>: top left
    //		corner.</li>   
    //		<li> <code> BasicLinkStyleLayout.TOP&#95;RIGHT</code>: top right
    //		corner.</li>  
    //		<li> <code> BasicLinkStyleLayout.BOTTOM&#95;RIGHT</code>: bottom right
    //		corner.</li>   
    //		<li> <code> BasicLinkStyleLayout.BOTTOM&#95;LEFT</code>: bottom left
    //		corner.</li>  
    //		</ul>      
    // corners: int
    //		A bitwise-Or combination of the following values:
    //		BasicLinkStyleLayout.TOP_LEFT: top left corner;
    //		BasicLinkStyleLayout.TOP_RIGHT: top right corner;
    //		BasicLinkStyleLayout.BOTTOM_RIGHT: bottom right corner; 
    //		BasicLinkStyleLayout.BOTTOM_LEFT: bottom left corner; or the value 
    //		BasicLinkStyleLayout.ALL_CORNERS.
    
    if ((corners & ~ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.ALL_CORNERS) != 0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6090E",  corners);
    }

    if (corners != this._selfLinkAllowedCorners)
    {
      this._selfLinkAllowedCorners = corners;
      this.onParameterChanged("SelfLinkAllowedCorners");
    }
  },

  getSelfLinkAllowedCorners : function()
  {
    // summary:
    //		Returns which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    // description:
    //		Returns which corners are allowed to have self-links (that is, links
    //		that start and end at the same node). 
    //		The default value is all the corners, that is, a combination of all
    //		the possible values.   
    // returns:
    //		A bitwise-Or combination of the following values: 
    //		<ul>
    //		<li> ' BasicLinkStyleLayout.TOP_LEFT': top left corner. 
    //		<li> ' BasicLinkStyleLayout.TOP_RIGHT': top right corner.
    //		
    //		<li> ' BasicLinkStyleLayout.BOTTOM_RIGHT': bottom right
    //		corner. 
    //		<li> ' BasicLinkStyleLayout.BOTTOM_LEFT': bottom left
    //		corner. 
    //		</ul>
    //		or the value ' BasicLinkStyleLayout.ALL_CORNERS'.
    
    return (false ? ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkAllowedCorners : this._selfLinkAllowedCorners); // int
  },

  translateAllowedCorners : function(mask)
  {
    // summary:
    //		MultiAndSelfLinkUtil has a different coding for the corners. 
    // description:
    //		MultiAndSelfLinkUtil has a different coding for the corners. 
    //		Hence this method translates into that coding.
    // tags:
    //		private
    
    var result = 0;
    if ((mask & ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.TOP_LEFT) != 0) {
      result |= 0x08;
    }
    if ((mask & ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.TOP_RIGHT) != 0) {
      result |= 0x04;
    }
    if ((mask & ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.BOTTOM_RIGHT) != 0) {
      result |= 0x02;
    }
    if ((mask & ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.BOTTOM_LEFT) != 0) {
      result |= 0x01;
    }
    return result; // int
  },

  setSelfLinkSpacing : function(spacing)
  {
    // summary:
    //		Sets the minimal spacing between node border and self-links (that
    //		is, links that start and end at the same node). 
    // description:
    //		Sets the minimal spacing between node border and self-links (that
    //		is, links that start and end at the same node). 
    //		If the self-link mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, the offset has no effect.  
    //		<p>
    //		If the spacing is negative, the spacing is calculated automatically.
    //		This is in particular useful for the self-link modes <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code> and <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>  in combination
    //		with spline links, to form approximate circle shapes for the
    //		self-links.  
    //		</p>
    //		<p>
    //		The default value is <code>5</code>.  
    //		</p>
    // spacing: Number
    //		The spacing value.
    
    if (spacing != this._selfLinkSpacing)
    {
      this._selfLinkSpacing = spacing;
      this.onParameterChanged("SelfLinkSpacing");
    }
  },

  getSelfLinkSpacing : function()
  {
    // summary:
    //		Returns the minimal spacing between node border and the self-links
    //		(that is, links that start and end at the same node).
    
    if (false) {
      return ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkSpacing; // Number
    }
    return this._selfLinkSpacing; // Number
  },

  setSelfLinkRelativeAttachPosition : function(position)
  {
    // summary:
    //		Sets the relative attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    // description:
    //		Sets the relative attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    //		The x value of the position specifies a point at the top or bottom
    //		border of the node, and the y value of the position specifies a
    //		point at the left or right border of the node. The relative attach
    //		position is expressed as a fraction of the width and height of the
    //		node bounding box. Self-links occur at a corner of the node, and the
    //		relative position is specified with respect to this corner. For
    //		instance, the attach position <code>(0.5, 0.1)</code> specifies the
    //		middle of the top or bottom side and a point that is one tenth of
    //		the node height away from the corner of the self-link at the left or
    //		right side.   If the self-link occurs at the bottom right corner, it
    //		goes from the middle of the bottom side, to a point at the right
    //		side that is 10% away from that corner. The attach position
    //		<code>(0.0, 0.0)</code> specifies exactly the corresponding corner.
    //		The attach position <code>(1.0, 1.0)</code> specified the, in each
    //		direction, opposite corners, that is, if the self-link occurs at the
    //		bottom right corner, it goes from the bottom left corner to the top
    //		right corner. Such extreme values are perhaps not useful; they are
    //		mentioned only to illustrate the meaning of the relative position.
    //		The coordinate range for useful values is approximately between 0.1 
    //		and 0.5 for the relative position.  
    //		<p>
    //		If the self-link mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, then the attach
    //		position is only respected at one side and calculate on the other
    //		side to form a square.  
    //		</p>
    //		<p>
    //		The real attach position is the sum of the relative attach position
    //		and the absolute attach position.  
    //		</p>
    //		<p>
    //		The default value of the relative attach position is <code>(0.5,
    //		0.5)</code>.  
    //		</p>
    // position: Point
    //		The relative attach position for self-links.
    
    if (position == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6092E");
    }

    if (!ibm_ilog.graphlayout.internalutil.TranslateUtil.pointEquals(position, this._selfLinkRelativeAttachPosition))
    {
      this._selfLinkRelativeAttachPosition = new ibm_ilog.graphlayout.internalutil.Point(position .x, position .y);

      this.onParameterChanged("SelfLinkRelativeAttachPosition");
    }
  },

  getSelfLinkRelativeAttachPosition : function()
  {
    // summary:
    //		Returns the relative attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    // description:
    //		Returns the relative attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    //		The relative attach position is expressed as a fraction of the width
    //		and height of the node bounding box. Self-links occur at a corner of
    //		the node, and the relative position is specified with respect to
    //		this corner.
    
    var point = (false ? ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkRelativeAttachPosition : this._selfLinkRelativeAttachPosition);
    return new ibm_ilog.graphlayout.internalutil.Point(point .x, point .y); // Point
  },

  setSelfLinkAbsoluteAttachPosition : function(position)
  {
    // summary:
    //		Sets the absolute attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    // description:
    //		Sets the absolute attach position at the node border for self-links
    //		(that is, links that start and end at the same node). 
    //		The x value of the position specifies a point at the top or bottom
    //		border of the node, and the y value of the position specifies a
    //		point at the left or right border of the node. The absolute attach
    //		position is expressed as absolute coordinate units. Self-links occur
    //		at a corner of the node, and the relative position is specified with
    //		respect to this corner. For instance, if the self-link occurs at the
    //		bottom right corner, the attach position <code>(10, 20)</code>
    //		specifies that the self-link goes from 10 units away from the corner
    //		at the bottom side (that is, <code>x = node.x + node.width -
    //		10</code>) to 20 units away from the corner at the right side (that
    //		is, <code>y = node.y + node.height - 20</code>).  
    //		<p>
    //		If the self-link mode is <code>
    //		BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.FREE&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, then the attach
    //		position is only respected at one side and calculate on the other
    //		side to form a square.  
    //		</p>
    //		<p>
    //		The real attach position is the sum of the relative attach position 
    //		
    //		</p>
    //		<p>
    //		The real attach position is the sum of the relative attach position
    //		and the absolute attach position.  
    //		</p>
    //		<p>
    //		The default value of the absolute attach position is <code>(0,
    //		0)</code>.  
    //		</p>
    // position: Point
    //		The absolute attach position for self-links.
    
    if (position == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6092E");
    }

    if (!ibm_ilog.graphlayout.internalutil.TranslateUtil.pointEquals(position, this._selfLinkAbsoluteAttachPosition))
    {
      this._selfLinkAbsoluteAttachPosition = new ibm_ilog.graphlayout.internalutil.Point(position .x, position .y);

      this.onParameterChanged("SelfLinkAbsoluteAttachPosition");
    }
  },

  getSelfLinkAbsoluteAttachPosition : function()
  {
    // summary:
    //		Returns the absolute attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    // description:
    //		Returns the absolute attach position at the node border for
    //		self-links (that is, links that start and end at the same node). 
    //		The absolute attach position is expressed as absolute coordinate
    //		units.
    
    var point = (false ? ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkAbsoluteAttachPosition : this._selfLinkAbsoluteAttachPosition);
    return new ibm_ilog.graphlayout.internalutil.Point(point .x, point .y); // Point
  },

  setSelfLinkConnectToNodeCenter : function(enable)
  {
    // summary:
    //		Sets whether self-links (that is, links that start and end at the
    //		same node) connect towards the node center. 
    // description:
    //		Sets whether self-links (that is, links that start and end at the
    //		same node) connect towards the node center. 
    //		This is disabled by default. It has only an effect for the self-link
    //		modes <code> BasicLinkStyleLayout.CONNECTED&#95;RECTANGULAR</code>,
    //		<code> BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>,
    //		<code> BasicLinkStyleLayout.CONNECTED&#95;SQUARE</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>. If disabled,
    //		the self-link segments incident to the node border are orthogonal to
    //		the node border. If enabled, the self-link segments are rotated to
    //		point towards the node center.  
    // enable: Boolean
    //		Whether the option is enabled.
    
    if (enable != this._selfLinkConnectToNodeCenter)
    {
      this._selfLinkConnectToNodeCenter = enable;
      this.onParameterChanged("SelfLinkConnectToNodeCenter");
    }
  },

  isSelfLinkConnectToNodeCenter : function()
  {
    // summary:
    //		Returns whether self-links  (that is, links that start and end at
    //		the same node) connect towards the node center.
    
    if (false) {
      return ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultSelfLinkConnectToNodeCenter; // Boolean
    }
    return this._selfLinkConnectToNodeCenter; // Boolean
  },

  setMultiSelfLinkDistribution : function(distribution)
  {
    // summary:
    //		Sets the distribution of bundles of multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    // description:
    //		Sets the distribution of bundles of multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    //		Self-link bundles form essentially nested rectangles or circles.
    //		There is a reference point at the node border and this reference
    //		point is either in the middle of the bundle, or at the outermost
    //		circle or at the innermost cicle. Valid values are:  
    //		<ul>
    //		<li> <code> BasicLinkStyleLayout.CENTERED</code> - centered
    //		(default). The middle of a bundle of multiple self-links  is
    //		attached at the reference points for self-links. The nested circles
    //		are equally spread out towards the inner nesting and towards the
    //		outer nesting. </li>  
    //		<li> <code> BasicLinkStyleLayout.OUTER</code> - towards outer
    //		nestings. The innermost self-link of a bundle of multiple self-links
    //		 is attached at the reference points for self-links and the
    //		remaining self-links are distributed towards the outer of the
    //		nestings. </li>  
    //		<li> <code> BasicLinkStyleLayout.INNER</code> - towards inner
    //		nestings. The outermost self-link of a bundle of multiple self-links
    //		 is attached at the reference points for self-links and the
    //		remaining self-links are distributed towards the inner of the
    //		nestings. </li>  
    //		</ul>
    //		This feature is only useful if the graph contains bundles of
    //		multiple self-links. If has only an effect when the link style is
    //		not <code> BasicLinkStyleLayout.NO&#95;RESHAPE&#95;STYLE</code> and the
    //		self-link mode is not <code> BasicLinkStyleLayout.NO&#95;BENDS</code>.  
    //		
    // distribution: int
    //		The distribution mode for multiple self-links.
    
    if (
      !
        ((distribution == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CENTERED) || (distribution == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.OUTER) ||
            (distribution == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.INNER)))
      {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6090E",  distribution);
      }

    if (distribution != this._multiSelfLinkDistribution)
    {
      this._multiSelfLinkDistribution = distribution;
      this.onParameterChanged("MultiSelfLinkDistribution");
    }
  },

  getMultiSelfLinkDistribution : function()
  {
    // summary:
    //		Returns the current option for the distribution of bundles of
    //		multiple self-links (that is, multiple links that start and end at
    //		the same node).
    
    return (false ? ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiSelfLinkDistribution : this._multiSelfLinkDistribution); // int
  },

  setMultiSelfLinkOffset : function(offset)
  {
    // summary:
    //		Sets the offset between multiple self-links (that is, multiple links
    //		that start and end at the same node). 
    // description:
    //		Sets the offset between multiple self-links (that is, multiple links
    //		that start and end at the same node). 
    //		<p>
    //		If the self-link mode is not <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, bends are added to self-links.
    //		If there are multiple self-links at the same node, the bends are
    //		shifted relative to each other by the multiple self-link offset
    //		unless the number of self-links times the offset exceeds the
    //		multiple self-link max spread value. In that case, the offset is
    //		limited by the max spread value. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;RECTANGULAR</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, the offset is
    //		further limited by the node size. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, the offset  has no effect.  
    //		</p>
    //		<p>
    //		This offset affects only self-links, no other multilinks. See <code>
    //		BasicLinkStyleLayout.setMultiLinkOffset()</code> for the same
    //		parameter at other multilinks.  
    //		</p>
    //		<p>
    //		The default value is <code>10</code>.  
    //		</p>
    // offset: Number
    //		The offset value.
    
    if (offset < 0.0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6091E",  offset);
    }

    if (offset != this._multiSelfLinkOffset)
    {
      this._multiSelfLinkOffset = offset;
      this.onParameterChanged("MultiSelfLinkOffset");
    }
  },

  getMultiSelfLinkOffset : function()
  {
    // summary:
    //		Returns the offset between multiple self-links (that is, multiple
    //		links that start and end at the same node).
    
    if (false) {
      return ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiSelfLinkOffset; // Number
    }
    return this._multiSelfLinkOffset; // Number
  },

  setMultiSelfLinkMaxSpread : function(maxSpread)
  {
    // summary:
    //		Sets the maximum spread width between multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    // description:
    //		Sets the maximum spread width between multiple self-links (that is,
    //		multiple links that start and end at the same node). 
    //		<p>
    //		If the self-link mode is not <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, bends are added to self-links.
    //		If there are multiple self-links at the same node, the bends are
    //		shifted relative to each other by the multiple self-link offset
    //		unless the number of self-links times the offset exceeds the max
    //		spread value. In that case, the offset is limited by the max spread
    //		value. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;RECTANGULAR</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;CONNECTED&#95;SQUARE</code>, <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;RECTANGULAR</code>, or <code>
    //		BasicLinkStyleLayout.NARROW&#95;FREE&#95;SQUARE</code>, the offset is
    //		further limited by the node size. If the self-link mode is <code>
    //		BasicLinkStyleLayout.NO&#95;BENDS</code>, the maximum spread width has
    //		no effect.  
    //		</p>
    //		<p>
    //		This maximum spread width affects only self-links, no other
    //		multilinks. See <code>
    //		BasicLinkStyleLayout.setMultiLinkMaxSpread()</code> for the same
    //		parameter at other multilinks.  
    //		</p>
    //		<p>
    //		The default maximum spread value is <code>50</code>.  
    //		</p>
    // maxSpread: Number
    //		The maximum spread value.
    
    if (maxSpread < 0.0)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6091E",  maxSpread);
    }

    if (maxSpread != this._multiSelfLinkMaxSpread)
    {
      this._multiSelfLinkMaxSpread = maxSpread;
      this.onParameterChanged("MultiSelfLinkMaxSpread");
    }
  },

  getMultiSelfLinkMaxSpread : function()
  {
    // summary:
    //		Returns the maximum spread width between multiple self-links (that
    //		is, multiple links that start and end at the same node).
    
    if (false) {
      return ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._defaultMultiSelfLinkMaxSpread; // Number
    }
    return this._multiSelfLinkMaxSpread; // Number
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.basic.BasicLinkStyleLayout,
{
  // summary:
  //		Returns a new instance of '
  //		BasicLinkStyleLayoutNodeProperty' that stores the parameter
  //		settings of this layout class for nodes. 
  // description:
  //		Returns a new instance of <code>
  //		BasicLinkStyleLayoutNodeProperty</code> that stores the parameter
  //		settings of this layout class for nodes. 
  //		<p>
  //		The method is used by <code>
  //		ibm&#95;ilog.graphlayout.AbstractGraphLayoutModel.saveParametersToNamedProperties()</code>
  //		to create a named property for a node that contains parameter
  //		settings of this layout instance for the input node.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  
  STRAIGHT_LINE_STYLE : null,

  NO_RESHAPE_STYLE : null,

  NO_BUNDLE : null,

  STRAIGHT_LINE_BUNDLE : null,

  NARROW_STRAIGHT_LINE_BUNDLE : null,

  CONNECTED_ONE_BEND_BUNDLE : null,

  FREE_ONE_BEND_BUNDLE : null,

  NO_BENDS : null,

  CONNECTED_RECTANGULAR : null,

  FREE_RECTANGULAR : null,

  CONNECTED_SQUARE : null,

  FREE_SQUARE : null,

  NARROW_CONNECTED_RECTANGULAR : null,

  NARROW_FREE_RECTANGULAR : null,

  NARROW_CONNECTED_SQUARE : null,

  NARROW_FREE_SQUARE : null,

  TOP_LEFT : null,

  BOTTOM_LEFT : null,

  TOP_RIGHT : null,

  BOTTOM_RIGHT : null,

  ALL_CORNERS : null,

  CLOCK_WISE : null,

  COUNTER_CLOCK_WISE : null,

  HORIZONTAL_TO_VERTICAL : null,

  VERTICAL_TO_HORIZONTAL : null,

  CENTERED : null,

  OUTER : null,

  INNER : null,

  _defaultConnectLinksToNodeCenters : null,

  _defaultLinkStyle : null,

  _defaultMultiLinkMode : null,

  _defaultMultiLinkOffset : null,

  _defaultMultiLinkMaxSpread : null,

  _defaultSelfLinkMode : null,

  _defaultSelfLinkOrientation : null,

  _defaultSelfLinkAllowedCorners : null,

  _defaultSelfLinkSpacing : null,

  _defaultSelfLinkRelativeAttachPosition : null,

  _defaultSelfLinkAbsoluteAttachPosition : null,

  _defaultSelfLinkConnectToNodeCenter : null,

  _defaultMultiSelfLinkDistribution : null,

  _defaultMultiSelfLinkOffset : null,

  _defaultMultiSelfLinkMaxSpread : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.basic.BasicLinkStyleLayout;
    if(ibm_ilog.graphlayout.GraphLayout._fields_init)
      ibm_ilog.graphlayout.GraphLayout._fields_init(c);
    
    c.STRAIGHT_LINE_STYLE = ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE;
    c.NO_RESHAPE_STYLE = ibm_ilog.graphlayout.internalutil.LinkStyles.NO_RESHAPE_STYLE;
    c.NO_BUNDLE = ibm_ilog.graphlayout.internalutil.BundlingModes.NO_BUNDLE;
    c.STRAIGHT_LINE_BUNDLE = 
                            ibm_ilog.graphlayout.internalutil.BundlingModes.STRAIGHT_LINE_BUNDLE;
    c.NARROW_STRAIGHT_LINE_BUNDLE = ibm_ilog.graphlayout.internalutil.BundlingModes.NARROW_STRAIGHT_LINE_BUNDLE;
    c.CONNECTED_ONE_BEND_BUNDLE = ibm_ilog.graphlayout.internalutil.BundlingModes.CONNECTED_ONE_BEND_BUNDLE;
    c.FREE_ONE_BEND_BUNDLE = ibm_ilog.graphlayout.internalutil.BundlingModes.FREE_ONE_BEND_BUNDLE;
    c.NO_BENDS = ibm_ilog.graphlayout.internalutil.SelfLinkModes.NO_BENDS;
    c.CONNECTED_RECTANGULAR = ibm_ilog.graphlayout.internalutil.SelfLinkModes.CONNECTED_RECTANGULAR;
    c.FREE_RECTANGULAR = ibm_ilog.graphlayout.internalutil.SelfLinkModes.FREE_RECTANGULAR;
    c.CONNECTED_SQUARE = ibm_ilog.graphlayout.internalutil.SelfLinkModes.CONNECTED_SQUARE;
    c.FREE_SQUARE = ibm_ilog.graphlayout.internalutil.SelfLinkModes.FREE_SQUARE;
    c.NARROW_CONNECTED_RECTANGULAR = ibm_ilog.graphlayout.internalutil.SelfLinkModes.NARROW_CONNECTED_RECTANGULAR;
    c.NARROW_FREE_RECTANGULAR = ibm_ilog.graphlayout.internalutil.SelfLinkModes.NARROW_FREE_RECTANGULAR;
    c.NARROW_CONNECTED_SQUARE = ibm_ilog.graphlayout.internalutil.SelfLinkModes.NARROW_CONNECTED_SQUARE;
    c.NARROW_FREE_SQUARE = ibm_ilog.graphlayout.internalutil.SelfLinkModes.NARROW_FREE_SQUARE;
    c.TOP_LEFT = 0x0001;
    c.BOTTOM_LEFT = 0x0002;
    c.TOP_RIGHT = 0x0004;
    c.BOTTOM_RIGHT = 0x0008;
    c.ALL_CORNERS = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.TOP_LEFT | ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.BOTTOM_LEFT | ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.TOP_RIGHT |
    ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.BOTTOM_RIGHT;
    c.CLOCK_WISE = ibm_ilog.graphlayout.internalutil.SelfLinkOrientations.CLOCK_WISE;
    c.COUNTER_CLOCK_WISE = ibm_ilog.graphlayout.internalutil.SelfLinkOrientations.COUNTER_CLOCK_WISE;
    c.HORIZONTAL_TO_VERTICAL = ibm_ilog.graphlayout.internalutil.SelfLinkOrientations.HORIZONTAL_TO_VERTICAL;
    c.VERTICAL_TO_HORIZONTAL = ibm_ilog.graphlayout.internalutil.SelfLinkOrientations.VERTICAL_TO_HORIZONTAL;
    c.CENTERED = ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions.CENTERED;
    c.OUTER = ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions.OUTER;
    c.INNER = ibm_ilog.graphlayout.internalutil.MultiSelfLinkDistributions.INNER;
    c._defaultConnectLinksToNodeCenters = false;
    c._defaultLinkStyle = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.STRAIGHT_LINE_STYLE;
    c._defaultMultiLinkMode = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE;
    c._defaultMultiLinkOffset = 10;
    c._defaultMultiLinkMaxSpread = 50;
    c._defaultSelfLinkMode = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR;
    c._defaultSelfLinkOrientation = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CLOCK_WISE;
    c._defaultSelfLinkAllowedCorners = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.ALL_CORNERS;
    c._defaultSelfLinkSpacing = 5;
    c._defaultSelfLinkRelativeAttachPosition = new ibm_ilog.graphlayout.internalutil.Point(0.5, 0.5);
    c._defaultSelfLinkAbsoluteAttachPosition = new ibm_ilog.graphlayout.internalutil.Point(0, 0);
    c._defaultSelfLinkConnectToNodeCenter = false;
    c._defaultMultiSelfLinkDistribution = ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CENTERED;
    c._defaultMultiSelfLinkOffset = 10;
    c._defaultMultiSelfLinkMaxSpread = 50;
  }
  
}
);

ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._getGlobalProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'preserveFixedNodes', defaultValue: false },
    { name: 'preserveFixedLinks', defaultValue: false },
    { name: 'linkStyle', defaultValue: ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.STRAIGHT_LINE_STYLE },
    { name: 'connectLinksToNodeCenters', defaultValue: true },
    { name: 'multiLinkMode', defaultValue: ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_STRAIGHT_LINE_BUNDLE },
    { name: 'multiLinkOffset', defaultValue: 10 },
    { name: 'multiLinkMaxSpread', defaultValue: 50 },
    { name: 'selfLinkMode', defaultValue: ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NARROW_CONNECTED_RECTANGULAR },
    { name: 'selfLinkOrientation', defaultValue: ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CLOCK_WISE },
    { name: 'selfLinkAllowedCorners', defaultValue: ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.ALL_CORNERS },
    { name: 'selfLinkSpacing', defaultValue: 5 },
    { name: 'selfLinkConnectToNodeCenter', defaultValue: false },
    { name: 'multiSelfLinkDistribution', defaultValue: ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.CENTERED },
    { name: 'multiSelfLinkOffset', defaultValue: 10 },
    { name: 'multiSelfLinkMaxSpread', defaultValue: 50 }
  ];
  var baseProperties = ibm_ilog.graphlayout.GraphLayout._getGlobalProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._getNodeProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false }
  ];
  var baseProperties = ibm_ilog.graphlayout.GraphLayout._getNodeProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._getLinkProperties = function()
{
  // tags:
  //		private
  var properties = [
    { name: 'fixed', defaultValue: false }
  ];
  var baseProperties = ibm_ilog.graphlayout.GraphLayout._getLinkProperties();
  return baseProperties ? baseProperties.concat(properties) : properties;
};

(function(){ ibm_ilog.graphlayout.basic.BasicLinkStyleLayout._fields_init(); })();

}

if(!dojo._hasResource['ibm_ilog.graphlayout.layer_basiclinkstyle']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['ibm_ilog.graphlayout.layer_basiclinkstyle'] = true;
dojo.provide('ibm_ilog.graphlayout.layer_basiclinkstyle');



// The commented classes are included by the class in the first
// group. I left them just for reference

// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 

}

